Korzystanie z programu Microsoft Query w celu pobierania danych zewnętrznych — informacje

Ten temat zawiera następujące informacje:

Czym jest program Microsoft Query?

Konfigurowanie źródeł danych

Definiowanie kwerendy

Praca z danymi w programie Microsoft Excel

Czym jest program Microsoft Query?

Microsoft Query jest programem służącym do pobierania danych z zewnętrznych źródeł i udostępniania ich w innych programach pakietu Microsoft Office, zwłaszcza w programie Microsoft Excel. Korzystanie z programu Query w celu pobierania danych z baz danych i plików firmy pozwala uniknąć wpisywania danych, które mają zostać poddane analizie w programie Microsoft Excel. Można również automatycznie aktualizować raporty i podsumowania programu Microsoft Excel z poziomu oryginalnej źródłowej bazy danych za każdym razem, gdy baza danych jest aktualizowana.

Typy baz danych, do których możliwy jest dostęp Dane można pobierać z kilku typów baz danych, łącznie z programami Microsoft Access, Microsoft SQL Server i Microsoft SQL Server OLAP Services. Można również pobierać dane z list programu Microsoft Excel i z plików tekstowych. Zapoznaj się z listą typów baz danych, do których można uzyskać dostęp.

W programie Microsoft Excel można także pobierać dane ze stron sieci Web, ale w tym celu nie jest potrzebny program Microsoft Query. Informacje dotyczące pobierania danych ze stron sieci Web można znaleźć w Pomocy programu Microsoft Excel.

Wybieranie danych z bazy danych Dane z bazy danych są pobierane poprzez utworzenie kwerendy, która jest pytaniem o dane znajdujące się w zewnętrznej bazie danych. Jeśli na przykład dane są przechowywane w bazie danych programu Microsoft Access, kwerenda może służyć do wybrania z niej wyników sprzedaży danego produktu w zależności od regionów. Można pobrać część danych, wybierając wyłącznie dane dla produktu i regionu, które mają zostać poddane analizie, i pomijając wszelkie zbędne dane.

Przykład wybierania danych w programie Microsoft Query

Za pomocą programu Query można zaznaczyć żądane kolumny danych i przenieść do programu Microsoft Excel tylko te dane.

Aktualizowanie arkusza w jednej operacji Po umieszczeniu w arkuszu programu Microsoft Excel danych pochodzących z zewnętrznej bazy danych można odświeżyć dane znajdujące się w arkuszu przy każdej ich zmianie bez konieczności ponownego tworzenia raportów i wykresów. Można na przykład tworzyć miesięczne podsumowanie sprzedaży i odświeżać je za każdym razem, gdy nadchodzą nowe dane.

Korzystanie z programu Query w celu pobierania danych Umieszczenie w programie Microsoft Excel zewnętrznych danych za pomocą programu Microsoft Query obejmuje trzy kroki: Najpierw należy skonfigurować źródło danych w celu nawiązania połączenia z bazą danych, następnie wybrać odpowiednie dane za pomocą Kreatora kwerend, a następnie zwrócić dane do programu Microsoft Excel, gdzie można poddać je formatowaniu i podsumowaniu oraz utworzyć na ich podstawie raporty.

Powrót do początku

Konfigurowanie źródeł danych

Co to jest źródło danych? ródło danych jest to zgromadzony zestaw informacji, umożliwiający programom Microsoft Excel i Microsoft Query połączenie się z zewnętrzną bazą danych. W przypadku użycia programu Microsoft Query do skonfigurowania źródła danych, źródłu temu nadaje się nazwę, a następnie podaje się nazwę i lokalizację bazy danych lub serwera, typ bazy danych oraz informacje o logowaniu i haśle. Informacje obejmują także nazwę sterownika ODBC lub sterownika źródła danych, który jest programem ustanawiającym połączenie z danym typem bazy danych. Dla niektórych typów zewnętrznych baz danych (modułów OLAP) w celu pobrania danych wystarczy jedynie skonfigurować źródło danych.

Jak program Microsoft Query korzysta ze źródeł danych Po skonfigurowaniu źródła danych dla określonej bazy danych można go zawsze użyć w celu utworzenia kwerendy mającej wybierać i pobierać dane z bazy danych, bez konieczności ponownego wpisywania informacji o połączeniu. Program Microsoft Query używa danych źródła danych do łączenia się z zewnętrzną bazą danych i do wyświetlenia informacji o dostępnych danych. Po utworzeniu kwerendy i zwróceniu danych do programu Microsoft Excel program Microsoft Query pobiera dane i udostępnia skoroszytowi programu Microsoft Excel zarówno kwerendę, jak i informacje o źródle danych, dzięki czemu można się ponownie połączyć z bazą danych w celu odświeżenia danych.

Diagram ilustrujący używanie źródeł danych przez program Microsoft Query

ródło danych umożliwia programom Microsoft Query i Microsoft Excel połączenie z określoną bazą danych i pobranie danych.

Powrót do początku

Definiowanie kwerendy

Korzystanie z Kreatora kwerend przy tworzeniu większości kwerend Będący częścią programu Microsoft Query Kreator kwerend jest przeznaczony dla użytkowników słabo znających tematykę tworzenia kwerend. Kreator ułatwia wybieranie i zbieranie danych z różnych tabel i pól bazy danych. Po wybraniu danych można także użyć kreatora do filtrowania i sortowania wyników kwerendy. Kreatora kwerend można używać zarówno do tworzenia pełnej kwerendy, jak i do tworzenia kwerendy, w której później zostaną wprowadzone dalsze zmiany bezpośrednio w programie Microsoft Query.

Praca bezpośrednio w programie Microsoft Query w przypadku innych typów kwerend Jeśli użytkownik potrafi tworzyć kwerendy lub jeśli chce utworzyć bardziej zaawansowaną kwerendę, może pracować bezpośrednio w programie Microsoft Query. Można również użyć programu Microsoft Query do wyświetlania i wprowadzania zmian w kwerendach rozpoczętych za pomocą Kreatora kwerend, jak również do tworzenia nowych kwerend bez użycia kreatora.

Programu Microsoft Query należy używać do tworzenia kwerend wykonujących następujące operacje:

  • Wybieranie określonych danych z pola W dużej bazie danych użytkownik może zechcieć wybrać część danych znajdujących się w polu i pominąć pozostałe dane. Jeśli na przykład potrzebne są dane o dwóch produktach, znajdujące się w polu zawierającym informacje o wielu produktach, można użyć kryteriów do wybrania danych dotyczących jedynie wymaganych produktów. Dowiedz się więcej o używaniu kryteriów.
  • Pobieranie danych opartych na innych kryteriach przy każdym wykonywaniu kwerendy Aby utworzyć w programie Microsoft Excel jeden raport lub podsumowanie dla kilku obszarów tego samego zbioru danych zewnętrznych, takich jak oddzielne raporty o sprzedaży dla każdego regionu, można utworzyć kwerendę zwaną kwerendą parametryczną. Po uruchomieniu kwerendy parametrycznej zostanie wyświetlony monit o podanie danych, które będą użyte jako kryteria przy wybieraniu rekordów przez kwerendę. Kwerenda parametryczna może na przykład wyświetlić monit o podanie konkretnego regionu; kwerendy tej można użyć ponownie do tworzenia każdego z regionalnych raportów sprzedaży. Dowiedz się więcej o kwerendach parametrycznych.
  • Łączenie danych na różne sposoby Programu Query można używać do łączenia (sprzęgania) danych znajdujących się w różnych tabelach bazy danych. Jeśli na przykład w jednej tabeli zawarte są dane o sprzedaży produktów, a w innej informacje o klientach, można sprzęgnąć te tabele w taki sposób, aby pokazać, którzy klienci ostatnio nie dokonywali zakupów. Dowiedz się więcej o sprzęganiu tabel.

Tworzenie modułu OLAP na podstawie danych znajdujących się w kwerendzie Analityczne przetwarzanie online (OLAP) jest sposobem porządkowania danych na potrzeby tworzenia kwerend i raportów, stanowiąc alternatywę dla koncepcji przetwarzania transakcyjnego. Dane bazy danych OLAP są uporządkowane hierarchicznie i przechowywane w modułach zamiast w tabelach.

Program Microsoft Query umożliwia tworzenie modułu OLAP na postawie danych znajdujących się w kwerendzie, co przyspiesza i ułatwia tworzenie w programie Microsoft Excel raportów w oparciu o te dane. Aby utworzyć moduł OLAP, należy uruchomić Kreatora modułów OLAP z poziomu Kreatora kwerend lub bezpośrednio w programie Microsoft Query. Dane do programu Microsoft Excel można zwrócić jako raport tabeli przestawnej. Dowiedz się więcej o tworzeniu modułu OLAP na podstawie pobranych danych.

Więcej informacji

Kiedy używać Kreatora kwerend, a kiedy programu Microsoft Query

Powrót do początku

Praca z danymi w programie Microsoft Excel

Po utworzeniu kwerendy za pomocą Kreatora kwerend lub programu Microsoft Query można zwrócić dane do arkusza programu Microsoft Excel. Takie dane stają się zakresem danych zewnętrznych lub raportem tabeli przestawnej, który można formatować, analizować i odświeżać.

Formatowanie i analizowanie danych W programie Microsoft Excel dostępne są znane narzędzia służące do przedstawiania i sumowania danych, takie jak Kreator wykresów lub automatyczne obliczanie sum częściowych. Dane mogą być formatowane i formatowanie to będzie zachowane podczas odświeżania zewnętrznych danych z poziomu źródłowej bazy danych. Jeżeli do zakresu danych zewnętrznych zostaną dodane kolumny formuł, to formuły te będą mogły być automatycznie kopiowane do dowolnych nowych wierszy dodawanych do zakresu podczas odświeżania danych. Zamiast nazw pól można użyć własnych etykiet kolumn, a także dodać automatycznie numery wierszy. Więcej informacji na temat kontrolowania formatowania i układu zakresu danych zewnętrznych można znaleźć w Pomocy programu Microsoft Excel.

Ponowne wykorzystywanie i udostępnianie kwerend Zarówno w Kreatorze kwerend, jak i w programie Microsoft Query można zapisać plik kwerendy dqy, który następnie można modyfikować, wykorzystywać ponownie i udostępniać. Program Microsoft Excel może bezpośrednio otwierać pliki dqy, co pozwala utworzyć dodatkowe zakresy danych zewnętrznych z poziomu tej samej kwerendy.

Aby udostępniać podsumowanie lub raport programu Microsoft Excel oparty na danych zewnętrznych, można przekazać innym użytkownikom skoroszyt zawierający zakres danych zewnętrznych lub można utworzyć szablon raportu. Szablon raportu pozwala zapisać podsumowanie lub raport bez zapisywania danych zewnętrznych, dzięki czemu plik jest mniejszy. Dane zewnętrzne są pobierane podczas otwierania przez użytkownika szablonu raportu. Więcej informacji na temat tworzenia szablonów raportów można znaleźć w Pomocy programu Microsoft Excel.

Odświeżanie danych zewnętrznych Podczas odświeżania danych zewnętrznych zostaje uruchomiona kwerenda pobierająca wszelkie nowe lub zmienione dane, odpowiadające specyfikacji określonej przez użytkownika. Kwerendę można odświeżać zarówno w programie Microsoft Query, jak i Microsoft Excel. Program Microsoft Excel udostępnia wiele opcji odświeżania kwerend, łącznie z odświeżaniem danych przy każdym otwarciu skoroszytu i automatycznym odświeżaniem w określonych interwałach. Podczas odświeżania danych można kontynuować pracę w programie Microsoft Excel, a także sprawdzać stan odświeżania. Więcej informacji o odświeżaniu danych zewnętrznych w programie Microsoft Excel można znaleźć w Pomocy programu Microsoft Excel.

Powrót do początku


Wyświetlanie informacji o programie Microsoft Query

  • W menu Pomoc programu Microsoft Query, kliknij polecenie Microsoft Query — informacje.

    Informacje o programie, łącznie z numerem wersji, zostaną wyświetlone w oknie dialogowym Microsoft Query — informacje.


Korzystanie z klawiszy skrótów w programie Microsoft Query

Co chcesz zrobić?

Przechodzić między okienkami programu Microsoft Query za pomocą klawiszy skrótów

Zaznaczać dane i kryteria za pomocą klawiszy skrótów

Edytować dane i kryteria za pomocą klawiszy skrótów

Użyć klawiszy funkcji w programie Microsoft Query

Użyć klawiszy skrótów w Kreatorze modułów OLAP


Przenoszenie się między okienkami programu Microsoft Query za pomocą klawiszy skrótów

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Poruszanie się w okienku tabeli

Naciśnij | Aby
TAB | Przechodzić między tabelami
STRZAŁKĘ W GÓRĘ lub STRZAŁKĘ W DÓŁ | Przejść do innych nazw pól w tabeli i zaznaczyć je
SHIFT+STRZAŁKĘ W GÓRĘ lub SHIFT+STRZAŁKĘ W DÓŁ | Zaznaczyć ciągły zestaw pól w tabeli lub anulować zaznaczenie

Przechodzenie między kolumnami i wierszami w okienku kryteriów i w okienku danych

Naciśnij | Aby
F5, a następnie wpisz numer rekordu w polu Rekord i naciśnij klawisz ENTER | Przejść do określonego rekordu (wiersza) w okienku danych
TAB, ENTER lub STRZAŁKĘ W PRAWO (w zaznaczonej komórce) | Przejść do następnej kolumny w okienku danych
SHIFT+TAB, SHIFT+ENTER lub STRZAŁKĘ W LEWO (w zaznaczonej komórce) | Przejść się do poprzedniej kolumny w bieżącym wierszu lub do ostatniego pola w poprzednim rekordzie
END | Przejść do ostatniej kolumny w bieżącym wierszu
CTRL+END | Przejść do ostatniej kolumny w ostatnim wierszu
HOME | Przejść do pierwszej kolumny w bieżącym wierszu
CTRL+HOME | Przejść do pierwszej kolumny w pierwszym wierszu
STRZAŁKĘ W DÓŁ | Przejść do bieżącej kolumny w następnym wierszu
CTRL+STRZAŁKĘ W DÓŁ | Przejść do bieżącej kolumny w ostatnim wierszu
STRZAŁKĘ W GÓRĘ | Przejść do bieżącej kolumny w poprzednim wierszu
CTRL+STRZAŁKĘ W GÓRĘ | Przejść do bieżącej kolumny w pierwszym wierszu

Przenoszenie punktu wstawiania w obrębie wartości komórki w okienku danych i w okienku kryteriów

Naciśnij | Aby
F2 | Anulować zaznaczenie i wyświetlić punkt wstawiania w zaznaczonej komórce
STRZAŁKĘ W PRAWO | Przejść o jeden znak w prawo
CTRL+STRZAŁKĘ W PRAWO | Przejść o jedno słowo w prawo
STRZAŁKĘ W LEWO | Przejść o jeden znak w lewo
CTRL+STRZAŁKĘ W LEWO | Przejść o jedno słowo w lewo
END | Przenieść punkt wstawiania na koniec bieżącej linii w wartościach składających się w jednej lub wielu linii
CTRL+END | Przenieść punkt wstawiania na koniec wartości składającej się z wielu linii
HOME | Przenieść punkt wstawiania na początek bieżącej linii w wartościach składających się z jednej lub wielu linii
CTRL+HOME | Przenieść punkt wstawiania na początek wartości składającej się z wielu linii

Przechodzenie między ekranami w okienku danych i w okienku kryteriów

Naciśnij | Aby
PAGE DOWN | Przejść w okienku o jeden ekran w dół
PAGE UP | Przejść w okienku o jeden ekran w górę
CTRL+PAGE DOWN | Przejść w okienku o jeden ekran w prawo
CTRL+PAGE UP | Przejść w okienku o jeden ekran w lewo


Zaznaczanie danych i kryteriów za pomocą klawiszy skrótów

Zaznaczanie wartości w kolumnie

Naciśnij | Aby
F2 | Zaznaczyć bieżącą wartość lub anulować zaznaczenie i wyświetlić punkt wstawiania
TAB, ENTER lub STRZAŁKĘ W PRAWO (w zaznaczonej komórce) | Zaznaczyć wartość w następnej kolumnie
SHIFT+HOME | Zaznaczyć fragment wartości od punktu wstawiania do początku linii
SHIFT+END | Zaznaczyć fragment wartości od punktu wstawiania do końca linii
SHIFT+STRZAŁKĘ W PRAWO | Rozszerzyć lub zmniejszyć zaznaczenie po prawej stronie o jeden znak
CTRL+SHIFT+ STRZAŁKĘ W PRAWO | Rozszerzyć lub zmniejszyć zaznaczenie po prawej stronie o jeden wyraz
SHIFT+ STRZAŁKĘ W LEWO | Rozszerzyć lub zmniejszyć zaznaczenie po lewej stronie o jeden znak
CTRL+SHIFT+ STRZAŁKĘ W LEWO | Rozszerzyć lub zmniejszyć zaznaczenie po lewej stronie o jeden wyraz

Zaznaczanie wiersza

Naciśnij | Aby
SHIFT+SPACJA | Zaznaczyć bieżący wiersz
STRZAŁKĘ W DÓŁ | Zaznaczyć następny wiersz, jeżeli bieżący wiersz jest zaznaczony
STRZAŁKĘ W GÓRĘ | Zaznaczyć poprzedni wiersz, jeżeli bieżący wiersz jest zaznaczony
SHIFT+ STRZAŁKĘ W DÓŁ | Rozszerzyć lub zmniejszyć zaznaczenie w dół o jeden wiersz
SHIFT+STRZAŁKĘ W GÓRĘ | Rozszerzyć lub zmniejszyć zaznaczenie w górę o jeden wiersz
SHIFT+PAGE DOWN | Rozszerzyć zaznaczenie w dół o jeden ekran
SHIFT+PAGE UP | Rozszerzyć zaznaczenie w górę o jeden ekran
CTRL+SHIFT+SPACJA | Zaznaczyć cały zestaw wyników

Zaznaczanie kolumny

Naciśnij | Aby
CTRL+SPACJA | Zaznaczyć bieżącą kolumnę
STRZAŁKĘ W PRAWO | Zaznaczyć kolumnę na prawo od kolumny bieżącej, jeżeli bieżąca kolumna jest zaznaczona
STRZAŁKĘ W LEWO | Zaznaczyć kolumnę na lewo od kolumny bieżącej, jeżeli bieżąca kolumna jest zaznaczona
SHIFT+ STRZAŁKĘ W LEWO | Rozszerzyć lub zmniejszyć zaznaczenie z lewej strony o jedną kolumnę
SHIFT+STRZAŁKĘ W PRAWO | Rozszerzyć lub zmniejszyć zaznaczenie z prawej strony o jedną kolumnę
CTRL+SHIFT+PAGE DOWN | Rozszerzyć zaznaczenie w prawo o jeden ekran
CTRL+SHIFT+PAGE UP | Rozszerzyć zaznaczenie w lewo o jeden ekran


Edytowanie danych i kryteriów za pomocą klawiszy skrótów

Kopiowanie, wycinanie, wklejanie lub usuwanie

Naciśnij | Aby
CTRL+C | Skopiować bieżące zaznaczenie do Schowka
CTRL+V | Wkleić zawartość Schowka w punkcie wstawiania
CTRL+X | Wyciąć bieżące zaznaczenie i skopiować je do Schowka
BACKSPACE | Usunąć bieżące zaznaczenie lub jeden znak na lewo od punktu wstawiania
DELETE | Usunąć bieżące zaznaczenie lub jeden znak na prawo od punktu wstawiania

Powiększenie ułatwiające edycję w okienku danych

Naciśnij | Aby
SHIFT+F2 | Otworzyć okno dialogowe Powiększ pole w celu wygodniejszego wprowadzania danych do małych obszarów w okienku danych


Klawisze funkcji w programie Microsoft Query

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Naciśnij | Aby
F1 | Przełączyć do Pomocy
SHIFT+F1, a następnie ENTER | Uzyskać pomoc dotyczącą zaznaczonego elementu
F2 | Zaznaczyć bieżącą wartość lub usunąć jej zaznaczenie
ALT+SHIFT+F2 lub SHIFT+F12 | Zapisać kwerendę za pomocą polecenia Zapisz
ALT+F2 lub F12 | Zapisać kwerendę za pomocą polecenia Zapisz jako
SHIFT+F2 | Otworzyć okno dialogowe Powiększ pole w celu wygodniejszego wprowadzania danych do małych obszarów w okienku danych
CTRL+F4 | Zamknąć aktywną kwerendę
ALT+F4 | Zamknąć program Microsoft Query
F5, a następnie wpisz numer rekordu w polu Rekord i naciśnij klawisz ENTER | Przejść do określonego rekordu (wiersza) w okienku danych
F6 | Przejść do następnego okienka w oknie programu Query
SHIFT+F6 | Przejść do poprzedniego okienka w oknie programu Query
CTRL+F6 | Przełączyć do następnego otwartego okna programu Query
CTRL+SHIFT+F6 | Przełączyć do poprzedniego otwartego okna programu Query
F9 | Uruchomić otwartą kwerendę


Używanie klawiszy skrótów w Kreatorze modułów OLAP

Należy skorzystać z tych klawiszy, aby wykonać krok 2. w Kreatorze modułów OLAP.

Aby przenieść pole z listy pól źródłowych do pola Wymiary

  1. Naciśnij klawisz TAB, aby zaznaczyć listę Pola źródłowe.
  2. Naciśnij klawisze STRZAŁKA W GÓRĘ lub STRZAŁKA W DÓŁ, aby zaznaczyć pole, które chcesz przenieść.
  3. Naciśnij klawisz TAB, aby zaznaczyć przycisk >, a następnie naciśnij klawisz ENTER.
  4. Powtórz kroki od 1. do 3., aby przenieść inne pola.

Aby przenieść pole na niższy lub wyższy poziom w obrębie wymiaru w polu Wymiary

  1. Naciśnij klawisz TAB, aby zaznaczyć pole Wymiary.
  2. Naciśnij klawisze STRZAŁKA W GÓRĘ lub STRZAŁKA W DÓŁ, aby zaznaczyć pole, które chcesz przenieść.
  3. Naciśnij klawisze CTRL+X.
  4. Naciśnij klawisze STRZAŁKA W GÓRĘ lub STRZAŁKA W DÓŁ, aby zaznaczyć miejsce, w które chcesz przenieść pole.
  5. Naciśnij klawisze CTRL+V.


Instalowanie sterownika ODBC umożliwiającego korzystanie z zewnętrznego źródła danych

Sterowniki ODBC dostarczane przez Microsoft z programem Microsoft Query są instalowane w trakcie instalacji programu Query. Zobacz listę sterowników ODBC instalowanych z programem Query.

Jeśli zewnętrzna baza danych, do której trzeba uzyskać dostęp, nie jest obsługiwana przez powyższe sterowniki ODBC, należy uzyskać i zainstalować zgodny z pakietem Microsoft Office sterownik ODBC od innego producenta, na przykład od producenta bazy danych. Aby uzyskać instrukcje dotyczące instalacji, skontaktuj się z dostawcą bazy danych.

Uwaga Bazy danych OLAP nie wymagają sterowników ODBC. Podczas instalacji programu Query instalowane są sterowniki i programy obsługi zapewniające dostęp do baz danych utworzonych za pomocą usług OLAP programu Microsoft SQL Server. Aby podłączyć się do innych baz danych OLAP, należy zainstalować sterownik źródła danych i oprogramowanie klienckie. Dowiedz się więcej na temat innych dostawców baz danych OLAP.


Instalowanie oprogramowania usługodawcy OLAP

Aby połączyć się z produktami innych firm dostarczającymi dane i usługi OLAP, należy zainstalować oprogramowanie usługodawcy OLAP. Oprogramowanie zawiera dodatkowe sterowniki źródeł danych i oprogramowanie klienckie umożliwiające połączenie się z umieszczoną na serwerze bazą danych OLAP innych firm.

Aby użyć funkcji pakietu Microsoft Office do pracy z danymi OLAP, usługodawca OLAP innych firm musi być zgodny z pakietem Office. Dostawca może, ale nie musi, obsługiwać tworzenie i pracę z plikami modułów offline. Można sprawdzić obsługę, tworząc raport tabeli przestawnej programu Microsoft Excel ze źródła danych dostarczonego przez bazę danych OLAP innej firmy. W raporcie tabeli przestawnej polecenie Ustawienia Klient-Server w menu Tabela przestawna (pasek narzędzi Tabela przestawna) będzie niedostępne, jeśli dostawca nie obsługuje plików modułów offline.

Aby uzyskać informacje dotyczące instalowania i używania usługodawcy OLAP innej firmy, skontaktuj się z administratorem systemu lub producentem produktu OLAP. Po zainstalowaniu dostawcy można skonfigurować źródła danych w programie Microsoft Query, aby uzyskać dostęp do baz danych dostawcy.


Dostępne bazy danych

Program Microsoft Office zawiera sterowniki, których można użyć do pobierania danych z następujących źródeł danych:

  • Microsoft SQL Server OLAP Services (dostawca OLAP) 7.0 i nowszy
  • Microsoft Access 2000 i nowszy
  • dBASE
  • Microsoft FoxPro
  • Microsoft Excel
  • Oracle
  • Paradox
  • SQL Server
  • Bazy danych w plikach tekstowych

Uwaga Można używać sterowników ODBC lub sterowników baz danych pochodzących od innych producentów w celu pobierania informacji z systemów obsługi baz danych niewymienionych tutaj, łącznie z innymi typami baz danych OLAP. Informacje dotyczące instalowania sterowników ODBC lub źródeł danych niewymienionych powyżej można znaleźć w dokumentacji systemu obsługi bazy danych lub należy się skontaktować z dostawcą systemu obsługi bazy danych.


Określanie źródła, z którego mają zostać pobrane dane

  1. Jeśli okno dialogowe Wybór źródła danych nie jest wyświetlone, kliknij przycisk Nowa kwerenda Obrazek przycisku.
  2. Wykonaj jedną z następujących czynności:

    Aby określić źródło danych dla relacyjnej bazy danych, bazy danych w plikach tekstowych lub listy programu Microsoft Excel, kliknij kartę Bazy danych.

    Aby określić źródło danych dla modułu OLAP, kliknij kartę Moduły OLAP. Karta ta jest dostępna tylko w przypadku uruchomienia programu Microsoft Query z poziomu programu Microsoft Excel.

  3. Kliknij dwukrotnie przycisk Nowe źródło danych.
  4. W kroku pierwszym wpisz nazwę w celu identyfikacji źródło danych.
  5. W kroku drugim kliknij sterownik typu bazy danych wykorzystywanej jako źródło danych.

    Jeśli na liście nie ma wymaganej bazy danych, może zaistnieć konieczność zainstalowania dla źródła danych sterownika ODBC lub sterownika źródła danych.

    Jak?

  6. Kliknij przycisk Połącz, a następnie wpisz informacje wymagane do nawiązania połączenia z wymaganą bazą danych.

    W przypadku relacyjnych baz danych, baz danych w plikach tekstowych i list programu Microsoft Excel, wpisywane informacje zależą od typu wybranej bazy danych. Może pojawić się monit o wprowadzenie nazwy logowania, hasła, wersji używanej bazy danych, jej lokalizacji lub innych informacji unikatowych dla bazy danych.

    W przypadku korzystania ze źródeł danych programu Microsoft SQL Server OLAP Services postępuj według wskazówek Kreatora połączeń wielowymiarowych.

  7. Po wprowadzeniu wymaganych informacji kliknij przycisk OK lub Zakończ, aby powrócić do okna dialogowego Utwórz nowe źródło danych.
  8. Jeśli baza danych zawiera tabele i jedna z nich ma być automatycznie wyświetlana w Kreatorze kwerend, kliknij pole dla kroku czwartego, a następnie kliknij żądaną tabelę.
  9. Jeśli nie chcesz wpisywać nazwy logowania i hasła podczas korzystania ze źródła danych, zaznacz pole wyboru Zapisz mój identyfikator użytkownika i hasło w definicji źródła danych. Jeśli to pole wyboru jest niedostępne, skonsultuj się z administratorem bazy danych w celu sprawdzenia, czy opcja ta została wyłączona.

    Po zakończeniu tej procedury nazwa bazy danych pojawi się w oknie dialogowym Wybór źródła danych.


Ustawianie źródła danych używającego sterownika programu Microsoft Access

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych z kroku 1, a następnie wybierz opcję Sterownik programu Microsoft Access w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. W polu Baza danych kliknij przycisk Wybierz, a następnie użyj okna dialogowego Wybieranie bazy danych do zlokalizowania pliku bazy danych.

    Chcąc, aby program Microsoft Query otwierał bazę danych w trybie tylko do odczytu, zaznacz pole wyboru Tylko do odczytu.

    Chcąc, aby program Microsoft Query był jedynym użytkownikiem bazy danych, kiedy korzysta z tego źródła danych, zaznacz pole wyboru Wyłączny.

  4. Kliknij przycisk OK.

    Jeśli baza danych wymaga ustawienia dodatkowych parametrów połączenia, kliknij przycisk Zaawansowane. Aby uzyskać informacje o ewentualnej konieczności zmiany któregokolwiek z tych ustawień, skontaktuj się z administratorem bazy danych. Aby uzyskać informacje o ustawieniach zaawansowanych, kliknij przycisk Anuluj, a następnie kliknij przycisk Pomoc w oknie dialogowym Ustawienia ODBC programu Microsoft Access.

  5. Chcąc, aby program Microsoft Query korzystał z systemowej bazy danych, kliknij opcję Baza danych w obszarze Systemowa baza danych, a następnie kliknij przycisk Systemowa baza danych. W oknie dialogowym Wybieranie bazy danych odszukaj plik systemowej bazy danych, a następnie kliknij przycisk OK.
  6. Kliknij przycisk OK, a następnie wpisz nazwę użytkownika i hasło w polu Autoryzacja. Jeśli nie używasz nazwy użytkownika lub hasła w celu uzyskania dostępu do bazy danych, pola w obszarze Autoryzacja pozostaw puste.

Uwaga Okno dialogowe Ustawienia ODBC programu Microsoft Access można wykorzystać do tworzenia, naprawy i kompaktowania baz danych programu Microsoft Access. Nie znając tych operacji, należy je wykonywać tylko w programie Microsoft Access. Więcej informacji można znaleźć w Pomocy programu Microsoft Access.


Ustawianie źródła danych używającego sterownika programu Microsoft dBASE lub FoxPro

Przed wykonaniem tych czynności dobrze jest umieścić w jednym folderze wszystkie pliki baz danych, które mają być używane, tak aby program Microsoft Query mógł znaleźć wszystkie te pliki i aby nie trzeba było wpisywać pełnej ścieżki przy każdym dodawaniu tabeli do kwerendy. Pliki baz danych można umieścić w jednym folderze, a pliki indeksowe w drugim.

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych z kroku 1, a następnie wybierz opcję Sterownik programu Microsoft dBase lub Sterownik programu Microsoft Visual FoxPro w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. Wykonaj jedną z następujących czynności:

    W wypadku sterownika programu Microsoft dBase, na liście Wersja kliknij wersję programu dBase lub FoxPro, która była użyta do utworzenia plików bazy danych. Jeśli pliki bazy danych nie znajdują się w bieżącym folderze, wyczyść pole wyboru Użyj bieżącego katalogu, a następnie kliknij przycisk Wybierz katalog, aby odszukać folder. Jeśli pliki indeksowe bazy danych są także w innym folderze, kliknij przycisk Wybierz indeksy, aby odszukać folder.

    W przypadku sterownika programu Microsoft Visual FoxPro kliknij opcję bazy danych programu FoxPro w polu Typ bazy danych, a następnie w polu Ścieżka wpisz ścieżkę do bazy danych.


Ustawianie źródła danych używającego sterownika Microsoft Excel

Korzystając ze sterownika ODBC programu Microsoft Excel, można uzyskać dostęp do danych tylko ze skoroszytów w tym samym folderze. Przed wykonaniem następujących czynności należy skopiować do jednego folderu wszystkie skoroszyty, z których mają być równocześnie pobierane dane, a ponadto należy nazwać każdy zakres skoroszytu, który ma być rozpoznawany przez program Microsoft Query jako tabela.

Dla każdego folderu, z którego mają być pobierane dane, należy zainstalować oddzielne źródło danych.

Przed instalacją źródła danych lub uruchomieniem kwerendy w celu pobrania danych w skoroszycie programu Excel należy zamknąć skoroszyt w programie Excel.

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowa w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych z kroku 1, a następnie wybierz opcję Sterownik programu Microsoft Excel w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. W polu Wersja kliknij wersję programu Excel, która była użyta do utworzenia skoroszytu. Jeśli skoroszyt został utworzony w programie Excel 97, Excel 2000 lub w nowszej wersji tego programu, kliknij opcję Excel 97-2000. Jeśli skoroszyt został utworzony w programie Excel 95 (Excel w wersji 7.0), kliknij opcję Excel 5.0/7.0.
  4. Kliknij przycisk Wybierz skoroszyt, a następnie odszukaj plik skoroszytu.


Ustawianie źródła danych używającego sterownika ODBC firmy Microsoft dla bazy danych Oracle

Korzystając ze sterownika ODBC firmy Microsoft dla bazy danych Oracle, można się łączyć z bazami danych Oracle, które obsługują system SQL*Net 2.3 lub nowszy. Informacje na temat tej obsługi można znaleźć w dokumentacji programu Oracle.

Przed rozpoczęciem ustawiania źródeł danych używających tego sterownika należy zainstalować oprogramowanie klienta Oracle i składniki oprogramowania sieciowego w wersji 7.3 lub nowszej. Składniki te są dostępne w firmie Oracle lub u jej dystrybutorów.

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych w kroku 1, a następnie wybierz opcję Sterownik ODBC Microsoft dla Oracle w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. W polu Baza danych kliknij przycisk Wybierz.
  4. W polu Nazwa użytkownika wpisz nazwę logowania do bazy danych.
  5. Wpisz nazwę serwera Oracle i wszelkie dodatkowe informacje niezbędne do uzyskania połączenia z serwerem. Aby uzyskać te informacje, skontaktuj się z administratorem bazy danych Oracle. Aby uzyskać informacje na temat opcji ustawień, kliknij przycisk Pomoc w oknie dialogowym ustawień.
  6. Wprowadź identyfikator logowania i hasło, a następnie kliknij dwukrotnie przycisk OK.


Ustawianie źródła danych używającego sterownika programu Microsoft Paradox

Przed wykonaniem tych czynności dobrze jest umieścić w jednym folderze wszystkie pliki baz danych, które mają być używane, tak aby program Microsoft Query mógł znaleźć wszystkie te pliki i aby nie trzeba było wpisywać pełnej ścieżki przy każdym dodawaniu tabeli do kwerendy.

  1. Jeśli nie jest wyświetlane okno dialogowe Wybierz źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych w kroku 1, a następnie wybierz opcję Sterownik programu Microsoft Paradox w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. W polu Wersja wybierz wersję programu Paradox, która była użyta do utworzenia plików bazy danych.
  4. Jeśli pliki bazy danych nie znajdują się w bieżącym folderze, wyczyść pole wyboru Użyj bieżącego katalogu, a następnie kliknij przycisk Wybierz katalog, aby odszukać pliki.
  5. Jeśli baza danych wymaga ustawienia opcji zaawansowanych, kliknij polecenie Opcje. Aby uzyskać informacje o ewentualnej konieczności zmiany któregokolwiek z tych ustawień, skontaktuj się z administratorem danej bazy danych. Aby uzyskać informacje o ustawieniach opcji, kliknij przycisk Pomoc w oknie dialogowym Instalacja ODBC programu Paradox.


Ustawianie źródła danych używającego sterownika programu Microsoft SQL Server

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych w kroku 1, a następnie wybierz opcję Serwer SQL w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. W polu Serwer wpisz nazwę serwera SQL w sieci. Aby uzyskać informacje na temat wyborów dostępnych dla opcji Serwer, kliknij przycisk Pomoc.
  4. Kliknij przycisk Opcje i ustaw pozostałe opcje wymagane przez bazę danych. Aby uzyskać informacje o ewentualnej konieczności zmiany któregokolwiek z tych ustawień, skontaktuj się z administratorem danej bazy danych. Aby uzyskać informacje na temat ustawień opcji, kliknij przycisk Pomoc.
  5. Wpisz identyfikator logowania i hasło, a następnie kliknij dwukrotnie przycisk OK.


Ustawianie źródła danych używającego sterownika programu Microsoft SQL Server OLAP Services

Tego sterownika można użyć do konfigurowania źródeł danych zarówno w przypadku baz danych na serwerze, jak i plików modułu offline (*.cub) tworzonych przez bazy danych programu Microsoft SQL Server OLAP Services za pomocą Kreatora modułu offline programu Microsoft Excel lub tworzonych z rekordów relacyjnych baz danych za pomocą Kreatora modułów OLAP w programie Microsoft Query. Zapoznaj się ze źródłami danych OLAP.

Uwaga W tym temacie wyjaśniono sposób konfigurowania źródeł danych, które używają dostawcy OLAP dla pierwszej wersji programu Microsoft SQL Server OLAP Services (wersja 7.0 programu MSMDCUBE.DLL). Aby skonfigurować źródła danych dla nowszych wersji tego dostawcy, zamiast programu Query można użyć Kreatora łączenia danych. Dodatkowe informacje o ustawianiu takich źródeł danych można znaleźć w Pomocy odpowiedniej wersji programu Microsoft SQL Server OLAP Services.

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Moduły OLAP, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę dla źródła danych z kroku 1, a następnie kliknij opcję Dostawca baz danych OLE firmy Microsoft dla usług OLAP w kroku 2.

    Karta Moduły OLAP jest dostępna tylko wtedy, kiedy program Query jest uruchomiony z programu Excel.

  2. W kroku 3 w oknie dialogowym Utwórz nowe źródło danych kliknij przycisk Połącz.
  3. W kroku 1 w oknie dialogowym Połączenie wielowymiarowe wykonaj jedną z następujących czynności:

    Aby połączyć się z bazą danych na serwerze, kliknij opcję Serwer analizy, a następnie podaj nazwę serwera, identyfikator logowania i hasło dla serwera. Aby uzyskać informacje na temat tych i innych ustawień dla bazy danych, skontaktuj się z administratorem.

    Aby połączyć się z plikiem modułu offline, kliknij opcję Plik modułu, a następnie podaj ścieżkę do pliku cub w polu Plik.

  4. Wykonaj jedną z następujących czynności:

    Jeżeli łączysz się z plikiem modułu offline, kliknij przycisk Zakończ.

    Jeżeli łączysz się z bazą danych na serwerze, kliknij przycisk Następny, wybierz bazę danych serwera, a następnie kliknij przycisk Zakończ. W kroku 4 okna dialogowego Utwórz nowe źródło danych wybierz nazwę modułu bazy danych, z której chcesz pobrać dane.


Ustawianie źródła danych używającego sterownika tekstowego firmy Microsoft

Dla każdego folderu zawierającego pliki tekstowe, z których mają być pobierane dane, należy zainstalować oddzielne źródło danych. Chcąc używać źródła danych do równoczesnego pobierania danych z kilku plików tekstowych, przed wykonaniem następnych czynności należy skopiować wszystkie te pliki do tego samego foldera.

  1. Jeśli nie jest wyświetlane okno dialogowe Utwórz nowe źródło danych, kliknij polecenie Nowy w menu Plik, kliknij kartę Bazy danych, a następnie kliknij dwukrotnie opcję Nowe źródło danych. Wpisz nazwę źródła danych z kroku 1, a następnie wybierz opcję Sterownik tekstowy firmy Microsoft w kroku 2.
  2. W kroku 3 kliknij przycisk Połącz.
  3. Jeśli pliki tekstowe nie znajdują się w bieżącym folderze, wyczyść pole wyboru Użyj bieżącego katalogu, a następnie kliknij przycisk Wybierz katalog, aby odszukać folder.

Uwaga Można uzyskać dostęp do danych w plikach tekstowych w wielu formatach, włącznie z kolumnami oddzielanymi spacją, przecinkami lub znakami tabulacji. Aby uzyskać więcej informacji o formatach plików tekstowych, których można używać, kliknij przycisk Pomoc w oknie dialogowym Instalacja tekstu ODBC.


Tworzenie nowej kwerendy — informacje

Kwerenda jest narzędziem umożliwiającym odnajdywanie rekordów odpowiadających na konkretne pytanie dotyczące danych przechowywanych w bazie danych. Podczas tworzenia kwerendy można korzystać z Kreatora kwerend lub pracować bezpośrednio w programie Microsoft Query. Sposób tworzenia kwerendy zależy od funkcji niezbędnych do wyboru wymaganych danych.

Kiedy używać Kreatora kwerend Kreator kwerend jest pomocny w tworzeniu prostych kwerend. Używając Kreatora kwerend, można wybrać tabele i pola, które mają znaleźć się w kwerendzie. Sprzężenie wewnętrzne jest tworzone automatycznie, gdy kreator rozpoznaje pole klucza podstawowego w jednej tabeli i pole o tej samej nazwie w drugiej tabeli.

Kreatora można także używać do sortowania zestawu wyników i do prostego filtrowania. W końcowym kroku kreatora można wybrać przekazanie danych do programu Microsoft Excel, dalsze uściślenie kwerendy w programie Microsoft Query lub utworzenie na podstawie danych modułu OLAP. Po utworzeniu kwerendy można ją uruchomić w programie Microsoft Excel lub w programie Microsoft Query. Jak używać Kreatora kwerend?

Kiedy używać programu Microsoft Query Program Microsoft Query umożliwia tworzenie bardziej złożonych kwerend. Metoda ta daje użytkownikowi znacznie więcej możliwości, umożliwiając zawężanie zawartości zestawu wyników dzięki utworzeniu sprzężenia wewnętrznego lub sprzężenia zewnętrznego lub dzięki użyciu wyrażeń i złożonych kryteriów. Wyrażenia są obliczeniami, które można tworzyć przy użyciu operatorów, funkcji, nazw pól i stałych. Stosowanie kryteriów pozwala na bardziej złożone filtrowanie.

W programie Microsoft Query można wyświetlić zestaw wyników, a po upewnieniu się, że zawarte w nim dane odpowiadają wymaganiom użytkownika, można je zwrócić do programu Microsoft Excel. W programie Microsoft Query można także tworzyć moduły OLAP. Po utworzeniu kwerendy można ją uruchomić w programie Microsoft Excel lub w programie Microsoft Query. Jak utworzyć kwerendę w programie Microsoft Query

Kiedy używać kwerendy parametrycznej Kwerenda parametryczna jest pomocna w tworzeniu jednej kwerendy służącej do pobierania danych przy użyciu różnych kryteriów. Na przykład, aby pobrać dane sprzedaży dla każdego produktu oddzielnie, można użyć jako kryterium nazwy produktu. Kwerendy parametryczne są także przydatne do pobierania porcji danych z baz danych, których wielkość uniemożliwia pobranie wszystkich danych jednocześnie przy istniejących ograniczeniach zasobów systemu.

Kwerenda parametryczna po uruchomieniu monituje o kryteria. Kwerendę parametryczną można utworzyć tylko w programie Microsoft Query, nie zaś w Kreatorze kwerend. Wprowadzane w kwerendzie kryteria są używane do pobierania danych z tabel. Po utworzeniu kwerendy można ją uruchomić w programie Microsoft Excel lub w programie Microsoft Query. Jak utworzyć kwerendę parametryczną


Tworzenie nowej kwerendy

Co chcesz zrobić?

Utworzyć kwerendę za pomocą kreatora kwerend

Utworzyć bardziej złożoną kwerendę w programie Microsoft Query

Utworzyć kwerendę parametryczną

Nie masz pewności, co wybrać?


Tworzenie kwerendy parametrycznej

  1. Utwórz kwerendę zawierającą tabele i pola dla żądanych rekordów.

    Jak?

  2. Upewnij się, że przycisk Autokwerenda Obrazek przycisku nie jest wciśnięty.
  3. Upewnij się, że przycisk Pokaż/Ukryj kryteria Obrazek przycisku decydujący o wyświetlaniu okienka kryteriów jest wciśnięty.
  4. Kliknij pierwszą komórkę w wierszu Pole kryteriów, a następnie kliknij strzałkę w komórce, aby na liście wybrać pole, które chcesz wykorzystać jako parametr kwerendy.
  5. Kliknij pierwszą komórkę w wierszu Wartość. Wpisz [ (otwierający nawias kwadratowy), a następnie tekst monitu, który program Microsoft Query wyświetli po uruchomieniu kwerendy, a następnie wpisz znak ] (zamykający nawias kwadratowy). Przykład pokazano na poniższym rysunku.

    Tekst monitu musi różnić się od nazwy pola, chociaż może zawierać tę nazwę.

    Aby utworzyć więcej niż jeden parametr dla kwerendy, powtórz krok 4. i 5. dla każdego dodawanego parametru w następnej dostępnej kolumnie w okienku kryteriów.

    Aby uzyskać więcej informacji na temat kryteriów, których można użyć w kwerendzie, kliknij przycisk Obrazek przycisku .

  6. Naciśnij klawisz ENTER.
  7. Aby uruchomić kwerendę, kliknij przycisk Wykonaj kwerendę Obrazek przycisku.

Uwaga Po zakończeniu pobierania danych można zwrócić zestaw wyników do programu Microsoft Excel. Aby uzyskać więcej informacji, kliknij przycisk Obrazek przycisku .


Otwieranie kwerendy

  1. Kliknij przycisk Otwórz kwerendę Obrazek przycisku, kliknij plik kwerendy, który chcesz otworzyć, a następnie kliknij przycisk Otwórz.

    Pliki kwerend mają rozszerzenie dqy lub qry.

  2. Jeżeli został wyświetlony monit, wprowadź nazwę użytkownika, hasło i inne dane potrzebne do połączenia za źródłem danych.
  3. Jeżeli został wyświetlony monit, wprowadź wartości parametrów dla kwerendy, a następnie kliknij przycisk OK. Informacje o prawidłowych parametrach można zwykle uzyskać od osoby, która utworzyła kwerendę.

Uwaga Można także otworzyć plik definicji modułu oqy utworzony za pomocą Kreatora modułów OLAP. Otwarcie tego typu pliku uruchamia kreatora, co pozwala zmienić definicję modułu. Dowiedz się więcej o tworzeniu modułów za pomocą Kreatora modułów OLAP.


Zapisywanie kwerendy

Należy zapisać kwerendę, chcąc zachować formatowanie lub użyć później tej samej kwerendy w innym skoroszycie. Aby uzyskać więcej informacji na temat otwierania plików kwerend w programie Microsoft Excel, zobacz Pomoc programu Excel. Zapisanie kwerendy nie jest potrzebne, aby zwrócić dane do programu Excel.

  1. Kliknij przycisk Zapisz plik Obrazek przycisku.
  2. W polu Nazwa pliku wpisz żądaną nazwę.
  3. Na liście Zapisz jako typ program Microsoft Query automatycznie wybiera Pliki kwerend (*.dqy). Jeżeli kwerenda ma być używana również w wersji programu Query wcześniejszej niż Microsoft Query 97, kliknij typ Pliki kwerend (*.qry).

    Kwerendy parametryczne mogą być zapisywane tylko w formacie *.dqy i nie mogą być używane w wersjach programu Query wcześniejszych niż Microsoft Query 97.

  4. Na liście Zapisz w kliknij folder, w którym chcesz przechować kwerendę.
  5. Kliknij przycisk Zapisz.

Uwagi

  • Podczas zapisywania pliku kwerendy w programie Query nie jest zapisywany bieżący zestaw wyników wyświetlany w okienku danych. Zestaw wyników jest automatycznie odświeżany przed wyświetleniem okna dialogowego Zapisz jako, nawet jeżeli nie jest wciśnięty przycisk Autokwerenda Obrazek przycisku.
  • Chcąc zapobiec uruchamianiu kwerendy przed zapisaniem lub zwróceniem danych do programu Excel, należy kliknąć polecenie Opcje w menu Edycja, a następnie wyczyścić pole wyboru Sprawdź kwerendy przed zapisaniem lub zwróceniem danych.
  • Domyślną lokalizacją pliku kwerendy jest folder profilu użytkownika w folderze Dane aplikacji\Microsoft\Kwerendy. Jeżeli kwerenda została zapisana tym położeniu, to nazwa pliku pojawi się na karcie Kwerendy podczas otwierania nowej kwerendy w programie Microsoft Query lub po użyciu polecenia Uruchom zapisaną kwerendę (menu Dane, podmenu Importuj dane zewnętrzne) w programie Excel.


Uruchamianie, przeglądanie lub edycja polecenia, procedury lub instrukcji SQL

Osoby znające język SQL mogą go używać do edytowania opisującej kwerendę instrukcji SELECT języka SQL. Aby uzyskać więcej informacji na temat języka SQL, zapoznaj się z dokumentacją bazy danych.

  1. Utwórz nową kwerendę. Nie zwracaj wyników do programu Microsoft Excel.

    Jak?

  2. Kliknij przycisk Wyświetl SQL Obrazek przycisku.

    Program Microsoft Query wyświetla okno dialogowe SQL, które zawiera odpowiadającą kwerendzie instrukcję SELECT.

  3. Wpisz zmiany, które chcesz wprowadzić w instrukcji SQL, a następnie kliknij przycisk OK.

    Aby dodać nowy wiersz w oknie Instrukcja SQL, naciśnij klawisz ENTER.

Uwagi

  • Aby zmodyfikować lub zamienić instrukcję SQL, należy użyć tej samej składni, jakiej używa program Microsoft Query, lub składni obsługiwanej przez dane źródło danych. Program Microsoft Query interpretuje tę składnię i wyświetla zmieniony projekt kwerendy oraz zestaw wyników.
  • Jeżeli program Microsoft Query nie może wyświetlić projektu kwerendy, ponieważ nie może zinterpretować części wprowadzonej składni, wyświetlany jest wyłącznie zestaw wyników. W takim wypadku można zmieniać tylko formatowanie zestawu wyników, takie jak wyświetlana czcionka czy szerokość kolumny. Nie można edytować danych, a wszystkie zmiany w definicji kwerendy, takie jak np. dodawanie lub usuwanie pól, trzeba wprowadzać w oknie dialogowym SQL.


Uruchamianie kwerendy automatycznie lub uruchamianie jej w późniejszym czasie

Program Microsoft Query automatycznie uruchamia kwerendę i odświeża dane znajdujące się w zestawie wyników po każdym dodaniu pola do okienka danych lub po dodaniu albo zmianie kryteriów w okienku kryteriów. Jeżeli jednak kwerenda zawiera większą liczbę rekordów, to lepiej uruchomić kwerendę dopiero po wprowadzeniu wszystkich potrzebnych zmian.

  • Chcąc automatycznie uruchamiać kwerendę po dodaniu każdego pola lub kryterium, upewnij się, że jest wciśnięty przycisk Autokwerenda Obrazek przycisku.
  • Chcąc ręcznie uruchomić kwerendę po zakończeniu dodawania nowych kryteriów lub pól, upewnij się, że przycisk Autokwerenda Obrazek przycisku nie jest wciśnięty. Po przygotowaniu kwerendy kliknij przycisk Wykonaj kwerendę Obrazek przycisku.


Zwracanie zestawu wyników do programu Microsoft Excel

  1. Jeżeli nie jest wyświetlone okno dialogowe Zwracanie zewnętrznych danych do programu Microsoft Excel, kliknij przycisk Zwróć dane Obrazek przycisku i w razie potrzeby wprowadź wartości parametrów wymagane w przypadku danej kwerendy.
  2. Kliknij przycisk Właściwości, aby kontrolować sposób formatowania i układ, w jaki zewnętrzny zakres danych jest umieszczany w programie Microsoft Excel. Aby uzyskać więcej informacji, zobacz Pomoc programu Microsoft Excel.
  3. Aby umieścić zestaw wyników w zaznaczonym arkuszu, kliknij przycisk Istniejący arkusz. W arkuszu kliknij komórkę, w której chcesz umieścić lewy górny róg zestawu wyników, a następnie kliknij przycisk OK.

    Aby umieścić zestaw wyników w nowym arkuszu, kliknij przycisk Nowy arkusz, a następnie kliknij przycisk OK. Program Microsoft Excel dodaje nowy arkusz do skoroszytu i automatycznie umieszcza zestaw wyników w lewym górnym rogu nowego arkusza.

    Aby użyć danych zewnętrznych w raporcie tabeli przestawnej, kliknij przycisk Raport tabeli przestawnej, a następnie kliknij przycisk OK.

Uwagi

  • Zestaw wyników jest automatycznie odświeżany w programie Microsoft Query przed wyświetleniem okna dialogowego Zwracanie zewnętrznych danych do programu Microsoft Excel, nawet wówczas, gdy nie jest wciśnięty przycisk Autokwerenda Obrazek przycisku. Chcąc zapobiec uruchamianiu kwerendy przed zwróceniem danych do programu Excel, należy kliknąć polecenie Opcje w menu Edycja programu Query, a następnie wyczyścić pole wyboru Sprawdź kwerendy przed zapisaniem lub zwróceniem danych.
  • Można sprawdzić status czasochłonnej kwerendy. W programie Excel należy kliknąć przycisk Odśwież stan obraz przycisku na pasku narzędzi Dane zewnętrzne. Aby anulować zwracanie danych, należy kliknąć przycisk Anuluj odświeżanie.


Wykonywanie instrukcji lub procedury SQL

Osoby znające język Structured Query Language (SQL) mogą korzystać z instrukcji SELECT. Aby uzyskać więcej informacji na temat języka SQL, zapoznaj się z dokumentacją bazy danych.

  1. W menu Plik kliknij polecenie Wykonaj instrukcję SQL.

    Aby wykonać instrukcję SQL na tabeli znajdującej się w innym źródle danych, kliknij przycisk ródła danych, kliknij nazwę odpowiedniego źródła danych, a następnie kliknij przycisk OK. Można również określić nowe źródło danych.

    Jak?

  2. W polu Instrukcja SQL wpisz instrukcję SQL, którą chcesz uruchomić.

    Jeżeli instrukcja SQL została wcześniej przygotowana, kliknij przycisk Otwórz, zaznacz wybrany plik SQL, a następnie kliknij przycisk Otwórz.

    Aby uruchomić procedurę SQL przechowywaną w zewnętrznej bazie danych, kliknij przycisk Procedury, w polu Kwerenda zaznacz wybraną procedurę, a następnie kliknij polecenie Wklej, aby skopiować procedurę do pola Instrukcja SQL.

  3. Kliknij przycisk Wykonaj.

    Program Microsoft Query uruchamia instrukcję SQL. Jeżeli wykonanie kwerendy trwa zbyt długo, można ją przerwać, naciskając klawisz ESC.

    Aby zapisać instrukcję SQL, kliknij przycisk Zapisz.

Uwagi

  • Aby zmodyfikować lub zamienić instrukcję SQL, należy użyć tej samej składni, jakiej używa program Microsoft Query, lub składni obsługiwanej przez dane źródło danych. Program Microsoft Query interpretuje tę składnię i wyświetla zmieniony projekt kwerendy oraz zestaw wyników.
  • Jeżeli program Microsoft Query nie może wyświetlić projektu kwerendy, ponieważ nie może zinterpretować części wprowadzonej składni, wyświetlany jest wyłącznie zestaw wyników. W takim wypadku można zmieniać tylko formatowanie zestawu wyników, takie jak wyświetlana czcionka czy szerokość kolumny. Nie można edytować danych, a wszystkie zmiany w definicji kwerendy, takie jak np. dodawanie lub usuwanie pól, trzeba wprowadzać w oknie dialogowym SQL.
  • Jeżeli kwerenda zwraca więcej niż jeden zestaw wyników, program Microsoft Query wyświetla w okienku danych tylko pierwszy zbiór. Pozostałe zbiory nie są wyświetlane.
  • Jeżeli kwerenda jest wykonywana prawidłowo, lecz nie zwraca zestawu wyników, program Microsoft Query wyświetla komunikat o prawidłowym wykonaniu instrukcji. Jeżeli kwerenda spowodowała modyfikację zawartości tabel wyjściowych, komunikat informuje również o liczbie zmienionych wierszy.
  • Jeśli kwerenda nie została wykonana prawidłowo, program Microsoft Query wyświetla komunikat o błędzie instrukcji SQL, odnoszący się do problemu. Aby wyświetlić okno dialogowe Wykonywanie instrukcji SQL i dokonać poprawek w instrukcji, kliknij przycisk OK.


Kwerendy OLAP — informacje

Program Microsoft Query umożliwia tworzenie i pracę z danymi baz danych procesów analitycznego przetwarzania online (OLAP) poprzez skonfigurowanie źródeł danych, utworzenie modułów OLAP na podstawie danych relacyjnych oraz zapisanie plików definicji modułów OLAP. W temacie tym omówiono używanie programu Microsoft Query do przygotowania danych OLAP, które zostaną wykorzystane w raportach tabel przestawnych oraz raportach wykresów przestawnych programu Microsoft Excel.

Temat ten zawiera następujące informacje:

Co to jest OLAP?

Łączenie się z bazami danych OLAP

Tworzenie modułu OLAP na podstawie rekordów kwerendy

Zapisywanie plików kwerendy OLAP

Co to jest OLAP?

OLAP jest sposobem porządkowania dużych biznesowych baz danych. Dane OLAP są porządkowane przez administratora bazy danych pod kątem sposobu zarządzania nimi i ich analizowania, co przyspiesza i upraszcza przygotowywanie raportów.

Poziomy szczegółowości Bazy danych OLAP porządkują dane według poziomów szczegółowości, wykorzystując te same rodzaje kategorii, z jakich korzysta użytkownik podczas analizowania danych. Na przykład baza danych zawierająca informacje o wielkości sprzedaży danego produktu na całym świecie może zawierać oddzielne pola określające wielkości sprzedaży dla kraju, regionu, miasta czy biura. W bazie danych OLAP takie geograficzne informacje mogą być uporządkowane od najniższego do najwyższego poziomu szczegółowości, na przykład tak:

Poziomy szczegółowości w wymiarze geograficznym

Poziomy w wymiarze geograficznym

Takie uporządkowanie ułatwia zarówno wyświetlanie podsumowań sprzedaży na najwyższym poziomie, takich jak podsumowania sprzedaży w całym kraju lub regionie, jak i wyświetlanie szczegółowych informacji o miejscach, w których sprzedaż jest szczególnie mała lub szczególnie duża. Raporty tabel przestawnych i wykresów przestawnych programu Microsoft Excel pozwalają wyświetlać podsumowania na różnych poziomach, a jeśli dany poziom zawiera bardzo dużo szczegółowych danych, można wyświetlać tylko wybrane elementy.

Wymiary i moduły Zestaw poziomów odnoszący się do jednego aspektu danych, takiego jak obszar geograficzny, jest nazywany wymiarem. Podobnie informacje o czasie sprzedaży towarów mogą zostać uporządkowane w wymiarze czasowym obejmującym poziomy roku, kwartału, miesiąca i dnia. Bazy danych OLAP są nazywane modułami, ponieważ łączą w sobie kilka wymiarów, takich jak czas, lokalizacja geograficzna i produkty, razem z podsumowanymi danymi, takimi jak wielkość sprzedaży czy stan zapasów. Baza danych OLAP pozwala obliczyć sumaryczne wartości dla wszystkich możliwych przecięć poziomów wszystkich wymiarów, na przykład całkowitą wartość sprzedaży dla każdego dnia, miesiąca i roku, w każdym oddziale, regionie i kraju, dla każdego produktu i każdej rodziny produktów.

Powrót do początku

Łączenie się z bazami danych OLAP

Dostawcy OLAP Aby połączyć się z bazą danych OLAP, wymagany jest dostawca OLAP obsługujący określony typ bazy danych OLAP. Pakiet Microsoft Office zawiera oprogramowanie zapewniające dostęp do serwera bazy danych OLAP firmy Microsoft, programu Microsoft SQL Server OLAP Services. Aby móc korzystać z innych produktów lub usług OLAP, należy zainstalować dodatkowe sterowniki i oprogramowanie klienta. Aby uzyskać informacje o możliwości korzystania z usług niezależnych dostawców OLAP, należy skonsultować się z administratorem systemu lub dostawcą używanego produktu OLAP. Dowiedz się więcej o instalowaniu dostawców OLAP.

Źródła danych Oprogramowanie klienta OLAP obejmuje sterownik źródła danych bazy danych OLAP. Pakiet Office zawiera sterownik o nazwie Microsoft OLE DB Provider for OLAP Services, który zapewnia dostęp do baz danych utworzonych za pomocą programu Microsoft SQL Server OLAP Services. Tworzenie modułów lub plików modułów trybu offline za pomocą programu Microsoft Query powoduje jednoczesne utworzenie źródeł danych zapewniających dostęp do tych modułów.

Jeśli w celu połączenia się z bazą danych OLAP lub plikiem modułu trybu offline zostanie uruchomiony program Microsoft Query, nowe źródło danych będzie konfigurowane w taki sam sposób, jak dla każdego innego typu danych, z wyjątkiem nazwania źródła danych, określenia sterownika źródła danych i połączenia się z bazą danych, które to funkcje są realizowane za pośrednictwem karty Moduły OLAP, dostępnej w oknie dialogowym Wybór źródła danych. Jak skonfigurować źródło danych.

Zwracanie danych do programu Excel Po skonfigurowaniu źródła danych OLAP i podjęciu decyzji o jego użyciu nie jest tworzona kwerenda służąca do wybierania pól i tabel, tak jak ma to miejsce w przypadku innych typów źródeł danych. Źródło danych zapewnia dostęp do wszystkich danych modułu OLAP. Pola danych są natychmiast zwracane do programu Excel w formie raportu tabeli przestawnej.

Powrót do początku

Tworzenie modułu OLAP na podstawie rekordów kwerendy

Dostarczane w pakiecie Microsoft Office oprogramowanie Microsoft Query i klient OLAP umożliwia tworzenie własnych modułów OLAP lub pliku modułu trybu offline w oparciu o dane zwrócone z relacyjnej bazy danych, takiej jak baza programu Microsoft SQL Server. Utworzenie modułu OLAP może spowodować, że dostęp do dużych porcji informacji przechowywanych w relacyjnej bazie danych będzie przebiegał sprawniej, a użytkownik może lepiej porządkować dane używane w raportach. Aby utworzyć taki moduł OLAP i posługiwać się nim, nie trzeba wcale dysponować serwerem OLAP.

Pobieranie danych dla modułu Aby utworzyć swój własny moduł, należy skonfigurować źródło danych dla relacyjnej bazy danych, utworzyć kwerendę umożliwiającą pobieranie danych oraz uruchomić Kreatora modułów OLAP w celu zdefiniowania struktury danych w module, a także (opcjonalnie) zapisać plik modułu trybu offline.

Tworzenie modułu budowanego w pamięci W Kreatorze modułów OLAP można utworzyć tymczasowy moduł, który jest odbudowywany w pamięci po każdym otwarciu raportu opartego na tym module. Informacje o sytuacjach wymagających utworzenia tego typu modułu można znaleźć w Pomocy Kreatora modułów OLAP. Dowiedz się więcej o uruchamianiu kreatora w celu utworzenia modułu OLAP.

Tworzenie pliku modułu trybu offline Kreator modułów OLAP umożliwia również tworzenie pliku modułu trybu offline (z rozszerzeniem .cub), który można przechowywać na dysku lokalnym lub w udziale sieciowym. Zapisanie pliku cub na dysku lokalnym pozwala na kontynuowanie pracy z danymi po przerwaniu połączenia sieciowego lub w przypadku, gdy serwer jest niedostępny. Jeśli plik zostanie zapisany w udziale sieciowym, użytkownicy będą mieli możliwość skonfigurowania źródeł danych w sposób umożliwiający dostęp do pliku modułu trybu offline oraz tworzenie na jego podstawie raportów. Dowiedz się więcej o uruchamianiu kreatora w celu utworzenia pliku modułu offline.

Powrót do początku

Zapisywanie plików kwerendy OLAP

Źródła danych OLAP Jeśli źródło danych zostanie skonfigurowane za pomocą karty Moduły OLAP dostępnej w oknie dialogowym Wybór źródła danych, program Microsoft Query zapisze plik oqy w folderze profilu użytkownika, w katalogu Application Data\Microsoft\Queries. Oprócz określenia źródła danych podczas tworzenia w programie Microsoft Excel raportu tabeli przestawnej lub wykresu przestawnego, użytkownik ma również możliwość otwarcia pliku oqy bezpośrednio w programie Microsoft Excel i utworzenia raportu tabeli przestawnej. Jeśli plik oqy jest połączony z bazą danych serwera OLAP lub plikiem modułu trybu offline zapisanym w udziale sieciowym, można plik oqy udostępnić innym użytkownikom, którzy będą mieli odtąd możliwość otwierania go i tworzenia raportów bez konieczności konfigurowania własnych źródeł danych.

Moduły utworzone za pomocą Kreatora modułów OLAP Po zakończeniu ostatniego działania wykonywanego przez Kreatora modułów OLAP pojawia się monit o zapisanie pliku definicji modułu, mającego rozszerzenie oqy. Plik ten zawiera informacje wymagane przez program Microsoft Excel do zbudowania modułu w pamięci lub połączenia się z plikiem modułu trybu offline, jeśli plik taki utworzono. Zamiast zwracać rekordy kwerendy do programu Microsoft Excel, można otworzyć ten plik w programie Microsoft Excel i utworzyć raport tabeli przestawnej. Mimo że nie jest konieczne konfigurowanie oddzielnego źródła danych dla modułu OLAP, można skonfigurować oddzielne źródło danych dla pliku modułu trybu offline, zwłaszcza w przypadku bezpośredniego łączenia z plikiem modułu w celu tworzenia raportów.

Zapisanie pliku oqy nie jest tym samym, co zapisanie kopii kwerendy dla rekordów relacyjnej bazy danych, których użyto do utworzenia modułu OLAP. Aby zapisać kopię kwerendy w sposób umożliwiający późniejsze dodawanie danych do modułu, należy zapisać kwerendę w pliku kwerendy bazy danych (dqy).

Powrót do początku


Tworzenie modułu OLAP na podstawie danych relacyjnych — informacje

W temacie tym omówiono tworzenie modułu OLAP na podstawie kwerendy pobierającej dane z relacyjnej bazy danych, takiej jak baza programu Microsoft Access czy Microsoft SQL Server. Aby utworzyć taki moduł OLAP i posługiwać się nim, nie trzeba wcale dysponować serwerem OLAP. Aby zrozumieć i zastosować te funkcje w programie Microsoft Query, trzeba poznać zarządzanie bazami danych i używanie programu Microsoft Query do pobierania danych do programu raportów tabel przestawnych lub raportów wykresów przestawnych w programie Microsoft Excel.

Temat ten zawiera następujące informacje:

Co to jest moduł OLAP?

Tworzenie kwerendy danych

Tworzenie modułu

Odświeżanie i zmiana modułu

Co to jest moduł OLAP?

Analityczne przetwarzanie online (On-Line Analitical Processing — OLAP) jest sposobem porządkowania danych pod kątem sposobu zarządzania nimi i ich analizowania, co przyspiesza i upraszcza przygotowywanie raportów. Podczas tworzenia modułu OLAP na podstawie kwerendy płaski zestaw rekordów zostaje zamieniony w zhierarchizowaną strukturę (moduł), dzięki czemu raporty mogą się koncentrować na wymaganym poziomie szczegółowości. Można również wstępnie definiować wartości podsumowania dla raportów, co przyspiesza przeliczanie danych na potrzeby raportów.

Moduł OLAP warto utworzyć w przypadku, gdy użytkownik chce korzystać w raportach programu Microsoft Excel z dużej ilości danych zewnętrznych, zwłaszcza jeśli trzeba przeanalizować więcej rekordów, niż można zwrócić do programu Microsoft Excel bez wyczerpania zasobów systemowych. Ponieważ moduł pozwala programowi Microsoft Excel pobierać tylko te dane, które są niezbędne do utworzenia aktualnego widoku raportu, tworzenie i aktualizowanie raportów przebiega zazwyczaj szybciej w przypadku używania większej liczby danych niż wtedy, gdy z bazy danych pobierany byłby komplet rekordów.

Dane modułu OLAP mogą być zwracane do programu Microsoft Excel tylko w postaci raportu tabeli przestawnej lub wykresu przestawnego, w odróżnieniu od rekordów relacyjnej bazy danych pobierane przez kwerendę, które mogą być też zwracane jako zakres zewnętrznych danych w arkuszu.

Powrót do początku

Tworzenie kwerendy danych

Aby utworzyć moduł OLAP na podstawie rekordów relacyjnej bazy danych, należy skonfigurować źródło danych dla relacyjnej bazy danych, a następnie utworzyć kwerendę umożliwiającą pobieranie danych z pól i rekordów i przekazywanie danych do modułu.

Wybieranie pól dla kwerendy Aby zagwarantować optymalne działanie kwerendy, należy w niej zawrzeć tylko te tabele i pola, które będą wykorzystywane w module. Należy jednak pamiętać o dodaniu wszystkich pól wymaganych przez użytkownika. Po utworzeniu modułu nie można już dodawać do kwerendy kolejnych pól w celu dołączenia ich do modułu. Aby dodać nowe pola do modułu, należy go utworzyć od początku.

Wielokrotne dodawanie pól Czasami może zaistnieć potrzeba kilkakrotnego użycia jednego pola w module. Na przykład pole Sprzedaż można podsumować na dwa różne sposoby: sumując przychodzy ze sprzedaży i zliczając liczbę transakcji. Można też zastosować dwie wersje pola Data: jedną porządkującą daty według kwartałów i miesięcy, a drugą — według kwartałów i tygodni. Aby użyć pola w module więcej niż raz, należy dodać pole do kwerendy dla każdego zastosowania osobno. Na przykład pole Sprzedaż należy dodać do kwerendy dwa razy, jeśli ma być dokonane zarówno dodawanie, jak i zliczanie wartości pola.

Szczegółowe informacje na temat wielokrotnego umieszczania pola w kwerendzie można znaleźć w Pomocy Kreatora modułów OLAP. Jeśli podczas działania kreatora okaże się, że trzeba w danym momencie dodać pola do kwerendy, można anulować działanie kreatora, dodać pola, a następnie ponownie uruchomić kreatora.

Zapisywanie kwerendy Jeśli użytkownik planuje późniejsze odtworzenie modułu z innymi polami, należy pamiętać, aby zapisać kwerendę w pliku kwerend baz danych (dqy). Można wówczas otworzyć taki plik, zmienić kwerendę i utworzyć nowe moduły na podstawie zmienionej kwerendy.

Powrót do początku

Tworzenie modułu

Aby utworzyć moduł, należy uruchomić Kreatora modułów OLAP. Szczegółowe instrukcje na temat każdego z kroków kreatora można znaleźć w Pomocy tego kreatora.

Moduły tymczasowe i pliki modułów trybu offline Kreator umożliwia tworzenie dwóch rodzajów modułów. Jeden typ to definicja modułu, którą kreator zapisuje w postaci pliku oqy. Po otwarciu raportu utworzonego w oparciu o plik oqy, w pamięci tworzona jest tymczasowa postać modułu. Drugi typ modułu to oddzielny plik modułu trybu offline, który jest przechowywany na lokalnym dysku lub udziale sieciowym. Jeśli moduł jest przechowywany na lokalnym dysku, umożliwia to kontynuowanie pracy po odłączeniu się od sieci. Plik modułu trybu offline można skonfigurować jako źródło danych dla raportów.

Zapisywanie pliku definicji modułu Niezależnie od tego, czy zapisywany jest osobny plik modułu trybu offline czy też nie, kreator zapisuje plik definicji modułu (oqy). Plik ten zawiera informacje wymagane przez program Microsoft Query do załadowania modułu, tak aby można było dokonać w nim zmian oraz informacje wymagane przez program Microsoft Excel do zbudowania modułu w pamięci lub nawiązania połączenia z plikiem modułu trybu offline, jeśli został on utworzony.

Tworzenie raportów na podstawie definicji modułu Zamiast zwracać rekordy kwerendy względem relacyjnej bazy danych do programu Microsoft Excel, można w programie tym otworzyć plik oqy i utworzyć raport tabeli przestawnej oparty na module OLAP. Można wówczas zapisać raport tabeli przestawnej w skoroszycie lub utworzyć raporty wykresów tabeli przestawnej oparte na raporcie tabeli przestawnej. Instrukcje dotyczące otwierania plików oqy i tworzenia raportów można znaleźć w Pomocy programu Microsoft Excel.

Powrót do początku

Odświeżanie i zmiana modułu

Odświeżanie modułu OLAP Aby odświeżyć moduł, należy w programie Microsoft Excel otworzyć raport oparty na danym module i odświeżyć raport. Jeśli moduł jest zbudowany tymczasowo w pamięci, w wyniku odświeżenia z pierwotnej bazy danych przekazywane są do niego dane nowe i zmienione. Jeśli moduł jest plikiem modułu trybu offline, plik jest odbudowywany na podstawie nowych danych, a istniejący plik jest zamieniany. Aby tworzyć własne moduły i odświeżać je, trzeba dysponować dostawcą usług OLAP, takim jak program Microsoft SQL Server OLAP Services, obsługującym te możliwości. Informacje na temat procedury odświeżania raportu tabeli przestawnej lub wykresu przestawnego, opartego na module OLAP, można znaleźć w Pomocy programu Microsoft Excel.

Zmiana modułu OLAP Można zmienić moduł OLAP utworzony za pomocą Kreatora modułów OLAP, porządkując dane w inny sposób lub usuwając pola, które nie mają być uwzględniane w raportach. Jeśli został utworzony plik modułu trybu offline, można zapisać plik ze zmianami.

Po utworzeniu modułu OLAP nie można dodawać do niego pól z pierwotnej relacyjnej bazy danych. Można jednak utworzyć nowy moduł OLAP z tego samego pliku kwerendy bazy danych (dqy), tak aby użyć w nim innych pól pierwotnej bazy danych.

Powrót do początku


Tworzenie modułu OLAP z danych relacyjnych

Dane modułu OLAP można zwracać do programu Microsoft Excel jedynie jako raport tabeli przestawnej, a nie jako zakres danych zewnętrznych w arkuszu.

  1. Utwórz kwerendę, aby pobrać pola używane w module.

    Jak?

  2. Uruchom Kreatora modułów OLAP, korzystając z jednego z następujących sposobów:

    Jeśli kwerenda została utworzona za pomocą Kreatora kwerend, kliknij przycisk Utwórz moduł OLAP z tej kwerendy w ostatnim kroku kreatora, a następnie kliknij przycisk Zakończ.

    Jeśli kwerenda została utworzona w programie Microsoft Query, kliknij polecenie Utwórz moduł OLAP w menu Plik.

  3. Postępuj zgodnie z krokami Kreatora modułów OLAP. Aby uzyskać szczegółowe instrukcje, zobacz Pomoc Kreatora modułów OLAP.
  4. Po zakończeniu pracy kreatora, program Query monituje o zapisanie pliku definicji modułu (oqy). Wpisz nazwę tego pliku, a następnie kliknij przycisk Zapisz.

Uwagi

  • Jeśli w Kreatorze modułów OLAP wybrano plik modułu offline (cub), to plik cub jest tworzony po kliknięciu przycisku Zapisz. Zależnie od ilości danych w module, zapisywanie pliku może być czasochłonne. Do czasu zakończenia tworzenia plików nie można kontynuować pracy z programem Microsoft Query.
  • Aby moduł stał się podstawą dodatkowych raportów programu Microsoft Excel, nie trzeba zwracać danych z kwerendy do programu Excel. Zamiast tego należy otworzyć plik oqy za pomocą polecenia Otwórz w menu Plik programu Excel.
  • Można także wykorzystać w raportach programu Excel pliki modułów offline, konfigurując źródło danych dla pliku, a następnie wskazując to źródło danych podczas uruchamiania Kreatora tabel lub wykresów przestawnych programu Excel.
  • Chcąc w przyszłości dodawać pola ze źródłowej bazy danych do modułu, należy pamiętać, aby zapisać plik kwerendy bazy danych (dqy), co umożliwi zmienianie modułu za pomocą modyfikacji tego pliku.


Zmienianie zawartości i ustawień modułu OLAP

Można zmienić organizację pól w module oraz usunąć z niego niepotrzebne pola, ale nie można dodawać kolejnych pól do istniejącego modułu OLAP. Aby dodać do modułu więcej pól, należy utworzyć nowy moduł.

  1. W menu Plik programu Microsoft Query kliknij polecenie Otwórz.
  2. Na liście Pliki typu kliknij pozycję Moduły OLAP.
  3. Zlokalizuj i kliknij dwukrotnie plik definicji modułu (oqy), który chcesz zmienić.
  4. Aby zmienić zawartość i ustawienia, wykonaj kolejne kroki Kreatora modułów OLAP. Aby uzyskać szczegółowe instrukcje, zobacz Pomoc Kreatora modułów OLAP.
  5. Po zakończeniu pracy z kreatorem program Query wyświetli monit o zapisanie pliku oqy. Aby zamienić istniejący plik oqy, kliknij przycisk Zapisz. Aby zapisać nowy plik oqy, wpisz nową nazwę, a następnie kliknij przycisk Zapisz.

Uwagi

  • Jeśli w Kreatorze modułów OLAP wybrano plik modułu offline (cub), to plik cub jest tworzony po kliknięciu przycisku Zapisz. Istniejący plik cub, który trzeba zmienić, musi być ponownie utworzony i zamieniony. Zależnie od ilości danych w module, zapisywanie pliku może być czasochłonne. Przed zakończeniem operacji tworzenia pliku cub nie można pracować w programie Microsoft Query.
  • Na podstawie pliku cub można utworzyć raporty programu Microsoft Excel, otwierając plik oqy za pomocą polecenia Otwórz z menu Plik programu Excel albo konfigurując źródło danych dla pliku cub, a następnie podając to źródło podczas uruchamiania Kreatora tabel i wykresów przestawnych programu Excel.


Usuwanie pliku modułu offline

Usunięty plik modułu offline (cub) jest na trwałe usuwany z dysku, na którym był zapisany, co powoduje zwolnienie używanej przestrzeni dyskowej. Po usunięciu pliku nie można zmieniać opartych na nim raportów. Jeśli plik był używany przez utworzone źródła danych, to nie można korzystać z tych źródeł.

  • W systemie Microsoft Windows zlokalizuj i usuń plik cub.


Dodawanie tabeli do kwerendy

  1. Kliknij przycisk Dodaj tabele Obrazek przycisku.
  2. Wybierz tabelę, którą chcesz dodać.
  3. Kliknij przycisk Dodaj.

Uwaga Do kwerendy można dodać dowolną liczbę tabel. Po zakończeniu należy kliknąć przycisk Zamknij.


Usuwanie tabeli z kwerendy

  1. Kliknij tabelę, którą chcesz usunąć.
  2. W menu Edycja kliknij polecenie Usuń.


Dodawanie lub usuwanie pola

Pole jest kategorią informacji, taką jak nazwa produktu lub wielkość zamówienia, przechowywaną w tabeli informacji w bazie danych. Podczas dodawania lub usuwania pola kwerenda dołącza lub wyklucza informacje z tego pola. Podstawowa baza danych, z której pochodzą informacje, nie zmienia się.

Dodawanie pola Aby dodać pojedyncze pole do zestawu wyników, należy kliknąć dwukrotnie odpowiednie pole w okienku tabeli.

Przykład pojedynczego pola wybranego w okienku tabeli

Usuwanie pola Aby usunąć pole ze zestawu wyników, należy kliknąć nagłówek kolumny dla odpowiedniego pola w okienku danych, a następnie kliknąć polecenie Usuń kolumnę w menu Rekordy.

Porady

  • Aby jednocześnie dodać kilka pól z tej samej tabeli, przytrzymaj wciśnięty klawisz CTRL podczas klikania każdego pola, a następnie przeciągnij zaznaczone pola do okienka danych.
  • Aby dodać wszystkie pola z tabeli do zestawu wyników, kliknij dwukrotnie * (gwiazdkę) znajdującą się u góry tabeli w okienku tabeli.

    Przykład wyboru gwiazdki (*) w okienku tabeli


Pobieranie pokrewnych rekordów z wielu tabel za pomocą sprzężeń

Temat ten zawiera następujące informacje:

Sprzęganie tabel

Sprzężenia wewnętrzne

Sprzężenia zewnętrzne

Samosprzężenia

Pełne sprzężenia zewnętrzne

Sprzężenia różnicowe

Sprzęganie tabel

Bazy danych składają się z wielu tabel zawierających pokrewne informacje. Podczas dodawania dwóch (lub więcej) tabel do kwerendy program Microsoft Query automatycznie tworzy „sprzężenie” między tabelami po rozpoznaniu pola klucza podstawowego w jednej tabeli i pola o tej samej nazwie w drugiej tabeli. Linie sprzężenia pokazują relacje między danymi w tabelach.

Linie sprzężenia między tabelami

Linie sprzężenia łączą tabele Produkty z tabelą Szczegóły zamówień, sprzęgając pola IDProduktu w każdej tabeli. Tabela Szczegóły zamówień i tabela Zamówienia są także sprzężone za pomocą pól IDZamówienia.

Istnieją dwa podstawowe typy sprzężeń, których można używać do pobierania rekordów z wielu tabel. Sprzężenie wewnętrzne jedynie pobiera z tabel pokrewne rekordy. Sprzężenie zewnętrzne pobiera wszystkie rekordy z jednej tabeli i związane z nimi rekordy z drugiej tabeli.

Poza sprzężeniami wewnętrznymi i zewnętrznymi istnieją trzy inne typy sprzężeń, które można tworzyć: samosprzężenia, pełne sprzężenia zewnętrzne i sprzężenia różnicowe. Samosprzężenie zwraca zestaw wyników, który łączy informacje zawarte w jednej tabeli. Pełne sprzężenie zewnętrzne zwraca wszystkie rekordy z obu tabel, nawet jeśli rekordy nie są pokrewne. Sprzężenie różnicowe zwraca jedynie te rekordy z pierwszej tabeli, które nie mają odpowiedników w drugiej tabeli.

Powrót do początku

Sprzężenia wewnętrzne

Sprzężenie wewnętrzne — domyślny typ sprzężenia — pobiera jedynie rekordy mające taką samą wartość sprzęgniętych pól w obu tabelach. Program Microsoft Query łączy pasujące do siebie rekordy z każdej tabeli i wyświetla je w zestawie wyników.

Przykład sprzężenia wewnętrznego

Więcej informacji

Sprzęganie tabel w kwerendzie

Zmiana typu sprzężenia między tabelami w kwerendzie

Powrót do początku

Sprzężenia zewnętrzne

Sprzężenie zewnętrzne pobiera wszystkie rekordy z jednej tabeli i pasujące do nich rekordy z drugiej tabeli. Gdy wartości w dwóch tabelach są takie same, program Microsoft Query łączy pasujące rekordy i wyświetla je w zestawie wyników jako jeden rekord. Gdy rekord z tabeli, która udostępnia wszystkie swoje rekordy, nie ma odpowiednika w drugiej tabeli, rekord nadal występuje w zestawie wyników. Jednak program Microsoft Query wyświetla puste komórki tam, gdzie w drugiej tabeli nie ma odpowiedniego rekordu.

Przykład sprzężenia zewnętrznego

Więcej informacji

Sprzęganie tabel w kwerendzie

Zmiana typu sprzężenia między tabelami w kwerendzie

Powrót do początku

Samosprzężenia

Jeśli zachodzi potrzeba połączenia informacji znajdujących się w jednej tabeli, najlepiej jest użyć samosprzężenia. Na przykład w tabeli pracowników każdy rekord zawiera identyfikator pracownika kierownika każdego z pracowników. Ponieważ kierownik występuje w tej samej tabeli jako pracownik, można sprzęgnąć tabelę z samą sobą, tak aby było zwracane nazwisko i identyfikator pracownika kierownika.

Sprzęgnięcie tabeli z sobą samą umożliwia pobranie zarówno identyfikatora, jak i nazwiska kierownika.

Więcej informacji

Pobieranie wielu pól za pomocą samosprzężenia

Powrót do początku

Pełne sprzężenia zewnętrzne

Jeśli zachodzi potrzeba połączenia wszystkich danych z dwóch tabel, można utworzyć kwerendę pełnego sprzężenia zewnętrznego. Kwerenda tego typu zwraca wszystkie dane z obu tabel, nawet jeśli dane nie są ze sobą powiązane.

Tabele o podobnych danych przed utworzeniem pełnego sprzężenia zewnętrznego

Jeśli na przykład istnieją tabele Klienci i Zamówienia, można użyć pełnego sprzężenia zewnętrznego do zwrócenia wszystkich zamówień oczekujących (z tabeli Zamówienia) i wszystkich klientów, którzy nie dokonali zamówienia (z tabeli Klienci).

Zestaw wyników pokazujący klientów, którzy nie dokonali zamówień

Dwie pierwsze osoby na tej liście nie dokonały zamówień.

Uwaga W przypadku utworzenia pełnego sprzężenia zewnętrznego program Microsoft Query wyświetla jedynie zestaw wyników kwerendy, nie tabele używane w kwerendzie.

Więcej informacji

Łączenie wszystkich danych z dwóch tabel

Powrót do początku

Sprzężenia różnicowe

Jeśli istnieją dwie tabele zawierające podobne dane, na przykład dwie tabele klientów, a każda z nich zawiera informacje nieuwzględnione w drugiej tabeli, można utworzyć sprzężenie różnicowe. Sprzężenie różnicowe zwraca te jedynie rekordy z pierwszej tabeli, które nie mają swoich odpowiedników w drugiej tabeli.

Tabele o podobnych danych przed utworzeniem sprzężenia różnicowego

Dwie tabele o podobnych danych o klientach

Przykład sprzężenia różnicowego

Więcej informacji

Pobieranie rekordów, które nie powtarzają się w obu tabelach

Powrót do początku


Pobieranie rekordów z wielu tabel

Jeśli kwerenda zawiera więcej niż jedną tabelę, można pobrać pokrewne rekordy z wielu tabel, używając sprzężeń. Sprzężenie to łącze pomiędzy dwiema tabelami, gdzie pole w jednej tabeli zawiera te same dane, co pole w drugiej tabeli.

Co chcesz zrobić?

Dowiedzieć się więcej na temat pobierania rekordów za pomocą sprzężeń wewnętrznych i zewnętrznych

Utworzyć sprzężenie wewnętrzne

Utworzyć sprzężenie zewnętrzne

Utworzyć samosprzężenie

Pobrać wszystkie rekordy z dwóch tabel

Pobrać jedynie te rekordy, które nie należą do części wspólnej dwóch tabel


Łączenie wszystkich danych z dwóch tabel

Chcąc połączyć wszystkie dane z dwóch tabel o podobnych, ale nie identycznych, danych — takich jak dwie listy (tabele) klientów zawierające różne informacje (pola) dla każdego klienta, przy czym na każdej liście występują też klienci nieuwzględnieni na drugiej liście — można utworzyć kwerendę, która obejmuje wszystkich klientów. Ten typ kwerendy nazywa się pełnym sprzężeniem zewnętrznym. Zapoznaj się z pełnymi sprzężeniami zewnętrznymi

  1. W programie Microsoft Query utwórz kwerendę i dodaj do niej obie tabele.
  2. Dokonaj sprzężenia pola, które występuje w obu tabelach (na przykład pole Identyfikator klienta na dwóch listach klientów) przeciągając pole z pierwszej tabeli do drugiej tabeli.

    Wybierz pole, które zawiera informacje dla każdego rekordu w każdej tabeli. Na przykład, jeśli listy klientów mają odpowiadające sobie pola Identyfikator klienta, dokonaj sprzężenia pola Identyfikator klienta.

  3. Kliknij dwukrotnie linię sprzężenia między dwiema tabelami.
  4. W oknie dialogowym Sprzężenia kliknij opcję 2, kliknij przycisk Dodaj, a następnie kliknij przycisk Zamknij.
  5. Dodaj pola, które chcesz umieścić w kwerendzie.
  6. W menu Widok kliknij polecenie SQL.
  7. Wybierz dane w polu Instrukcja SQL, naciśnij klawisze CTRL+C, aby je skopiować, a następnie kliknij przycisk OK.
  8. Ponownie kliknij dwukrotnie linię sprzężenia.
  9. W oknie dialogowym Sprzężenia kliknij opcję 3, kliknij przycisk Dodaj, a następnie kliknij przycisk Zamknij.
  10. W menu Widok kliknij polecenie SQL.
  11. Kliknij na końcu danych w polu Instrukcja SQL, naciśnij klawisz ENTER, wpisz wielkimi literami UNION, a następnie ponownie naciśnij klawisz ENTER.
  12. Naciśnij klawisze CTRL+V, aby wkleić skopiowane informacje po słowie UNION.
  13. Kliknij przycisk OK i kiedy pojawi się monit, że nie można wyświetlić kwerendy graficznie, kliknij ponownie przycisk OK.


Pobieranie rekordów, które nie należą do części wspólnej dwóch tabel

Jeżeli istnieją dwie tabele, które zawierają podobne dane — np. dwie listy (tabele) klientów, przy czym w każdej tabeli są rekordy, których nie ma w drugiej tabeli — to można utworzyć kwerendę, która zwraca tylko te rekordy z pierwszej tabeli, które nie mają swoich odpowiedników w drugiej tabeli. Ten typ kwerendy nazywamy kwerendą różnicową lub sprzężeniem różnicowym.

  1. W programie Microsoft Query utwórz kwerendę i dodaj do niej obie tabele.
  2. Utwórz sprzężenie odpowiadających sobie pól z obydwu tabel (na przykład na listach klientów takim polem jest Identyfikator klienta), przeciągając pole pierwszej tabeli do tabeli drugiej.
  3. Kliknij dwukrotnie linię sprzężenia między dwiema tabelami.
  4. W oknie dialogowym Sprzężenia kliknij opcję 2, kliknij przycisk Dodaj, a następnie kliknij przycisk Zamknij.
  5. Dodaj sprzężone pole do kwerendy.
  6. Dodaj do kwerendy pole z drugiej tabeli inne niż pole, dla którego utworzono sprzężenie. Powinno to być pole, które we wszystkich rekordach drugiej tabeli zawiera jakieś dane. Na przykład, jeżeli utworzono sprzężenie pól Identyfikator klienta w obydwu tabelach, to można dodać do kwerendy pole Nazwa klienta z drugiej tabeli.
  7. W menu Widok kliknij polecenie Kryteria.
  8. W pierwszym polu kryteria kliknij pole, które zostało dodane w kroku 6.
  9. W pierwszym polu Wartość wpisz jest puste.
  10. Aby wybrać rekordy z pierwszej tabeli, które nie zostały dołączone do drugiej tabeli, kliknij przycisk Wykonaj kwerendę Obrazek przycisku.
  11. Dodaj inne pola, które chcesz umieścić w kwerendzie, a następnie zwróć dane do programu Microsoft Excel

Uwaga Chcąc również wybrać rekordy z drugiej tabeli, których nie ma w pierwszej tabeli, należy utworzyć w ten sam sposób drugą kwerendę, ale odwracając kolejność tabel (zamieniając je miejscami).


Tworzenie sprzężenia zewnętrznego

Sprzężenie zewnętrzne wyświetla wszystkie rekordy z jednej tabeli i związane z nimi rekordy z drugiej tabeli.

  1. Utwórz sprzężenie wewnętrzne między tabelami. Jak utworzyć sprzężenie wewnętrzne.
  2. Kliknij dwukrotnie linię sprzężenia między tabelami.
  3. Kliknij = (znak równości) na liście Operator.
  4. Wykonaj jedną z następujących czynności:

    Aby utworzyć sprzężenie zewnętrzne, które wykorzystuje wszystkie rekordy z tabeli po lewej stronie, kliknij opcję 2 w obszarze Sprzężenie zawiera.

    Aby utworzyć sprzężenie zewnętrzne, które wykorzystuje wszystkie rekordy z tabeli po prawej stronie, kliknij opcję 3 w obszarze Sprzężenie zawiera.

Uwagi

  • Pobieranie wszystkich rekordów z dwóch tabel Chcąc połączyć wszystkie rekordy z dwóch tabel, niezależnie od tego, czy są powiązane, można utworzyć pełne sprzężenie zewnętrzne.
  • Pobieranie jedynie tych rekordów, które nie należą do części wspólnej dwóch tabel Zamiast pobierać związane rekordy można pobrać wszystkie rekordy, które nie należą do części wspólnej dwóch tabel.


Tworzenie sprzężenia wewnętrznego

  • Przeciągnij pole z jednej tabeli do odpowiadającego mu pola (o takim samym typie danych zawierającego podobne dane) znajdującego się na liście pól drugiej tabeli.

Uwaga W przypadku sprzężenia wewnętrznego program Microsoft Query wybiera te rekordy z obydwu tabel lub kwerend, które zawierają identyczne wartości w połączonych polach. Można także utworzyć sprzężenie zewnętrzne, które pobiera wszystkie rekordy z jednej tabeli oraz skojarzone z nimi rekordy z drugiej tabeli.


Tworzenie samosprzężenia

Procedura ta umożliwia łączenie informacji zawartych w dwóch kopiach jednej tabeli, na przykład wtedy, gdy tabela informacji o pracownikach zawiera identyfikator pracownika każdego kierownika pracownika, a użytkownik chce połączyć identyfikator z nazwiskiem każdego kierownika. Procedura ta tworzy typ kwerendy zwany samosprzężeniem. Dowiedz się więcej o samosprzężeniach

  1. Utwórz kwerendę w programie Microsoft Query, a następnie dodaj tabelę, która ma zostać sprzężona w kwerendzie z samą sobą.
  2. Dodaj tę samą tabelę do kwerendy po raz drugi.
  3. Po pojawieniu się monitu informującego o tym, że tabela już istnieje w kwerendzie, kliknij przycisk OK.
  4. Jeśli kwerenda automatycznie sprzęgnie dwie tabele, kliknij dwukrotnie linię sprzężenia, kliknij przycisk Usuń, a następnie kliknij przycisk Zamknij.
  5. Utwórz sprzężenie wewnętrzne między tabelami. Jeśli na przykład pole Kierownik w celu identyfikacji kierowników korzysta z identyfikatora pracownika, można sprzęgnąć pole Kierownik znajdujące się w pierwszej tabeli z polem Identyfikator pracownika znajdującym się w drugiej tabeli.
  6. Dodaj pola, które mają się znaleźć w kwerendzie. Można na przykład dodać pola Nazwisko pracownika i Kierownik z pierwszej tabeli, a następnie dodać pole Nazwa pracownika z drugiej tabeli, co spowoduje wyświetlenie nazwiska kierownika każdego z pracowników.


Operatory w sprzężeniu

W sprzężeniach można używać następujących operatorów.

Operator | Opis
= (Równe) | Wybiera rekordy zawierające równe wartości w sprzężonych polach.
<> (Nierówne) | Wybiera rekordy zawierające nierówne wartości w sprzężonych polach.
> (Większe niż) | Wybiera te rekordy z lewej tabeli, które zawierają w sprzężonych polach większe wartości niż rekordy z prawej tabeli.
>= (Większe niż lub równe) | Wybiera te rekordy z lewej tabeli, które zawierają w sprzężonych polach wartości równe wartościom rekordów z prawej tabeli lub większe od nich.
< (Mniejsze niż) | Wybiera te rekordy z lewej tabeli, które zawierają w sprzężonych polach mniejsze wartości niż rekordy z prawej tabeli.
<= (Mniejsze niż lub równe) | Wybiera te rekordy z lewej tabeli, które zawierają w sprzężonych polach wartości równe wartościom rekordów z prawej tabeli lub mniejsze od nich.


Usuwanie sprzężenia

Jeżeli kwerenda zawiera sprzężenie wewnętrzne lub sprzężenie zewnętrzne, ale nie pobiera właściwych rekordów, to być może należy usunąć sprzężenie.

  1. W okienku tabel, kliknij linię sprzężenia, które chcesz usunąć.
  2. Naciśnij klawisz DELETE.

Uwagi

  • Po usunięciu sprzężenia rekordy dołączone do zestawu wyników kwerendy zostaną zmienione. W zależności od typu usuniętego sprzężenia, rekordy mogą być dodawane lub usuwane z zestawu wyników.
  • Usuwanie sprzężenia z kwerendy wpływa tylko na tę kwerendę. Na przykład, jeżeli program Microsoft Query automatycznie tworzy sprzężenie wewnętrzne pomiędzy dwiema tabelami w kwerendzie, a następnie sprzężenie zostanie usunięte, to program Microsoft Query automatycznie utworzy sprzężenie wewnętrzne między tymi tabelami w innej kwerendzie korzystającej z tych tabel.


Korzystanie z kryteriów — informacje

Temat ten zawiera następujące informacje:

Co to są kryteria?

Spełnianie pojedynczego warunku

Spełnianie wielu warunków

Wyszukiwanie podobnych rekordów

Określanie zakresu wartości

Korzystanie z obliczania

Wykluczanie określonych rekordów

Wyszukiwanie niepełnych rekordów

Co to są kryteria?

Kryteria są warunkami podawanymi w celu odnalezienia konkretnych rekordów w bazie danych lub na liście. Użycie kryteriów ogranicza zakres rekordów (lub wierszy) umieszczonych w zestawie wyników kwerendy. Na przykład kryterium CenaJednostkowa > 30 spowoduje wybranie rekordów, dla których wartość w polu CenaJednostkowa jest większa niż 30. Kryteria w programie Microsoft Query są dodawane w okienku kryteriów przez bezpośrednie ich wprowadzanie w okienku lub użycie polecenia Dodaj kryteria, dostępnego w menu Kryteria. Pola używane do określenia kryteriów nie muszą być uwzględniane w zestawie wyników.

Ponieważ kwerenda może zawierać wiele tabel z polami o podobnych nazwach, upewnij się, że używane jest pole z właściwej tabeli. Na przykład, jeśli mają zostać odnalezieni wszyscy dostawcy z danego kraju, należy wybrać pole Kraj z tabeli Dostawcy, a nie z tabeli Klienci.

Więcej informacji

Określanie rekordów do pobrania przy użyciu kryteriów

Powrót do początku

Spełnianie pojedynczego warunku

Można wyszukać wszystkie rekordy o wartościach spełniających pojedynczy warunek, na przykład określony kraj lub produkt. W poniższym przykładzie pokazano kryteria służące do pobrania wszystkich rekordów, w których w polu Kraj wpisana jest wartość Szwecja.

Przykład pojedynczego kryterium

Aby określić pojedyncze kryterium, wybierz nazwę pola w polu Pole kryterium, a następnie wpisz żądaną wartość w polu Wartość.

Więcej informacji

Przykłady wyrażeń zawierających operatory logiczne

Powrót do początku

Spełnianie wielu warunków

Spełnianie warunków określonych w co najmniej dwóch polach Można wyszukać wszystkie rekordy o wartościach spełniających jeden warunek określony w jednym polu i drugi warunek określony w innym polu. Mogą to być na przykład wszystkie rekordy zamówień dokonanych w Stanach Zjednoczonych w stanie Waszyngton. Aby wybrać te rekordy, w okienku Kryteria należy wpisać dwa zestawy kryteriów. W celu określenia wielu warunków, z których wszystkie są prawdziwe, używa się warunku AND.

Kryteria spełniające warunek AND

Aby wyszukać rekordy, które spełniają co najmniej dwa warunki, należy określić pola kryteriów dla każdego warunku.

Spełnianie wielu warunków określonych w jednym polu Można wyszukać wszystkie rekordy o wartościach spełniających wiele warunków określonych w tym samym polu. Mogą to być na przykład wszystkie rekordy klientów w Stanach Zjednoczonych i Meksyku. Aby wybrać te rekordy, w okienku Kryteria należy wpisać dwa zestawy kryteriów. W celu określenia kilku kryteriów, wśród których jedno jest prawdziwe, używa się warunku OR. W przypadku warunku OR musi być prawdziwy tylko jeden warunek z dwóch (albo większej ich liczby).

Kryteria spełniające warunek OR

Kryteria wyboru wszystkich klientów z Meksyku lub Stanach Zjednoczonych.

Uwaga Można również użyć operatora Or wewnątrz wartości kryterium. Na przykład, zamiast wpisywać Meksyk w polu Or, można wpisać USA Or Meksyk w polu Wartość.

Więcej informacji

Przykłady wyrażeń zawierających operatory logiczne

Powrót do początku

Wyszukiwanie podobnych rekordów

Można wyszukać rekordy, których wartości w jednym z pól są podobne do siebie, jak numery telefonu o tym samym numerze kierunkowym. Może to na przykład dotyczyć klientów, których numery telefonu zaczynają się od numeru kierunkowego (171) lub numeru kierunkowego kraju (1) i (11).

Kryteria wykorzystujące operator Like

Aby użyć operatora Like, wpisz słowo Like, a następnie w pojedynczym cudzysłowie wpisz wartość, jaka ma zostać odnaleziona.

Uwaga Znak procent (%) w przykładzie powyżej jest symbolem wieloznacznym, odpowiadającym dowolnej liczbie znaków. Jeśli symbol wieloznaczny ma dotyczyć jednego znaku, należy użyć podkreślenia (_). Używane symbole wieloznaczne mogą się zmieniać zależnie od źródła danych. Więcej informacji o symbolach wieloznacznych obsługiwanych przez sterownik można znaleźć w dokumentacji sterownika źródła danych.

Więcej informacji

Przykłady wyrażeń zawierających operatory innego typu

Powrót do początku

Określanie zakresu wartości

Można wyszukać wszystkie rekordy, które odpowiadają danemu zakresowi wartości lub dat. Może to być na przykład wyszukanie wszystkich rekordów dotyczących zamówień złożonych między 1 listopada 1998 a 31 grudnia 1998. Aby określić dwa lub więcej warunków, które muszą być spełnione, należy utworzyć warunek AND. Warunek AND podaje się w celu zdefiniowania zakresu wartości.

Przykład zakresu z dwoma kryteriami

Warunek AND, w którym wykorzystywane są dwa przypadki wystąpienia tego samego pola w okienku kryteriów.

Zakres uwzględniający operator And

Warunek AND, w którym dolny i górny limit są rozdzielone operatorem And.

Uwaga Podczas wpisywania daty w okienku kryteriów program Query konwertuje ją na format interpretowany przez siebie. Jeśli na przykład jako kryterium zostanie podana data >1998-10-31, program Query skonwertuje ją na >#98-10-31#.

Więcej informacji

Przykłady wyrażeń zawierających operatory porównania

Powrót do początku

Korzystanie z obliczania

Może zaistnieć potrzeba zlokalizowania rekordów odpowiadających wynikowi obliczeń, na przykład wszystkich rekordów, dla których suma zamówienia jest większa od sumy wynikającej z pomnożenia pola ceny przez pole ilości.

Przykład kryteriów obliczanych

Aby wyszukać wszystkie rekordy, w których suma zamówień jest większa od 500 zł, należy utworzyć formułę do obliczania sumy zamówienia, a następnie podać kryteria.

Więcej informacji

Przykłady wyrażeń zawierających operatory arytmetyczne

Powrót do początku

Wykluczanie określonych rekordów

Zamiast lokalizować rekordy odpowiadające danej wartości, można wyszukiwać te, które im nie odpowiadają. Na przykład można użyć operatora Not do wyszukania wszystkich rekordów dostawców spoza Stanów Zjednoczonych.

Kryteria wykorzystujące operator Not

Operatora Not należy używać do wykluczania rekordów.

Więcej informacji

Przykłady wyrażeń korzystających z operatorów logicznych

Powrót do początku

Wyszukiwanie niepełnych rekordów

Można wyszukiwać rekordy, w których brak jest wartości lub są one niepełne. Na przykład użycie operatora Is Null umożliwia wyszukiwanie rekordów pracowników, w przypadku których brakuje nazwiska kierownika.

Kryteria, w których wykorzystywany jest operator Is Null

Operatora Is Null należy używać do lokalizowania rekordów o pustych polach.

Więcej informacji

Przykłady wyrażeń zawierających operatory innego typu

Powrót do początku


Ograniczanie pobieranych rekordów za pomocą kryteriów

Można pobrać wybrane rekordy, korzystając z kryteriów. Program Microsoft Query używa kryteriów użytkownika do pobierania określonych rekordów, które następnie wyświetla w zestawie wyników. Aby ograniczyć liczbę pobieranych rekordów, można wybrać wartość z zestawu wyników, a następnie odnaleźć na jej podstawie inne rekordy. Można również utworzyć określone kryteria w okienku kryteriów i pobrać wyłącznie rekordy spełniające te kryteria.

Co chcesz zrobić?

Dowiedzieć się więcej na temat używania kryteriów

Pobrać rekordy zawierające określoną wartość

Określić za pomocą kryteriów, które rekordy mają być pobrane

Zobaczyć przykładowe wyrażenia, które można stosować jako kryteria


Określanie rekordów do pobrania przy użyciu kryteriów

  1. Kliknij przycisk Pokaż/Ukryj kryteria Obrazek przycisku.

    Program Microsoft Query wyświetli okienko kryteriów.

  2. W okienku kryteriów kliknij pierwszą komórkę w wierszu Pole kryterium, a następnie kliknij nazwę pola, do którego mają zostać zastosowane kryteria.

    Jeżeli kwerenda korzysta z wielu tabel z podobnymi nazwami pól, upewnij się, że zostało wybrane pole z właściwej tabeli.

  3. W wierszu Wartość kliknij komórkę znajdującą się pod nazwą pola wybraną w wierszu Pole kryterium.
  4. Wpisz kryterium, które ma zostać zastosowane do wybierania rekordów, i naciśnij klawisz ENTER.

    Jak?

  5. Jeśli nie zostało to jeszcze zrobione, dodaj inne pola, które mają być wyświetlane w zestawie wyników.

    Jak?

    Jeżeli mają być wyświetlane rekordy z różnych tabel, upewnij się, że te tabele zostały dodane w okienku tabel kwerendy. Aby uzyskać więcej informacji o dodawaniu tabel, kliknij przycisk Obrazek przycisku .

Uwagi

  • Można zawęzić zawartość zestawu wyników, dodając kolejne kryteria w okienku kryteriów. Można na przykład wyszukać wszystkie rekordy dotyczące dostawców produktów nabiałowych, pochodzących z Norwegii lub Włoch. Aby wybrać te rekordy, należy wpisać dwa zestawy kryteriów w okienku kryteriów. Najpierw w polu Pole kryterium kliknij pozycję Kraj, a następnie w polu Wartość wpisz Norwegia Lub Włochy. W następnym polu Pole kryterium kliknij pozycję Kategoria i w odpowiadającym mu polu Wartość wpisz =Nabiał.
  • Jeżeli wartość, która ma być użyta w kryterium, znajduje się już w zestawie wyników, można ją skopiować do okienka kryteriów. W tym celu zaznacz tę wartość w zestawie wyników, w menu Edycja kliknij polecenie Kopiuj, a następnie w wierszu Wartość zaznacz komórkę, w której ma być umieszczona wartość, i w menu Edycja kliknij polecenie Wklej.
  • Aby uniknąć długotrwałego oczekiwania na przesłanie danych z pól, można wykonać wyszukiwanie danych dopiero po dodaniu wszystkich pól do zestawu wyników. Chcąc odczekać na pobranie danych, upewnij się, że przycisk Autokwerenda Obrazek przycisku nie jest wciśnięty. Po przygotowaniu kwerendy kliknij przycisk Wykonaj kwerendę Obrazek przycisku.
  • Wykonanie czasochłonnej kwerendy można przerwać, naciskając klawisz ESC.


Pobieranie rekordów zawierających określoną wartość

  1. Upewnij się, że jest wciśnięty przycisk Autokwerenda Obrazek przycisku.
  2. Dodaj pole, do którego chcesz zastosować określone kryteria, do okienka danych.

    Jak?

    Na przykład chcąc pobrać rekordy, które w polu Kraj zawierają nazwę Francja, należy dodać pole Kraj do okienka danych.

  3. W zestawie wyników kliknij komórkę zawierającą odpowiednią wartość.
  4. Kliknij przycisk Kryteria równe Obrazek przycisku.


Przywracanie pełnego zestawu wyników przez usunięcie kryteriów

Jeśli kwerenda zawiera wiele rekordów, można zaoszczędzić czas dzięki odświeżaniu zestawu wyników dopiero po usunięciu wszystkich kryteriów. W tym celu należy się upewnić, że przycisk Autokwerenda Obrazek przycisku nie jest wciśnięty.

  1. W okienku kryteriów kliknij nagłówek kolumny zawierającej kryteria, które chcesz usunąć.
  2. Naciśnij klawisz DELETE.

    Powtórz kroki 1 i 2 dla każdego zestawu kryteriów, który chcesz usunąć.

    Aby jednocześnie usunąć wszystkie kryteria, w menu Kryteria kliknij polecenie Usuń wszystkie kryteria.

Uwaga Jeśli przycisk Autokwerenda nie jest wciśnięty, należy nacisnąć przycisk Wykonaj kwerendę Obrazek przycisku, aby przywrócić pełen zestaw wyników.


Wyrażenia — informacje

Wyrażenie jest to obliczenie, w którym wykorzystywana jest kombinacja operatorów, funkcji, nazw pól i stałych.

Wyrażenie może być stosowane jako kryterium wyboru rekordów. Aby użyć wyrażenia znajdującego się w okienku kryteriów, w polu Pole kryterium należy wybrać nazwę pola zawierającego wartości, które mają być użyte w obliczeniach, a następnie wprowadzić operator i wartość w polu Wartość. Podczas wybierania pola kryterium należy się upewnić, że jest ono wybierane z właściwej tabeli.

Wyrażenia korzystające z operatorów arytmetycznych Aby pobrać rekordy w oparciu o wyniki obliczeń, należy utworzyć wyrażenie korzystające z arytmetycznych operatorów dodawania, odejmowania, mnożenia lub dzielenia. Zobacz przykłady wyrażeń wykorzystujących operatory arytmetyczne.

Wyrażenia korzystające z operatorów porównania Operatory porównania służą do porównywania dwóch wartości. Na przykład aby znaleźć zamówienia, w których liczba sprzedanych jednostek jest większa niż 1000, jako kryterium dla pola Ilość należy wpisać >1000. Zobacz przykłady wyrażeń wykorzystujących operatory porównania.

Wyrażenia korzystające z operatorów logicznych Operatory logiczne służą do porównywania wartości, podobnie jak operatory porównania. Na przykład, aby pobrać wszystkie rekordy dotyczące sprzedaży poza Francją, jako kryterium w polu Kraj należy użyć wyrażenia Nie Francja. Zobacz przykłady wyrażeń wykorzystujących operatory logiczne.

Wyrażenia korzystające z innych typów operatorów Można korzystać z innych operatorów, które umożliwiają na przykład odnajdywanie wartości należących do określonego zbioru, określenie, czy rekord zawiera lub nie zawiera wartości w określonym polu lub wyszukiwanie rekordów przy użyciu symboli wieloznacznych. Zobacz przykłady wyrażeń wykorzystujących inne typy operatorów.


Przykłady wyrażeń

Wyrażenie jest obliczeniem wykorzystującym kombinację operatorów, funkcji, nazw pól i stałych. Wyrażenie może być stosowane jako kryterium wyboru rekordów. Aby użyć wyrażenia w okienku kryteriów, należy wybrać w polu Pole kryterium nazwę pola zawierającego wartości, które mają być użyte w obliczeniach, a następnie wprowadzić operator i wartość w polu Wartość.

Jaki przykład chcesz obejrzeć?

Wyrażenia z operatorami arytmetycznymi

Wyrażenia z operatorami porównania

Wyrażenia z operatorami logicznymi

Wyrażenia z operatorami innego typu

Nie masz pewności, co wybrać?


Przykłady wyrażeń wykorzystujących operatory arytmetyczne

Operatory arytmetyczne wykonują podstawowe operacje matematyczne, takie jak dodawanie, odejmowanie, mnożenie i dzielenie, i dają w wyniku liczby. Operatorów arytmetycznych można używać w wyrażeniach w okienku kryteriów lub w polach obliczeniowych.

Operator arytmetyczny | Znaczenie | Przykład | Składnia
+ (znak plus) | Dodawanie | Suma należności klienta | Wartość_zamówienia+Transport
— (znak minus) | Odejmowanie | Należność klienta z uwzględnieniem rabatu | Wartość_zamówienia-Rabat
* (gwiazdka) | Mnożenie | Wartość zamówienia określonego towaru | Cena*Ilość
/ (kreska ukośna w prawo) | Dzielenie | Cena towaru | Wartość/Ilość


Przykłady wyrażeń z operatorami porównania

Operatory porównania są stosowane w wyrażeniach używanych jako kryteria wyboru rekordów i ograniczania zestawu wyników.

Operator porównania | Znaczenie | Przykład | W polu Pole kryterium, kliknij | W polu Wartość wpisz
= (znak równości) | Równy | Znajdowanie rekordów klientów z Niemiec | Kraj | =Niemcy
<> (znak nierówności) | Nie równy | Znajdowanie rekordów dostawców spoza Polski | Kraj | <>Polska
> (znak większe niż) | Większy niż | Znajdowanie rekordów zamówień złożonych po pewnej dacie | Data_zamówienia | >6/30/2000
< (znak mniejsze niż) | Mniejszy niż | Znajdowanie rekordów zamówień złożonych przed pewną datą | Data_zamówienia | <6/30/2000
>= (znak większe lub równe) | Większy niż lub równy | Znajdowanie rekordów zamówień złożonych po pewnej dacie lub dokładnie tego dnia | Data_zamówienia | >=6/30/2000
<= (znak mniejsze niż lub równe) | Mniejszy niż lub równy | Znajdowanie rekordów zamówień złożonych przed pewną datą lub dokładnie tego dnia | Data_zamówienia | <=6/30/2000


Przykłady wyrażeń z operatorami logicznymi

Operatory logiczne porównują dwie wartości.

Operator logiczny | Znaczenie | Przykład | W polu Pole kryterium, kliknij | W polu Wartość wpisz
Oraz | Dla rekordów zestawu wyników dwie wartości w polu muszą mieć wartość Prawda. | Znajdowanie rekordów dla zamówień złożonych w pewnym okresie | Data_zamówienia | >6/5/2000 Oraz <6/23/2000
Lub | Dla rekordów zestawu wyników jedno z dwóch kryteriów musi mieć wartość Prawda. | Znajdowanie rekordów dostawców z dwóch krajów | Kraj | USA Lub Brazylia
Nie | Dla rekordów zestawu wyników to kryterium nie może przyjmować wartości Prawda. | Znajdowanie rekordów dostawców spoza Polski | Kraj | Nie Polska


Przykłady wyrażeń z operatorami innego typu

W poniższej tabeli przedstawiono listę operatorów, które umożliwiają wybranie zakresu wartości, odnalezienie wartości równych wielu innym wartościom, określenie, czy w danym polu rekordu znajduje się jakaś wartość oraz odnalezienie rekordów za pomocą symboli wieloznacznych.

Operator | Znaczenie | Przykład | W polu Pole kryterium, kliknij | W polu Wartość, wpisz
Between | Sprawdza, czy wartość mieści się w zakresie między dwoma wartościami, włącznie z wartościami skrajnymi | Znajdowanie rekordów, dla których wartość zamówienia mieści się pomiędzy 1000 zł i 3000 zł | Wartość_Zamówienia | Between 1000 Oraz 3000
In | Sprawdza, czy wartość jest równa jednej z wartości znajdujących się na liście | Znajdowanie rekordów klientów z Poznania, Wrocławia i Zakopanego | Miasto | In('Poznań', 'Wrocław', 'Zakopane')
Is Null | Sprawdza, czy dane pole rekordu jest puste | Znajdowanie rekordów pracowników, w których nie wpisano nazwiska przełożonego | Szef | Is Null
Is Not Null | Sprawdza, czy w danym polu rekordu znajduje się wartość | Znajdowanie rekordów pracowników, w których wpisano nazwisko przełożonego | Szef | Is Not Null
Like | Operator Like w połączeniu z symbolem wieloznacznym % służy do porównywania dwóch wartości | Znajdowanie rekordów pracowników, których nazwiska rozpoczynają się od liter "Ko", np. Kowal, Kokoszka | Nazwisko | Like ' Ko%'


Tworzenie pola obliczeniowego

Można wyświetlić wyniki wybranego obliczenia, tworząc nowe pole nazywane polem obliczeniowym. Pole obliczeniowe można utworzyć, wpisując wyrażenie, składające się z operatorów, funkcji, nazw pól i stałych. Aby wykonać obliczenia w polu, można również użyć wbudowanej funkcji.

Co chcesz zrobić?

Utworzyć pole obliczeniowe za pomocą wyrażenia

Utworzyć pole obliczeniowe za pomocą wbudowanej funkcji


Tworzenie pola obliczeniowego za pomocą wyrażenia

  1. W okienku danych kliknij pusty nagłówek kolumny.
  2. Wpisz wyrażenie dla obliczenia, a następnie naciśnij klawisz ENTER. Wyrażenia nie należy rozpoczynać od znaku równości (=).

    Na przykład jeżeli pracownicy mają otrzymać premię równą 15 procentom całkowitych zarobków, to można obliczyć wysokość premii, dodając zarobki każdego pracownika, a następnie mnożąc sumę przez 0,15.

    Aby zobaczyć przykłady wyrażeń z operatorami arytmetycznymi, kliknij przycisk Obrazek przycisku .


Tworzenie pola obliczeniowego za pomocą funkcji

  1. Dodaj pole zawierające wartości, które chcesz obliczyć.

    Jak?

  2. Kliknij w dowolnym miejscu pola, które chcesz obliczyć, a następnie kliknij przycisk Zmień typ obliczeń Obrazek przycisku.
  3. Klikaj przycisk Zmień typ obliczeń do momentu wyświetlenia odpowiedniego typu obliczeń.

    Przy każdym kliknięciu przycisku Zmień typ obliczeń program Microsoft Query oblicza i wyświetla inny typ obliczeń (używana funkcja jest wskazana w nagłówku kolumny). Aby zobaczyć opis funkcji, które mogą być użyte do tworzenia obliczeń w polu obliczeniowym, kliknij przycisk Obrazek przycisku .

  4. Po wybraniu funkcji generującej właściwy typ obliczeń kliknij przycisk Wykonaj kwerendę Obrazek przycisku, aby wyświetlić wyniki pola obliczeniowego.

Uwagi

  • Aby usunąć obliczenie z pola, klikaj przycisk Zmień typ obliczeń do momentu, gdy w nagłówku kolumny pojawi się oryginalna nazwa pola.
  • Jeżeli kwerenda zawiera wiele rekordów, to jej wykonanie przy każdej zmianie typu obliczeń może być czasochłonne. Upewnij się, że nie jest wciśnięty przycisk Autokwerenda Obrazek przycisku.


Funkcje stosowane w polu obliczeniowym

Funkcja zwraca wartość na podstawie wyników obliczeń lub innych operacji. Na przykład funkcja SUMA zwraca sumę dwóch lub większej liczby wartości. W poniższej tabeli przedstawiono funkcje dostępne w programie Microsoft Query. Funkcje dostępne w źródle danych zależą od wybranego dla tego źródła sterownika ODBC. Aby zobaczyć funkcje dostępne w przypadku bieżącego źródła danych, należy kliknąć dowolne pole liczbowe, a następnie kliknąć przycisk Zmień typ obliczeń Obrazek przycisku.

Aby zwrócić | Użyj
Średnią ze zbioru wartości w polu | ŚREDNIA
Całkowitą liczbę rekordów | ILE.LICZB
Maksymalną wartość zbioru wartości w polu | MAX
Minimalną wartość zbioru wartości w polu | MIN
Sumę zbioru wartości w polu | SUMA


Zmienianie układu zestawu wyników

Wstawienie pól lub zmiana kolejności pól powoduje zmianę układu, która jest zachowywana w czasie działania programu Microsoft Query i po powrocie do zestawu wyników w programie Microsoft Excel.

Co chcesz zrobić?

Zmienić kolejność pól w zestawie wyników

Wstawić pole w zestawie wyników


Formatowanie danych w programie Microsoft Query

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Program Microsoft Query zapisuje zmiany w momencie zapisywania kwerendy. Formatowanie danych wprowadzone w programie Microsoft Query nie jest zachowywane po powrocie do zestawu wyników programu Microsoft Excel. Zmiana kolejności pól lub pól uwzględnionych w zestawie wyników jest zachowywana po powrocie do programu Excel.

Co chcesz zrobić?

Zmienić nagłówek kolumny na bardziej opisowy

Zmienić szerokość kolumny lub wysokość wierszy

Zmienić czcionkę, styl i rozmiar tekstu w zestawie wyników

Ukryć lub wyświetlić pole w zestawie wyników

Zmienić układ zestawu wyników


Przechodzenie do wybranego rekordu w zestawie wyników

  1. W menu Rekordy kliknij polecenie Idź do.
  2. Wpisz numer rekordu, do którego chcesz przejść.


Sortowanie rekordów kwerendy

  1. Upewnij się, że jest wciśnięty przycisk Autokwerenda Obrazek przycisku.
  2. W zestawie wyników kliknij w polu, według którego chcesz sortować.
  3. Aby posortować rekordy według rosnącej kolejności sortowania, kliknij przycisk Sortuj rosnąco Obrazek przycisku.

    Aby sortować rekordy w kolejności malejącej, kliknij przycisk Sortuj malejąco Obrazek przycisku.

Uwagi

  • Aby posortować jednocześnie wiele kolumn, należy rozmieścić je w okienku danych od lewej do prawej, zgodnie z wybraną kolejnością sortowania. Należy nacisnąć klawisz SHIFT i kliknąć nagłówki kolumn, aby zaznaczyć kolumny, które trzeba dołączyć do sortowania, a następnie kliknąć przycisk Sortuj rosnąco lub Sortuj malejąco.
  • Aby przywrócić oryginalną kolejność rekordów, należy kliknąć polecenie Sortuj w menu Rekordy. W polu Sortowania w kwerendzie należy kliknąć pole, w którym trzeba usunąć kolejność sortowania, a następnie kliknąć przycisk Usuń.
  • Jeżeli po posortowaniu rekordów zmieniono kolejność kolumn w zestawie wyników, to kolejność sortowania pozostanie niezmieniona.


Wyświetlanie różnych pól w kwerendzie

  1. W menu Format kliknij polecenie Pokaż kolumny.
  2. Aby tymczasowo uniemożliwić wyświetlanie kolumny w okienku danych, kliknij kolumnę, a następnie kliknij polecenie Ukryj.

    Aby ponownie wyświetlić kolumnę, kliknij jej nazwę, a następnie kliknij polecenie Pokaż.

Uwaga Ukryte pola są uwzględniane podczas zwracania zestawu wyników do programu Microsoft Excel. Jeśli ukryte pola mają być pomijane, przed zwróceniem wyników do programu Microsoft Excel należy usunąć pola z okienka danych.


Wprowadzanie zmian do danych w bazie danych, której dotyczy kwerenda — informacje

Zmiana bazy danych, z której pobrano dane W niektórych przypadkach programu Microsoft Query można użyć w celu zmiany danych w zewnętrznej bazie danych lub usuwania danych z zewnętrznej bazy danych. Po wprowadzeniu zmian w wynikach kwerendy program Microsoft Query zmienia także dane w źródłowej tabeli używanej w kwerendzie.

Warunki uniemożliwiające wprowadzanie zmian w bazie danych W następujących sytuacjach nie można zmienić danych w bazie, której dotyczy kwerenda:

  • ródło danych jest chronione przed wprowadzaniem zmian lub nie zezwala na wprowadzanie zmian.
  • Kwerenda zawiera więcej niż jedną tabelę.
  • Kwerenda zawiera sumy lub wyrażenia niestandardowe.
  • Pole, które próbujesz zmienić, jest zablokowane lub wyłączone, lub znajduje się w rekordzie, który jest zablokowany.
  • Typ danych, które próbujesz wprowadzić, nie jest prawidłowy dla bazy danych. Zależnie od bazy danych, którą próbujesz zmieniać, może wystąpić konieczność wprowadzenia w polu określonej wartości.
  • Administrator uniemożliwił korzystanie z funkcji modyfikacji bazy danych.


Wprowadzanie zmian w danych bazy danych, w której wykonano kwerendę

Co chcesz zrobić?

Dowiedzieć się więcej na temat wprowadzania zmian w bazie danych, w której wykonano kwerendę

Zmienić dane w bazie danych, w której wykonano kwerendę

Usunąć dane z bazy danych, w której wykonano kwerendę

Cofnąć zmiany wprowadzone w danych bazy danych, w której wykonano kwerendę


Korzystanie z dynamicznej wymiany danych (DDE) w programie Microsoft Query

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Program Microsoft Query obsługuje mechanizm dynamicznej wymiany danych (DDE), który jest formą komunikacji między dwoma programami umożliwiającą wzajemną wymianę danych. Metody DDE mogą być stosowane w języku Visual Basic for Applications do komunikowania się i przesyłania danych pomiędzy programem Microsoft Query i innym programem, takim jak Microsoft Excel.

Objaśnienie sposobu korzystania z DDE

Otwieranie kanału DDE

Wykonywanie poleceń DDE

Objaśnienie dostępnych poleceń DDE

Żądanie stanu i innych informacji

Pobieranie danych

Wychodzenie z programu Microsoft Query w DDE

Zamykanie kanału DDE

Używanie programu Microsoft Query z innymi programami


Polecenia DDE

Aby wyświetlić odpowiednie informacje, kliknij polecenie lub żądanie.

Activate

AddParameters

AllowEdit

BuildODBC

BuildSQL

Close

Command

EnableParameters

EnableTensor

Exit

Fetch oraz Fetch.Advise

Fetch.Unadvise

Logoff

Logon

LogonNow

ODBCLogon

Open

ParameterNames2

QueryNow

QueryType

SaveAs

SetParameterName

SetQueryName

SetQueryType

SetWindowState

UserControl

UserControl2

ViewPane


Rozwiązywanie problemów dotyczących programu Microsoft Query

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Tworzenie i korzystanie ze źródeł danych

Nie mogę utworzyć nowego źródła danych

Nie mogę znaleźć albo usunąć źródła danych

Dlaczego obok nazwy źródła danych jest umieszczona gwiazdka?

Używany wcześniej sterownik ODBC nie działa

Tworzenie kwerend

Nie mogę odnaleźć żądanej tabeli

Nie mogę utworzyć potrzebnych sprzężeń

Sprzężenia nie wybierają właściwych rekordów

Nie mogę edytować typów parametrów w procedurze języka SQL

Nie mogę edytować kwerendy

Pobieranie danych

Komunikat sygnalizuje, że ścieżka do bazy danych jest niepoprawna

Program Microsoft Query wielokrotnie zgłasza błąd przekroczenia czasu, a połączenie z bazą danych nie następuje

Nie mogę uzyskać dostępu do danych z listy programu Microsoft Excel

Program Microsoft Query nie przerywa połączenia, mimo że baza danych nie jest używana

Program Microsoft Query nie zwraca wszystkich dostępnych rekordów

Praca w programie Microsoft Query

Dlaczego nie mogę kontynuować pracy w programie Microsoft Query?

Zmiany i formatowanie wprowadzone w kwerendzie nie pojawiają się przy następnym uruchomieniu

Nie mogę wydrukować zestawu wyników w programie Microsoft Query

Nie mogę utworzyć etykiet adresowych w programie Microsoft Query

Nie mogę zapisać zestawu wyników jako tabeli w bazie danych.

Nie mogę dodać, skopiować lub przenieść rekordu w bazie danych


Rozwiązywanie problemów z kwerendami i modułami OLAP

Funkcja podsumowania potrzebna dla danych modułu jest niedostępna

Pola daty lub godziny są niepoprawnie dzielone

Gdy próbuję zapisać plik modułu offline, brakuje miejsca na dysku

Nie mogę dodać pól do modułu OLAP

Nie mogę zmienić modułu OLAP

Przy zmianie modułu OLAP pojawia się komunikat o utracie danych

Pojawia się komunikat, że Kreator modułów OLAP nie może otworzyć pliku oqy


Jak program Microsoft Query obsługuje daty z rokiem 2000

Lata należy określać przy użyciu czterech cyfr Aby mieć pewność, że wartości określające rok są pobierane i interpretowane we właściwy sposób, należy zadbać o to, by w zewnętrznych bazach danych wartości określające rok były przechowywane jako cztery cyfry (np. 2001, a nie 01), jeśli jest to tylko możliwe.

Programy Microsoft Query i Microsoft Excel spójnie interpretują daty o zapisie dwucyfrowym Programy Microsoft Query i Microsoft Excel identycznie interpretują daty o zapisie dwucyfrowym. Podczas wyświetlania w programie Microsoft Query dat zawierających dwucyfrowe oznaczenie roku i po zwróceniu ich do programu Microsoft Excel, wartości określające rok są te same w obu programach.

Jak program Microsoft Query interpretuje dwucyfrowy zapis roku Kiedy program Microsoft Query pobiera z zewnętrznej bazy danych wartość roku zapisaną za pomocą dwóch cyfr, interpretuje tę wartość w następujący sposób:

  • Wartości określające rok w przedziale od 00 do 29 Dwucyfrowe wartości określające rok, zawierające się w przedziale od 00 do 29, są interpretowane jako lata od 2000 do 2029. Na przykład, jeśli program Microsoft Query pobierze z zewnętrznej bazy danych datę 19-05-28, to zinterpretuje ją jako 28 maja 2019 roku.
  • Wartości określające rok w przedziale od 30 do 99 Dwucyfrowe wartości określające rok, zawierające się w przedziale od 30 do 99, są interpretowane jako lata od 1930 do 1999. Na przykład, jeśli program Microsoft Query pobierze z zewnętrznej bazy danych datę 98-05-28, to zinterpretuje ją jako 28 maja 1998 roku.

Administratorzy mają możliwość zmiany sposobu interpretacji dat Administrator systemu może skonfigurować pakiet Microsoft Office w taki sposób, by interpretacją dat rządziły zróżnicowane reguły. Może on na przykład zmienić wartość roku interpretowaną jako początek okresu przyszłego z 29 na inną. Aby sprawdzić, czy w systemie zmieniono sposób interpretacji dat, należy skontaktować się z administratorem.


Wykonanie kwerendy jest niemożliwe. Wyświetlić tekst SQL?

Program Microsoft Query nie może uruchomić instrukcji SQL, ponieważ odwołuje się ona do nieprawidłowego elementu. Na przykład odwołuje się do tabeli, która już nie istnieje. Aby wyświetlić instrukcję SQL i wprowadzić konieczne zmiany, kliknij przycisk OK.


Tabela <nazwa> jest już w kwerendzie; dodać ją ponownie?

Nastąpiła próba dodania tabeli, która już znajduje się w okienku tabel.

  • Aby dodać tabelę w celu utworzenia samosprzężenia, kliknij przycisk OK.
  • Aby zapobiec dodaniu tabeli, kliknij przycisk Anuluj.


Błąd formatu danych — nie można wkleić.

Program Microsoft Query nie może wkleić danych ze Schowka, ponieważ jest za mało wolnej pamięci.

Spróbuj zamknąć inne okna w programie Microsoft Query lub inne programy. Jeżeli błąd się powtarza, uruchom ponownie system Microsoft Windows i ponów próbę skopiowania i wklejenia danych.


Nie można zapisywać w otwartym pliku.

Plik, w którym chcesz dokonać zapisu, jest otwarty. Przed ponowną próbą zapisu, zamknij plik.


Wywołana aplikacja jest zajęta.

Drugi program uczestniczący w komunikacji dynamicznej wymiany danych (DDE) jest zajęty i nie może wykonać operacji DDE. Poczekaj, aż program będzie dostępny.


Po 'GROUP' oczekiwane jest 'BY'.

Instrukcja SQL zawiera klauzulę GROUP zamiast klauzuli GROUP BY. Słowo BY mogło zostać błędnie wpisane lub brakuje go.


Po 'ORDER' oczekiwane jest 'BY'.

Instrukcja SQL zawiera klauzulę ORDER zamiast klauzuli ORDER BY. Słowo BY mogło zostać błędnie wpisane lub brakuje go.


Nie można otworzyć Schowka.

Schowek nie odpowiada, prawdopodobnie jest używany przez inny program. Zamknij ten program i ponów próbę operacji.


Nie można otworzyć pliku <nazwa>.

Program Microsoft Query nie może otworzyć pliku lub odczytać zawartych w nim danych albo zapisać pliku. Być może wystąpił błąd dysku lub plik jest uszkodzony.


Nie można uruchomić programu MS Query. Spróbuj ponownie.

Wystąpił błąd systemowy lub jest za mało wolnej pamięci, aby uruchomić program Microsoft Query.

Uruchom ponownie program Microsoft Query lub zamknij inne programy. Jeżeli błąd się powtarza, uruchom ponownie system Microsoft Windows, a następnie ponów próbę wykonania tej operacji.


Kolumna <nazwa> nie może być użyta z operatorem <operator>

ródło danych nie pozwala na użycie tego pola z podanym operatorem, ponieważ z operatorem tym nie może być używany typ danych określony dla tego pola. Sprawdź w dokumentacji dotyczącej źródła danych, które operatory mogą być używane w polach zawierających ten typ danych.


Kolumna <nazwa> nie może być użyta w kryteriach

Nie można określić kryteriów w kolumnie (polu) zawierającej ten typ danych.


Pomoc jest niedostępna z powodu braku pamięci lub nieprawidłowej instalacji systemu Windows lub programu MS Query.

Aby zwolnić trochę pamięci, spróbuj zamknąć okna lub inne programy. Jeżeli to konieczne, zainstaluj ponownie system Microsoft Windows lub program Microsoft Query.


Nie można wkleić.

Schowek nie odpowiada. Być może jest używany przez inny program albo dane w Schowku są zapisane w formacie, który nie jest rozpoznawany przez program Microsoft Query lub jest za mało pamięci, aby wkleić dane.

Spróbuj zamknąć inne okna w programie Microsoft Query lub inne programy. Jeżeli błąd się powtarza, uruchom ponownie system Microsoft Windows i ponów próbę skopiowania i wklejenia danych.


Nie można zamknąć programu Microsoft Query.

Program Microsoft Query komunikuje się z innym programem za pomocą mechanizmu dynamicznej wymiany danych (DDE). Poczekaj na zakończenie operacji DDE, a następnie zamknij program Microsoft Query.


Nie można wyświetlić kryterium.

Określone kryterium jest nieprawidłowe.


Nie można dodać wyrażenia <nazwa> do listy sortowania

Używane źródło danych nie zezwala na sortowanie według pola zawierającego wynik wyrażenia.


Nie można stosować wyrażeń agregujących do tabel

Dla opcji Pole wpisano gwiazdkę (*) zamiast określić pole, dla którego ma być obliczona suma. Usuń gwiazdkę (*), a następnie wprowadź nazwę pola.


Nie można określać * jako pola. Aby dodać wszystkie pola, przeciągnij i upuść * na siatkę.

W okienku kryteriów, w komórce Pole wpisano gwiazdkę (*). Aby określić kryteria dla wszystkich pól w kwerendzie, użyj jednej z następujących metod zamiast wpisywać gwiazdkę:

  • Przeciągnij gwiazdkę (*) z tabeli do okienka kryteriów.
  • Kliknij dwukrotnie gwiazdkę w tabeli.
  • Dodaj każde pole oddzielnie.


Funkcja <nazwa> nie może być użyta z <nazwa kolumny>

Wybrano funkcję, która nie może być obliczona dla typu danych zawartych w tym polu. Na przykład nie można policzyć średniej dla pola KRAJ_WYSYLKI, jeśli pole zawiera tekst.


Nieobsługiwany format Schowka.

Dane w Schowku są zapisane w formacie, który nie jest rozpoznawany przez program Microsoft Query.


Niektóre kwerendy korzystają z <nazwa połączenia>; czy zamknąć mimo to?

Jedna lub więcej kwerend używa źródła danych, które chcesz usunąć.

  • Aby usunąć źródło danych i zamknąć kwerendy, kliknij przycisk OK.
  • Aby zachować źródło danych na liście i nie zamykać kwerendy, kliknij przycisk Anuluj.


Usuwanie rekordów: <liczba>

Należy wskazać to polecenie, aby usunąć określoną liczbę rekordów.

Uwaga Większa od określonej liczba rekordów oznacza, że program Microsoft Query znalazł duplikaty rekordów na podstawie pól w okienku danych. Aby uniknąć duplikatów rekordów, należy dodać wszystkie pola do okienka danych przed usunięciem rekordów.

  • Aby usunąć rekordy, kliknij przycisk OK.
  • Aby nie usuwać rekordów, kliknij przycisk Anuluj.


Zaznaczono rekordy: <liczba>. Czy usunąć wszystkie?

Ponieważ okienko danych nie zawiera pola, które unikatowo identyfikuje każdy rekord (takiego jak np. Identyfikator klienta lub Identyfikator zamówienia), więc zestaw wyników zawiera inne rekordy, identyczne z tym, który trzeba usunąć. Usunięcie zaznaczonego rekordu spowoduje usunięcie wszystkich identycznych rekordów.

Aby jednoznacznie rozróżnić rekordy przed rozpoczęciem edycji danych, należy upewnić się, że dodano do okienka danych wszystkie pola tabeli lub utworzyć w tabeli unikatowy indeks.


Rekordy <liczba> zostaną zaktualizowane.

Okienko danych zawiera inne rekordy, identyczne z tym, który ma być poprawiony. Podczas aktualizacji program Microsoft Query automatycznie wprowadzi takie same zmiany we wszystkich identycznych rekordach.

  • Aby uniknąć wyświetlania duplikatów rekordów w okienku danych, przed wprowadzeniem zmian dodaj wszystkie pola do okienka danych.
  • Aby zaktualizować rekordy, kliknij przycisk OK.
  • Aby zapobiec aktualizacji rekordów, kliknij przycisk Anuluj.


Nie można utworzyć pliku.

Program Microsoft Query nie może utworzyć określonego pliku kwerendy. Być może wystąpił błąd dysku lub plik jest uszkodzony.


Utworzono pomyślnie tabelę <nazwa>.

Program Microsoft Query utworzył zdefiniowaną tabelę z wybranego źródła danych.


Nie można utworzyć indeksu unikatowego. Czy utworzysz go samodzielnie?

Program Microsoft Query nie może utworzyć indeksu unikatowego dla tej tabeli, mimo że zestaw wyników, który ma być zapisany jako nowa tabela, pochodzi z tabeli zawierającej unikatowy indeks.

  • Aby wyświetlić okno dialogowe Tworzenie indeksu, umożliwiające utworzenie unikatowego indeksu dla tabeli, kliknij przycisk Tak.
  • Jeżeli nie chcesz utworzyć unikatowego indeksu, kliknij przycisk Nie.


Określona długość musi być większa od 0.

Długość określona w polu Długość okna dialogowego Definicja tabeli musi być większa od 0 (zero).


Activate — polecenie (DDE)

Uaktywnia określone okno kwerendy. Polecenie to jest stosowane w celu zmiany aktywnego okna w przypadku, gdy otwartych jest wiele okien. Jest dostępne tylko w kanale systemowym.

Składnia

Activate(nazwa_kwerendy)

nazwa_kwerendy Nazwa okna kwerendy, które ma być uaktywnione

Przykład

W przykładzie wykonywane są dwie kwerendy i tworzone odpowiednie okna. Po wykonaniu drugiej kwerendy uaktywniane jest okno utworzone przez pierwszą kwerendę.

DDEExecute chan, "[BuildSQL('Select * From Customers')]"
DDEExecute chan, "[QueryNow()]"
stQueryname1 = DDERequest(chan, "Query")
DDEExecute chan, "[BuildSQL('Select * From ORDERS')]"
DDEExecute chan, "[QueryNow()]"
stQueryName2 = DDERequest(chan, "Query")
DDEExecute chan, "[Activate('" & stQueryname1(1) & "')]"


AddParameters — polecenie (DDE)

Dodaje parametr do aktywnej kwerendy w celu użycia z raportami tabeli przestawnej.

Składnia

AddParameters(pole1, pole2, …)

pole1, pole2, … Nazwy kolumn tabeli, które mają być dodane do kryteriów jako parametry. Nazwy nowych parametrów są definiowane jako nazwy pól. Po wskazaniu nazwy pola, które jest niedostępne w aktywnej kwerendzie, wystąpi błąd.

Spostrzeżenia

Polecenie AddParameters może być również użyte, gdy wprowadzanie parametrów jest wyłączone w programie Microsoft Query.

Zmodyfikowany ciąg SQL może być zwrócony poprzez żądanie elementu ODBCSQLStatement.

Aby zresetować parametry, trzeba zresetować cały ciąg SQL.


AllowEdit — polecenie (DDE)

Określa, czy w oknie kwerendy dozwolona jest edycja. Polecenie to jest dostępne zarówno w kanale systemowym, jak i w kanale kwerendy. Jest ono równoważne poleceniu Zezwalaj na edycję, dostępnemu w menu Rekordy.

Składnia 1

AllowEdit(zezwalaj_na_edycję, zablokowane)

Składnia 2

Allow.Edit(zezwalaj_na_edycję, zablokowane)

Obydwie formy składni są równoważne.

zezwalaj_na_edycję Określa, czy w oknie kwerendy dozwolona jest edycja. Może przybierać wartości True lub False.

zablokowane Określa, czy w przypadku włączenia funkcji UserControl wyłączane jest polecenie Zezwalaj na edycję dostępne w menu Rekordy. Może przybierać wartości True lub False.

Przykład

W przykładzie tym wykonywana jest utworzona uprzednio instrukcja SQL. Następnie polecenia AllowEdit i UserControl są przesyłane do programu Microsoft Query w celu umożliwienia użytkownikowi wyświetlania (ale nie edytowania) danych znajdujących się w źródle danych (jeśli włączona jest funkcja UserControl, polecenie menu Zezwalaj na edycję jest wyłączone).

DDEExecute chan,"[BuildSQL(""" & sql & """)]")
DDEExecute chan,"[QueryNow()]")
DDEExecute chan,"[AllowEdit(False, True)]")
DDEExecute chan,"[UserControl(""&Return Data"", 3, False)]")


BuildODBC — polecenie (DDE)

Buduje segment po segmencie ciąg połączenia.

Składnia

BuildODBC([ciągpołączenia])

ciągpołączenia Segment prawidłowego ciągu połączenia. Jeżeli ciągpołączenia ma wartość 0 (zero) lub jest pominięty, to ciąg połączenia zostaje wyczyszczony.


BuildSQL — polecenie (DDE)

Buduje instrukcję SQL segment po segmencie w celu utworzenia nowej kwerendy w kanale DDE. Polecenie to jest dostępne wyłącznie w kanale systemowym.

Składnia

BuildSQL[(tekst_SQL)]

tekst_SQL Prawidłowa instrukcja SQL. Jeżeli argument tekst_SQL ma wartość 0 (zero) lub jest pominięty, to instrukcja SQL jest usuwana.

Spostrzeżenia

Polecenie BuildSQL jest użyteczne przy tworzeniu długich instrukcji SQL. Jeśli na przykład instrukcja SQL jest zbyt długa na to, aby ją przesłać w postaci pojedynczej instrukcji, można ją przesłać w kilku mniejszych częściach.

Po zbudowaniu instrukcji SQL można ją wykonać za pomocą polecenia QueryNow.

Przykład

W przykładzie element żądania QueryDefinition został użyty do otrzymania instrukcji SQL dla kwerendy.

sql = DDERequest(chan,"QueryDefinition")

W przykładzie tym polecenie BuildSQL zostaje wykorzystane do ponownego wysłania zwróconego ciągu SQL z dodatkową klauzulą WHERE.

DDEExecute chan, "[BuildSQL(""" & sql & """)]"
DDEExecute chan, "[BuildSQL("WHERE Freight > 10")]"
DDEExecute chan, "[QueryNow()]


Close — polecenie (DDE)

Zamyka bieżącą kwerendę. Polecenie jest dostępne zarówno w kanale systemowym, jak i w kanale kwerendy.

Składnia

Close( )


Zamykanie kanału DDE

Aby zamknąć kanał DDE, należy użyć polecenia DDETerminate. Opisana metoda ma tylko jeden argument — numer kanału DDE, który ma być zamknięty. Po użyciu polecenia DDETerminate wszystkie, otwarte w tym kanale kwerendy zostaną automatycznie zamknięte, a użytkownik zostanie wylogowany ze wszystkich podłączonych źródeł danych.

Jeżeli używany numer kanału jest nieprawidłowy, to zwracana jest informacja o błędzie.


Command — polecenie (DDE)

Przesyła polecenie Open do programu Microsoft Query. Polecenie to jest przeznaczone dla programów, w których istnieją ograniczenia długości ciągów znaków użytych w poleceniu DDEExecute.

Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

Command(liczop, ciągwyk)

liczop Określa, w jaki sposób program Microsoft Query otrzymuje polecenia. Może mieć jedną z następujących wartości.

Wartość | Opis
1 | Argument ciągwyk inicjuje bufor programu Microsoft Query (jeśli bufor istnieje, zostaje wcześniej wyczyszczony), ale kwerenda nie jest wykonywana.
2 | Argument ciągwyk jest dołączany do końca buforu.
3 | Argument ciągwyk jest dołączany do końca buforu i wykonywane są wszystkie polecenia z buforu. Ponieważ bufor poleceń jest czyszczony po wykonaniu polecenia, polecenie ciągwyk nie może być ponownie wykonane.

liczop Segmenty polecenia Open. Cały ciąg musi być ujęty w pojedyncze lub podwójne cudzysłowy.

W programie Microsoft Query tylko polecenie Open może być przesłane za pomocą polecenia Command.

Spostrzeżenia

Polecenie to jest dostępne wyłącznie dla celów zgodności z plikiem Q+E. Zaleca się, by w miarę możliwości do przesyłania długich instrukcji SQL było używane polecenie BuildSQL.


EnableParameters — polecenie (DDE)

Kontroluje, czy użytkownik może określać parametry w okienku kryteriów i oknie SQL. Domyślnie użytkownik nie może określać parametrów. Polecenie nie działa, jeżeli zostały już wprowadzone jakieś parametry.

Składnia

EnableParameters(flaga)

flaga Określa, czy użytkownik może podawać parametry. Wartość 0 (zero) uniemożliwia, a wartość 1 umożliwia określanie parametrów.


EnableTensor — polecenie (DDE)

Wskazuje, czy program docelowy obsługuje źródła danych OLAP. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

EnableTensor(flaga)

flaga Należy użyć wartości Prawda (True), aby źródła danych OLAP były zwracane do programu docelowego. Aby umożliwić zwracanie do programu docelowego jedynie źródeł danych innych niż OLAP, należy użyć wartości Fałsz (False) lub pominąć parametr.


Wykonywanie poleceń DDE

Polecenia do programu Microsoft Query można przesyłać za pomocą metody DDEExecute. Polecenia są unikatowe dla programu Microsoft Query i nie muszą odpowiadać poleceniom z menu. Na przykład polecenia Open i SaveAs działają tak samo jak odpowiednie polecenia z menu programu Microsoft Query, ale polecenia ODBCLogon i UserControl działają inaczej. Aby wyświetlić listę dostępnych poleceń, kliknij przycisk Obrazek przycisku .

Instrukcja DDEExecute ma dwa argumenty.

Argument | Opis
channel | Numer kanału DDE zwrócony przez metodę DDEInitiate.
command | Polecenie przesyłane do programu Microsoft Query.

Aby umożliwić tworzenie kwerend w programie Microsoft Query, należy użyć polecenia UserControl. Poniższa instrukcja tworzy polecenie Moje zakończenie, jako równoważne poleceniu Zakończ z menu Plik systemu Windows lub poleceniu Zamknij z menu Plik w wersji dla komputerów Macintosh.

DDEExecute Chan,"[UserControl('&My Exit Command',3,True)]"

Wartość kanału DDE została wcześniej przypisana argumentowi Chan, a do programu Microsoft Query przesyłane jest polecenie UserControl. Należy zauważyć, że polecenie UserControl i jego parametry są ujęte w podwójny cudzysłów ( " " ) i nawiasy kwadratowe ( [ ] ).


Exit — polecenie (DDE)

Zamyka program Microsoft Query. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

Exit(wszystko)

wszystko Określa, czy praca z programem Microsoft Query ma zostać zakończona, jeśli otwarte są kwerendy na innych kanałach poza kanałem, w którym wykonywane jest polecenie Exit. Argument ten może przyjmować wartość Prawda (True) lub Fałsz (False).

Należy użyć wartości Prawda, aby wyjść z programu Microsoft Query niezależnie od tego, jakie kwerendy są otwarte. Jeżeli w innym kanale program Microsoft Query jest sterowany przez użytkownika (co oznacza, że w tym kanale wywołano polecenie UserControl), to ten kanał zostanie zamknięty, a sterowanie zostanie zwrócone do programu, z którego uruchomiono program Microsoft Query.

Należy użyć wartości Fałsz, aby wyjść z programu Microsoft Query tylko wtedy, gdy wszystkie otwarte kwerendy były otwarte w kanale, w którym wywołano polecenie Exit.

Spostrzeżenia

To polecenie DDE jest również używane do zamykania programu Microsoft Query w wersji dla komputerów Macintosh.


Wychodzenie z programu Microsoft Query w DDE

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Można zakończyć pracę z programem Microsoft Query, przesyłając do niego z innego programu polecenie Zakończ zamiast używać polecenia Zakończ lub Zamknij z menu Plik.

Polecenie | Opis
Zakończ (Fałsz) | Wychodzi z programu Microsoft Query tylko wówczas, gdy nie ma otwartych kwerend na innych kanałach
Zakończ (Prawda) | Wychodzi z programu Microsoft Query bez względu na to, czy otwarte są jakieś kwerendy


Fetch i Fetch.Advise — polecenia (DDE)

Polecenie Fetch pobiera dane z programu Microsoft Query i przesyła je bezpośrednio do programu docelowego.

Polecenie Fetch.Advise automatycznie aktualizuje wartości w programie docelowym, gdy są zmieniane wartości w programie Microsoft Query, nie zaś tylko wtedy, gdy przesyłane jest polecenie Fetch.Advise.

Polecenia te są dostępne zarówno w kanale systemowym, jak i w kanale kwerendy.

Składnia 1

Fetch.Advise(nazwa_apl, temat, zakres, wartości)

Składnia 2

Fetch(nazwa_apl, temat, zakres, wartości)

nazwa_apl Nazwa programu docelowego, do którego mają zostać przesłane dane. Poniżej zestawiono wartości argumentu nazwa_apl stosowane dla programów pakietu Office:

Program | Wartość argumentu
Microsoft Access | MSAccess
Microsoft Excel | Excel
Microsoft Word | WinWord

temat Nazwa arkusza, dokumentu lub formantu, do którego mają zostać przesłane dane.

zakres Obszar arkusza, dokumentu lub formantu, do którego mają zostać przesłane dane.

wartości Wartości, które mają zostać pobrane z programu Microsoft Query (poprawne wartości zestawiono w tabeli poniżej).

Uwaga Polecenie Fetch.Advise automatycznie aktualizuje wyłącznie dane z kwerendy, a nie żądane elementy lub odwołania row#col#.

Może mieć jedną z następujących wartości:

Wartość | Opis
Request_item | Określa, jakie informacje mają zostać zwrócone; na przykład definicja kwerendy — QueryDefinition.
row#col# | Odwołanie do określonych wierszy i kolumn, z których mają zostać pobrane dane, jak na przykład W3K5 w programie Microsoft Excel.
/Headers | Powoduje pobranie nazw kolumn.
/Rownum | Powoduje pobranie numerów wierszy.
All | Powoduje pobranie wszystkich rekordów.

Spostrzeżenia

Po użyciu polecenia Fetch.Advise, kanał tworzony w celu przekazania danych do programu docelowego nie jest zamykany aż do wysłania polecenia Fetch.Unadvise lub polecenia Close.

Przykład

W poniższym przykładzie elementy żądania NumRows i NumCols zostały użyte do przekazania liczby wierszy i kolumn w kwerendzie. Następnie wartości te wraz z nagłówkami kolumn są przekazywane do arkusza kalkulacyjnego programu Microsoft Excel o nazwie „Arkusz1”.

rows=REQUEST(Chan,"NumRows")
cols=REQUEST(Chan,"NumCols")
DDEExecute chan, "[Fetch(""Excel"", ""Data.xls!Sheet1"", _
    ""R1C1:R"&rows&"C"&cols&""", ""All/Headers"")]"


Pobieranie danych

Polecenie DDERequest może zwracać dane do programu, natomiast polecenia Fetch oraz Fetch.Advise wymagają szczególnej uwagi, ponieważ pobierają dane w programie Microsoft Query i przesyłają je bezpośrednio do arkusza kalkulacyjnego lub dokumentu. Polecenia Fetch i Fetch.Advise są używane jako argumenty polecenia DDEExecute.

Polecenie Fetch.Advise działa podobnie jak polecenie Fetch z tym, że kanał utworzony przy pierwszym pobieraniu nie jest natychmiast zamykany. Program Microsoft Query przesyła nim wszystkie zmiany wprowadzone w danych, aż do chwili zamknięcia oryginalnego kanału DDE lub przesłania do programu Microsoft Query polecenia Fetch.Unadvise.


Fetch.Unadvise — polecenie (DDE)

Usuwa automatyczną aktualizację skonfigurowaną za pomocą polecenia Fetch.Advise i zamyka kanał otwarty przez program Microsoft Query do przekazywania danych do programu docelowego. Polecenie jest dostępne zarówno w kanale systemowym, jak i w kanale kwerendy.

Uwaga Argumenty używane przez polecenie Fetch.Unadvise muszą odpowiadać argumentom użytym wcześniej w poleceniu Fetch.Advise.

Składnia

Fetch.Unadvise(nazwa_apl, temat, zakres, wartości)

nazwa_apl Nazwa programu docelowego, do którego mają być przesłane dane. (Przykłady można znaleźć w opisie polecenia Fetch.Advise.)

temat Nazwa arkusza, dokumentu lub formantu, do którego mają być przesłane dane.

zakres Obszar arkusza, dokumentu lub formantu, do którego mają być przesłane dane.

wartości Wartości, które mają być pobrane z programu Microsoft Query. (Tabelę z prawidłowymi wartościami można znaleźć w opisie polecenia Fetch.Advise).


Niezgodna wersja <nazwa pliku>; program Microsoft Query nie może zostać uruchomiony

Brak pliku Ddeml.dll lub istniejąca wersja jest przestarzała. Zainstaluj ponownie program Microsoft Query lub system Microsoft Windows.


Logoff — polecenie (DDE)

Wylogowuje z określonego źródła danych. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

Logoff(źródło)

źródło Nazwa źródła danych, z którym użytkownik chce się rozłączyć.


Logon — polecenie (DDE)

Wyświetla okno dialogowe, które umożliwia zalogowanie do źródła danych. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

Logon(źródło)

źródło Nazwa źródła danych, z którym użytkownik chce się połączyć.


LogonNow — polecenie (DDE)

Jeżeli wcześniej użyto polecenia BuildODBC do skonstruowania ciągu połączenia, to polecenie LogonNow umożliwia zalogowanie do umieszczonego w buforze ciągu połączenia. Jeżeli w buforze nie ma żadnego ciągu połączenia, to wystąpi błąd.

Składnia

LogonNow([dialog])

dialog Określa, czy w czasie logowania mają być wyświetlane okna dialogowe. Może przyjmować jedną z następujących wartości.

Wartość | Opis
0 (zero) | Nie są wyświetlane żadne okna dialogowe. Jeśli argument jest pominięty, wartość domyślna wynosi 0 (zero).
1 | Okna dialogowe są wyświetlane, aby uzyskać od użytkownika dodatkowe informacje, które nie są zawarte w ciągu połączenia.
2 | Okna dialogowe są wyświetlane z wartościami z ciągu połączenia, które zostały określone jako wartości domyślne.
3 | Działa tak samo jak 1, ale informacje, które nie są wymagane do podłączenia źródła danych, są wyświetlane jako wygaszone.


ODBCLogon — polecenie (DDE)

Umożliwia programowi uzyskanie połączenia ze źródłem danych. Pozwala określić, czy podczas logowania będą wyświetlane okna dialogowe. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

ODBCLogon(ciągpodłącz, dialog)

ciągpołącz Ciąg, w którym zawarte są informacje (takie jak nazwa źródła danych, identyfikator użytkownika i hasło) wymagane przez sterownik do połączenia ze źródłem danych. Argument musi odpowiadać formatowi wymaganemu przez stosowany sterownik. Szczegółowe informacje na temat ciągu połączenia można znaleźć w dokumentacji dotyczącej źródła danych.

Uwaga Ponieważ program Microsoft Query obsługuje plikowe nazwy źródeł danych (DSN, Data Source Name), można użyć polecenia żądania ConnectionString w celu uzyskania ciągu połączenia pozbawionego nazwy DSN, będącego częścią kwerendy utworzonej w oparciu o plikowe DSN. Następnie można użyć tego ciągu połączenia w celu ponownego połączenia się ze źródłem danych z dowolnego komputera.

dialog Określa, czy w czasie logowania mają być wyświetlane okna dialogowe. Może przyjmować jedną z następujących wartości.

Wartość | Opis
0 (zero) | Nie są wyświetlane żadne okna dialogowe.
1 | Okna dialogowe są wyświetlane, aby uzyskać od użytkownika dodatkowe informacje, które nie są zawarte w ciągu połączenia.
2 | Okna dialogowe są wyświetlane z wartościami z ciągu połączenia, które zostały określone jako wartości domyślne.
3 | Analogicznie jak w przypadku pierwszym z tą różnicą, że informacje, które nie są niezbędne do połączenia ze źródłem danych, są wygaszone.

Przykład

W tym przykładzie element żądania ConnectionString został użyty do zwrócenia ciągu wymaganego do połączenia się ze źródłem danych. Ciąg połączenia zostaje zapisany po zalogowaniu się użytkownika w źródle danych, a użyte następnie polecenie ODBCLogon umożliwia połączenie z tym samym źródłem danych bez konieczności wprowadzania danych przez użytkownika.

connstr = DDERequest(chan, "ConnectionString")
' intervening code
DDEExecute chan, "[ODBCLogon (connstr(1), 0)]"


Otwieranie kanału DDE

Do otwierania kanału DDE procedura wykorzystuje metodę DDEInitiate. Metoda DDEInitiate ma dwa argumenty: nazwę programu źródłowego oraz temat komunikacji DDE (zwany tematem). Dla programu Microsoft Query stosuje się nazwę „MSQuery”.

Tematy programu Microsoft Query mogą być następujące.

Temat | Opis
query_window_name | Nazwa otwartego okna kwerendy. Nazwa okna może być podana tylko wówczas, gdy program Microsoft Query działa i okno jest otwarte.
System | Ogólny temat, który umożliwia programowi docelowemu połączenie z samym programem Microsoft Query, a nie z oknem kwerendy, plikiem czy instrukcją SELECT języka SQL.

Gdy program Microsoft Query otrzymuje żądanie rozpoczęcia komunikacji DDE na rozpoznawany przez siebie temat, odpowiada i otwiera kanał DDE. Metoda DDEInitiate zwraca numer kanału DDE, który może być przypisany do zmiennej i użyty do innych operacji na tym kanale.

Aby otworzyć wiele okien w jednym kanale, należy użyć tematu System. Jeżeli do otwierania kanału DDE użyto tematu System, można uaktywnić wyłącznie okna otwarte w tym kanale DDE.


Open — polecenie (DDE)

Otwiera i wykonuje kwerendę, a następnie wyświetla dane w okienku danych. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

Open(kwerenda)

kwerenda Nazwa pliku programu Microsoft Query (w środowisku systemu Microsoft Windows pliki kwerend mają rozszerzenie dqy) lub pliku Q+E (wyłącznie w środowisku systemu Microsoft Windows; rozszerzenie qef) zawierającego kwerendę lub instrukcja SELECT języka SQL.

Przykład

W poniższym przykładzie następuje otwarcie kwerendy o nazwie Sprzedaż.

DDEExecute chan, "[Open(""c:\msquery\sales.dqy"")]")

Ten sam przykład w wersji dla komputerów Macintosh ma następującą postać.

DDEExecute chan, "[Open(""drivename:msquery:sales"")]")

W poniższym przykładzie polecenie SELECT języka SQL zostało użyte do wykonania nowej kwerendy.

DDEExecute chan, "[Open(""SELECT * FROM pubs.dbo.titles"")]")


ParameterNames2, żądanie (DDE)

Zwraca informacje o parametrach kwerendy parametrycznej. Żądanie jest dostępne wyłącznie w kanale systemowym.

Składnia

ParameterNames2( )

Dla każdego parametru żądanie ParameterNames2 zwraca nazwę, typ danych i ostatnio użytą wartość. Żądanie ParameterNames2 zwraca następującą tablicę z trzema kolumnami na N wierszy w formacie xlTable:

Kolumna 1 | Kolumna 2 | Kolumna 3
Nazwa parametru | Typ danych kolumny | Ostatnio użyta wartość parametru, jeśli jest dostępna, w przeciwnym wypadku wartość zerowa

Aby uzyskać informacje o formacie xlTable, odwołaj się do Pomocy języka Visual Basic dla programu Microsoft Excel.

Żądania ParameterNames2 można użyć w każdej chwili, nawet jeśli parametry zostały wyłączone dla kwerendy za pomocą polecenia EnableParameters. Jeśli kwerenda nie ma parametrów, żądanie ParameterNames2 zwraca pustą tablicę.


QueryNow — polecenie (DDE)

Wykonuje bieżącą kwerendę dla otwartego kanału DDE. Jeżeli kwerendę tworzono za pomocą polecenia BuildSQL, polecenie wykonuje znajdującą się w buforze instrukcję SQL i otwiera okno kwerendy. Polecenie jest dostępne zarówno w kanale systemowym, jak i w kanale kwerendy.

Składnia

QueryNow( )

Przykład

W przykładzie następuje zapisanie instrukcji SQL znajdującej się w kwerendzie, a następnie wysłanie tej instrukcji w celu ponownego wykonania kwerendy.

sql = DDERequest(Chan, "QueryDefinition")
DDEExecute chan, "[BuildSQL(""" & sql & """)]"
DDEExecute chan, "[QueryNow()]"


QueryType — żądanie (DDE)

Zwraca informacje o źródle danych kwerendy. Żądanie to jest dostępne jedynie w kanale systemowym.

Składnia

QueryType( )

Żądanie QueryType zwraca tablicę dwuelementową w formacie xlTable. Pierwszy element zawiera typ źródła danych kwerendy — ODBC lub OLE/DB. Drugi element zawiera typ poleceń interpretowanych przez źródło danych: SQL, Moduł lub Anuluj, mianowicie:

QueryType | CommandType | Opis
ODBC | SQL | ródłem danych jest ODBC zgodne z językiem SQL.
OLEDB | Moduł | ródło danych jest modułem OLAP. Instrukcja SQL zawiera nazwę modułu.
ODBC | Anuluj | Użytkownik anulował kwerendę i powrócił do programu docelowego.

Informacje o formacie xlTable można znaleźć w Pomocy języka Visual Basic dla programu Microsoft Excel.

Żądania QueryType należy używać jedynie jako pierwszego żądania po zakończeniu wykonywania polecenia UserControl2.

Jeśli żądanie QueryType wskazuje, że źródło danych jest modułem OLAP, można użyć żądań ODBCSQLStatement i ConnectionString do pobrania informacji o źródle danych. Dowiedz się, jak używać żądań DDE.


Żądanie stanu i innych informacji

Po otwarciu kanału DDE do programu Microsoft Query można użyć metody DDERequest, aby uzyskać zestaw wyników lub inne informacje.

Metoda DDERequest ma dwa argumenty.

Argument | Opis
channel | Numer kanału DDE zwrócony przez metodę DDEInitiate.
request_item | Dane, które mają zostać zwrócone. Może to być zawartość pola lub zakresu pól w oknie kwerendy, lub inne informacje, takie jak liczba rekordów w oknie kwerendy.

Żądanie przesłania elementu może być wysłane zarówno kanałem kwerendy, jak i kanałem systemowym. Kanałem kwerendy mogą być zwracane tylko informacje na temat kwerendy, takie jak liczba wierszy i kolumn lub definicja kwerendy. Kanałem systemowym mogą być zwracane ogólne informacje dotyczące programu Microsoft Query, takie jak bieżące połączenia, nazwy tematów i stan programu, jak również informacje unikatowe dla aktywnej kwerendy.

Kanałem kwerendy lub kanałem systemowym (dla aktywnej kwerendy) mogą być przesyłane następujące elementy żądania:

Element żądania | Zwracana informacja
ColumnTitles | Tablica tytułów kolumn. Tytuł kolumny jest taki sam jak nazwa pola, chyba że użytkownik zmienił tytuł kolumny w programie Microsoft Query.
ConnectionString | Tablica segmentów ciągu połączenia (każdy segment może mieć nie więcej niż 255 znaków) tworzących ciąg używany do łączenia z oknem aktywnej kwerendy. Jeśli kwerenda została utworzona na podstawie plikowego DSN, element zwraca ciąg połączenia pozbawiony nazwy DSN.
ConnectionString/n | Tablica segmentów ciągu połączenia (każdy segment może mieć nie więcej n znaków) tworzących ciąg używany do łączenia z oknem aktywnej kwerendy. Jeżeli kwerenda została utworzona na podstawie plikowego DSN, element zwraca ciąg połączenia pozbawiony nazwy DSN.
DataSourceName | Nazwa źródła danych (DSN) używana przez aktywną kwerendę.
ErrorText | Tekst komunikatu o błędzie pochodzący od ostatnio wykonanej instrukcji SQL. Ten element żądania może być wielokrotnie przesyłany w celu odczytania komunikatów o wszystkich błędach, które wystąpiły. Po odczytaniu wszystkich komunikatów o błędach element zwraca pusty ciąg. Jeżeli ostatnia instrukcja SQL została wykonana prawidłowo, element zwraca pusty ciąg, nawet jeśli wykonanie wcześniejszych instrukcji SQL nie powiodło się.
FieldDef | Tablica wartości opisujących wyrażenia i typy danych w kolumnach (polach) w oknie kwerendy. Każdy wiersz tablicy opisuje jedno pole w kwerendzie. Tablica zwraca w formacie kolumnowym następujące dane: nazwa pola, typ danych Q+E pola, szerokość pola, stopień dokładności pola oraz typ danych SQL w polu.
GetUniqueItems | Tablica unikatowych elementów w danej kolumnie wyniku kwerendy. Element żądania powinien być tekstem "GetUniqueItems" uzupełnionym o liczony od zera numer kolumny (na przykład unikatowe elementy z drugiej kolumny można otrzymać, przesyłając element żądania "GetUniqueItems1"). Nie można w ten sposób wyszukiwać unikatowych elementów kolumny, której nie ma w kwerendzie. Element żądania zwraca te same wartości dla żądanej kolumny, jak instrukcja SELECT DISTINCT, z uwzględnieniem klauzul kryteriów oraz sprzężeń. Nie są uwzględnianie klauzule kryteriów zawierające parametry.
NameSeparator | Pojedynczy znak używany jako separator nazw kwalifikatorów ODBC.
NumCols | Liczba kolumn (pól) kwerendy.
NumRows | Liczba wierszy (rekordów) kwerendy.
ODBCSQLStatement | Tablica segmentów SQL (każdy segment może mieć nie więcej niż 255 znaków) tworzących instrukcję ODBC SQL opisującą kwerendę. Posługując się tym elementem żądania, można przesłać instrukcję SQL ODBC bezpośrednio do programu ODBC z pominięciem programu Microsoft Query.
ODBCSQLStatement/n | Tablica segmentów SQL (każdy segment może mieć nie więcej niż n znaków) tworzących instrukcję ODBC SQL opisującą kwerendę. Ten element żądania umożliwia przechowywanie instrukcji ODBC SQL w postaci kilku mniejszych segmentów.
ParameterNames | Tablica parametrów kwerendy. Jeżeli nie istnieją parametry, zwracana jest pusta tablica. Element żądania może być przesyłany nawet wówczas, gdy parametry kwerendy są wyłączone.
Query | Nazwa kwerendy.
QueryDefinition | Tablica segmentów definicji kwerendy (każdy segment może mieć nie więcej niż 255 znaków) tworzących definicję kwerendy (instrukcję SQL) utworzoną przez program Microsoft Query. Ten element żądania może być zapisany i używany w następnych kwerendach.
QueryDefinition/n | Tablica segmentów definicji kwerendy (każdy segment może mieć nie więcej niż n znaków) tworzących definicję kwerendy (instrukcję SQL).
Recest | Oszacowanie liczby wierszy, które można odczytać w jednym kroku.
TierType | Pojedyncza cyfra określająca typ danych: 1 oznacza plik mogący zawierać tylko jedną tabelę; 2 oznacza plik bazy danych, zawierający co najmniej jedną tabelę; 3 oznacza, że przeglądanie danych jest niemożliwe. Tego elementu żądania używa się, gdy program ma wyświetlić okno dialogowe Otwieranie, służące do przeglądania danych na dysku.

Użycie powyższych elementów żądania w kanale systemowym wywołuje zwrócenie informacji dotyczących okna kwerendy, które było ostatnio używane w komunikacji DDE.

Dodatkowo w kanale systemowym można przesyłać następujące elementy.

Element żądania | Zwracana informacja
Sources | Wszystkie aktualne połączenia ze źródłami danych (tylko DSN).
Logon | Wszystkie zdalne bazy danych, z którymi może być nawiązane połączenie (pozycje DSN z rejestru).
Logoff | Wszystkie aktualnie podłączone zdalne bazy danych (tylko DSN).
Tables/source/user/database | Wszystkie tabele dla podanego połączenia DSN, użytkownika i bazy danych. Podane źródło musi być prawidłowym DSN.
Users/source/database | Wszyscy użytkownicy dla podanego połączenia DSN i bazy danych. Podane źródło musi być prawidłowym DSN.
Database/source | Wszystkie bazy danych dla podanego połączenia DSN. Podane źródło musi być prawidłowym DSN.
Username/source/database | Nazwa użytkownika dla podanego połączenia DSN i bazy danych. Podane źródło musi być prawidłowym DSN.
Topics | Nazwy tematów otwartych w kanale systemowym, łącznie z tematem System.
Status | Stan programu; może przybierać wartości Gotowy lub Zajęty. Gotowy oznacza, że program może nawiązać komunikację DDE z programem Microsoft Query. Zajęty oznacza, że program Microsoft Query nie jest gotowy do nawiązania komunikacji DDE.

W poniższym przykładzie wartość zwrócona przez element żądania NumRows jest umieszczana w komórce A10 arkusza programu Microsoft Excel.

ActiveWorksheet.Range("A10").Value = DDERequest(chan, "NumRows")


SaveAs — polecenie (DDE)

Zapisuje projekt nowej kwerendy lub projekt istniejącej kwerendy pod inną nazwą. Spełnia taką samą funkcję, jak polecenie Zapisz jako dostępne w menu Plik i jest dostępne zarówno w kanale systemowym, jak i kanale kwerendy.

Składnia 1

SaveAs(nazwa_kwerendy)

Składnia 2

Save.As(nazwa_kwerendy)

Obydwie formy składni są równoważne.

nazwa_kwerendy Nowa nazwa kwerendy.


SetParameterName — polecenie (DDE)

Ustawia nazwę parametru otrzymanego w ciągu kwerendy przesłanym do programu Microsoft Query. Polecenie SetParameterName powinno być użyte po poleceniu BuildSQL.

Składnia

SetParameterName(indeks, nazwa)

indeks Indeks parametru.

nazwa Nazwa parametru.

Spostrzeżenia

Jeżeli instrukcja SQL przesłana za pomocą polecenia BuildSQL zawiera parametry, ale nie zostały odebrane polecenia SetParameterName, to program Query przypisuje domyślne nazwy parametrów, które mają postać "Parametr n", gdzie n jest kolejnym numerem. Jeżeli za pomocą poleceń SetParameterName przesłano za małą liczbę nazw parametrów, to pozostałe parametry otrzymują nazwy typu "Parametr n". Jeżeli przesłano zbyt dużo nazw parametrów, to nadmiarowe nazwy są ignorowane.


SetQueryName — polecenie (DDE)

Ustawia nazwę aktywnej kwerendy lub tworzy kwerendę o takiej nazwie, jeżeli nie ma aktywnej kwerendy. Nazwa pojawia się na pasku tytułu w oknie kwerendy.

Składnia

SetQueryName(nazwa)

nazwa Nazwa kwerendy.


SetQueryType — polecenie (DDE)

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Określa czynność podejmowaną przez program Microsoft Query dla kwerend opierających się na różnych typach źródeł danych. Polecenie jest dostępne wyłącznie w kanale systemowym.

Składnia

SetQueryType(TypKwerendy, TypPolecenia)

Prawidłowe kombinacje parametrów TypKwerendy i TypPolecenia są następujące:

TypKwerendy | TypPolecenia | Opis
ODBC | SQL | Edytuje kwerendę w programie Microsoft Query. Wartości są zakładane, jeśli parametry są pominięte.
OLEDB | Cube | Uruchamia Kreatora modułów OLAP w celu zmiany definicji modułu.

Podczas używania polecenia SetQueryType(OLEDB, Cube), program Microsoft Query ignoruje wszystkie polecenia LogonNow, EnableParameters oraz SetQueryName i argumenty UserControl2, które są nieprawidłowe w kontekście edytowania definicji modułu w Kreatorze modułów OLAP.


SetWindowState — polecenie (DDE)

Określa, czy po otwarciu aktywne okno jest normalne, zminimalizowane lub zmaksymalizowane. Polecenie jest dostępne zarówno w kanale systemowym, jak i w kanale kwerendy.

Składnia

SetWindowState(stan)

stan Stan aktywnego okna. Może on przyjmować jedną z następujących wartości.

Wartość | Opis
1 | Normalne
2 | Zminimalizowane (tylko system Microsoft Windows)
3 | Zmaksymalizowane


UserControl2 — polecenie (DDE)

Uaktywnia program Microsoft Query i umożliwia użytkownikowi tworzenie, otwieranie lub edycję kwerend, tak jak w programie Microsoft Query uruchomionym jako niezależna aplikacja.

Polecenie jest dostępne wyłącznie w kanale systemowym.

Uwaga Różnica między poleceniem UserControl a poleceniem UserControl2 polega na tym, że polecenie UserControl2 umożliwia określenie polecenia dodawanego do menu Plik, które zamyka wszystkie kwerendy utworzone w programie Microsoft Query i zwraca do programu docelowego bez danych.

Składnia

UserControl2(tekstkon, tekstanuluj, stanap, nowakwer)

tekstkon Nowa nazwa polecenia Zakończ używanego do wychodzenia z programu Microsoft Query po zakończeniu komunikacji DDE. Jeżeli argument jest pominięty, zostanie użyte polecenie "Return".

tekstanuluj Nazwa elementu menu używanego do anulowania bieżącej sesji. Polecenie jest dodawane na dole menu Plik programu Microsoft Query. W przypadku pominięcia tego argumentu nie jest tworzony żaden nowy element menu.

stanap Stan programu. Może on przyjmować jedną z następujących wartości.

Wartość | Opis
1 | Normalny
2 | Zminimalizowany (tylko system Microsoft Windows)
3 | Zmaksymalizowany

Jeżeli ten argument zostanie pominięty, to używany jest bieżący stan programu Microsoft Query.

nowakwer Określa, czy w chwili rozpoczęcia komunikacji DDE z programem Microsoft Query ma być wyświetlane okno dialogowe Wybieranie źródła danych. Może mieć wartość Prawda (True) lub Fałsz (False).

Jeżeli argument nowakwer ma wartość Prawda, to wyświetlane jest okno dialogowe Wybierz źródło danych, które umożliwia użytkownikowi wybranie źródła danych. Jeżeli argument nowakwer ma wartość Fałsz (wartość domyślna), to nie jest wyświetlane okno dialogowe i dostępne są wszystkie kwerendy otwarte w tym kanale.


UserControl — polecenie (DDE)

Uaktywnia program Microsoft Query i umożliwia użytkownikowi tworzenie, otwieranie lub edycję kwerend, tak jak w programie Microsoft Query uruchomionym jako niezależna aplikacja.

Polecenie to jest dostępne wyłącznie w kanale systemowym.

Składnia

UserControl(tekstkon, stanap, nowakwer)

tekstkon Nowa nazwa polecenia Zakończ używanego do wychodzenia z programu Microsoft Query po zakończeniu komunikacji DDE. Jeżeli argument jest pominięty, zostanie użyte polecenie "Return".

stanap Stan programu. Może on przyjmować jedną z następujących wartości.

Wartość | Opis
1 | Normalne
2 | Zminimalizowane (tylko system Microsoft Windows)
3 | Zmaksymalizowane

Jeżeli ten argument zostanie pominięty, to używany jest bieżący stan programu Microsoft Query.

nowakwer Określa, czy w chwili rozpoczęcia komunikacji DDE z programem Microsoft Query ma być wyświetlane okno dialogowe Wybieranie źródła danych. Może mieć wartość Prawda (True) lub Fałsz (False).

Jeżeli argument nowakwer ma wartość Prawda, to wyświetlane jest okno dialogowe Wybierz źródło danych, które umożliwia użytkownikowi wybranie źródła danych. Jeżeli argument nowakwer ma wartość Fałsz (wartość domyślna), to nie jest wyświetlane okno dialogowe i dostępne są wszystkie kwerendy otwarte w tym kanale.

Spostrzeżenia

Sterowanie użytkownika kończy się z chwilą kliknięcia polecenia Zakończ w menu Plik w systemie Windows lub wybrania polecenia Zamknij w menu Plik w wersji dla komputerów Macintosh. Program Microsoft Query powraca do stanu początkowego i zwraca sterowanie do programu docelowego.

Ważne W przypadku programów, w których stosowane są limity czasu, nie można zezwolić na wyłączenie aplikacji przed zakończeniem sterowania przez użytkownika.

Jeśli program Microsoft Query został uruchomiony w trybie sterowania przez użytkownika, to wszystkie nowe lub istniejące kwerendy są otwierane w tym samym kanale DDE.

Przykład

W tym przykładzie program Microsoft Query został uruchomiony w stanie zmaksymalizowanym, a polecenie Zakończ z menu Plik (lub polecenie Zamknij z menu Plik w wersji dla komputerów Macintosh) zostało zastąpione poleceniem Prześlij dane do programu Microsoft Excel. Następnie wyświetlane jest okno dialogowe Wybierz źródło danych.

DDEExecute chan, "[UserControl(""&Return To Excel"",3,True)]")


Korzystanie z DDE

Dwa programy wymieniają informacje przez nawiązanie komunikacji DDE na kanale DDE. Program może realizować więcej niż jedną sesję komunikacji z programem Microsoft Query, ale każda z nich odbywa się na innym kanale.

Program, który inicjuje komunikację, jest nazywany programem docelowym; program, który na nią odpowiada, jest nazywany programem źródłowym. W komunikacji DDE program Microsoft Query jest zawsze programem źródłowym. Oznacza to, że komunikacja DDE z programem Microsoft Query jest zawsze inicjowana przez inny program.

Uwaga Nie wszystkie programy obsługują DDE. Aby sprawdzić, czy dany program obsługuje DDE, należy zapoznać się z dokumentacją programu.

Kanały DDE

Istnieją dwa typy kanałów DDE: kanały systemowe i kanały kwerend.

W komunikacji między programem docelowym a programem Microsoft Query kanał systemowy służy do przesyłania informacji ogólnych i związanych z kwerendą. Oprócz dostarczania informacji o kwerendach, kanał systemowy umożliwia również uzyskiwanie informacji o systemie, takich jak informacje o aktualnych połączeniach, otwartych kwerendach i stanie programu docelowego.

Kanał kwerendy jest wykorzystywany do realizacji komunikacji DDE między programem docelowym a określoną kwerendą (np. Kwerenda1) programu Microsoft Query. Aby korzystanie z kanału kwerendy było możliwe, okno kwerendy musi być wcześniej otwarte za pomocą kanału systemowego.

Jak działa DDE

Komunikację DDE można porównać do zwyczajnej rozmowy dwóch osób. Na przykład podczas rozmowy kwalifikacyjnej do pracy prowadzący może zadać kandydatowi wiele pytań. Prowadzący (cel) inicjuje przepływ informacji, prosząc o ich podanie kandydata (źródło), po czym zapisuje uzyskane informacje na papierze (w arkuszu lub dokumencie). Oczywiście również kandydat zadaje pytania prowadzącemu, co prowadzi do nawiązania dwukierunkowej rozmowy.

Podobnie programy uczestniczące w komunikacji DDE przekazują informacje w obie strony. Na przykład, aby użyć DDE do komunikowania się z programem Microsoft Query, można utworzyć procedurę języka Visual Basic for Applications składającą się z następujących etapów:

  1. Otwarcie kanału za pomocą metody DDEInitiate.
  2. Opcjonalnie procedura może przesłać do programu Microsoft Query informacje na przykład na temat dostępnych źródeł danych lub bieżących połączeń.
  3. Uaktywnienie programu Microsoft Query. Ten krok umożliwia programowi Microsoft Query przyjmowanie poleceń. Na tym etapie użytkownik lub procedura może utworzyć lub zmodyfikować kwerendę. Procedura może przesyłać polecenia bezpośrednio do programu Microsoft Query za pomocą metody DDEExecute.
  4. Po zamknięciu programu Microsoft Query, wywołanym przez użytkownika lub procedurę, sterowanie powraca do programu docelowego . Procedura może pobrać dane kwerendy i przesłać je z powrotem do programu docelowego za pomocą metody DDERequest lub przesłać dane do programu Microsoft Query.
  5. Zamknięcie przez procedurę kanału DDE za pomocą metody DDETerminate.

Szczegółowe informacje na temat metod języka Visual Basic for Applications obsługujących DDE można znaleźć w Pomocy języka Visual Basic.


Korzystanie z programu Microsoft Query z innymi programami

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Najczęściej inne programy korzystają z programu Microsoft Query do realizacji trzech głównych zadań:

  • Tworzenie nowej kwerendy
  • Aktualizacja danych
  • Modyfikacja definicji kwerendy lub danych

Program Microsoft Query jako narzędzie do wyszukiwania danych

Dzięki DDE program Microsoft Query może być używany jako narzędzie do wyszukiwania danych. Po otwarciu przez makro lub program kanału DDE, może on uaktywnić program Microsoft Query i określić, jakie polecenie zastąpi polecenie Zakończ dostępne w menu Plik w systemie Microsoft Windows lub polecenie Zamknij dostępne w menu Plik na komputerach Macintosh, w jakim stanie ma być program (zminimalizowany — tylko Windows, zmaksymalizowany lub przywrócony) oraz określić, czy mają być wyświetlane kolejne okna dialogowe.

Można tworzyć, otwierać i edytować kwerendy, używając programu Microsoft Query jak niezależnego programu. Po utworzeniu kwerendy można kliknąć niestandardowe polecenie Zakończ lub kliknąć przycisk Zakończ dostępny na pasku narzędzi.

Po przekazaniu sterowania do programu docelowego (dokumentu, arkusza lub innego obiektu) można wysyłać żądania danych do programu Microsoft Query. Na przykład można zażądać podania liczby wierszy i kolumn w kwerendzie, definicji kwerendy w języku SQL, ciągu połączenia dla źródła danych lub nazwy źródła danych. Dane mogą być zwracane do programu docelowego do momentu, gdy nastąpi zamknięcie kanału DDE i zostanie zakończone działanie programu lub makra.

Aktualizacja wyszukanych danych

Po wykonaniu kwerendy i uzyskaniu zestawu wyników istnieje możliwość późniejszej aktualizacji tych danych w oparciu o najświeższą zawartość źródła danych. DDE umożliwia dokonywanie aktualizacji danych bez interwencji użytkownika: program może przesłać instrukcję SQL do programu Microsoft Query, który z kolei może wykonać kwerendę i zwrócić zestaw wyników do programu docelowego.

Modyfikacja definicji kwerendy lub danych

Program Microsoft Query może być również użyty przez inny program w celu zmodyfikowania istniejącej definicji kwerendy w programie Microsoft Query lub do edycji danych w źródle danych.

Proces ten rozpoczyna się od otwarcia kanału DDE przez program docelowy, który następnie łączy się ze źródłem danych i przesyła do programu Microsoft Query ciąg SQL (zapisany przy wcześniejszej kwerendzie), nakazujący utworzenie nowej kwerendy. Po otwarciu nowej kwerendy przez program docelowy sterowanie jest przekazywane użytkownikowi, który może modyfikować kwerendę lub edytować dane. Z chwilą zakończenia przez użytkownika pracy w programie Microsoft Query dane są zwracane do programu docelowego, nowa definicja kwerendy jest zapisywana, po czym następuje zamknięcie kwerendy.

Na przykład użytkownik pracujący w programie Word może wybrać niestandardowe polecenie „Dane o sprzedaży”, uruchamiające odpowiednie makro. Bez angażowania użytkownika makro uruchomi program Microsoft Query, utworzy kwerendę, a następnie zwróci dane o sprzedaży do dokumentu programu Word.


ViewPane — polecenie (DDE)

Określa, które okienka są wyświetlane w oknie kwerendy. Polecenie jest dostępne zarówno w kanale systemowym, jak i w kanale kwerendy.

Składnia

ViewPane(okienko)

okienko Określa, które okienka są wyświetlane. Może przyjmować jedną z następujących wartości:

Wartość | Opis
0 (zero) | Wyłącznie okienko danych
1 | Okienko danych i okienko tabel
2 | Okienko danych i okienko kryteriów
3 | Okienko danych, okienko tabel i okienko kryteriów


Typy danych Q+E

Wartość | Typ
1 | SQL_CHAR
2 | SQL_BINARY, SQL_VARBINARY, SQL_LONGVARBINARY, SQL_LONGVARCHAR, SQL_VARCHAR
3 | SQL_NUMERIC, SQL_DECIMAL
4 | SQL_INTEGER, SQL_BIGINT
5 | SQL_BIT, SQL_TYNYINT, SQL_SMALLINT
6 | SQL_FLOAT
7 | SQL_REAL, SQL_DOUBLE
8 | SQL_TIME, SQL_DATE, SQL_TIMESTAMP


Typy danych SQL

Wartość | Typ
0 | SQL_UNKNOWN_TYPE
1 | SQL_CHAR
2 | SQL_NUMERIC
3 | SQL_DECIMAL
4 | SQL_INTEGER
5 | SQL_SMALLINT
6 | SQL_FLOAT
7 | SQL_REAL
8 | SQL_DOUBLE
9 | SQL_DATETIME (tylko ODBC 3.0)
12 | SQL_VARCHAR


Usunięto pomyślnie tabelę <nazwa>.

Program Microsoft Query usunął tabelę i wszystkie przechowywane w niej dane. Tego usunięcia nie można cofnąć.


Czy usunąć tabelę <nazwa>?

Zdecyduj, czy chcesz usunąć tabelę. Usunięcie tabeli spowoduje usunięcie wszystkich znajdujących się w niej danych.

Przestroga Usunięcia tabeli nie można cofnąć.

  • Aby usunąć tabelę i przechowywane w niej dane, kliknij przycisk Tak.
  • Aby zapobiec usunięciu tabeli, kliknij przycisk Nie.


Zatrzymano zapisywanie z powodu nieprawidłowego stanu kwerendy.

Projekt kwerendy jest nieprawidłowy. Na przykład niepoprawnie określono kryteria. Jeżeli polecenie Automatyczna kwerenda jest wyłączone, spróbuj uruchomić kwerendę, klikając polecenie Wykonaj kwerendę w menu Rekordy.


Do uruchomienia programu Microsoft Query wymagany jest sterownik ekranu o rozdzielczości minimum 400 x 350 pikseli.

Zainstalowany sterownik karty graficznej nie ma wystarczającej rozdzielczości, aby umożliwić działanie programu Microsoft Query. Zamień sterownik ekranu, używając programu instalacyjnego systemu Microsoft Windows. Przed wymianą sterownika konieczne może być uaktualnienie zainstalowanej na komputerze karty graficznej, aby obsługiwała ona wyższą rozdzielczość.


Błąd sterownika.

Wystąpił błąd sterownika. Aby uzyskać więcej informacji, zapoznaj się z dokumentacją dołączoną do aktualnie używanego sterownika.


Odnaleziono nieunikatowy rekord.

Zestaw wyników zawiera identyczne rekordy, ponieważ w okienku danych nie ma pola z wartościami unikatowo identyfikującymi każdy rekord, takimi jak Identyfikator klienta lub Identyfikator zamówienia. Zmiany wprowadzone w jednym z rekordów wpływają na wszystkie identyczne rekordy.

Aby rozróżnić rekordy, upewnij się, że przed rozpoczęciem edycji dodano do okienka danych wszystkie pola z tabeli.


Nie można edytować kolumny obliczeniowej.

Nie można edytować danych w kolumnie, w której są obliczane sumy lub wyświetlane wyniki wyrażenia niestandardowego.


Nie można edytować kwerendy zgrupowanej.

Nie można edytować danych w kwerendzie zawierającej sumy lub kwerendzie, dla której zaznaczono pole wyboru Grupuj rekordy w oknie dialogowym Właściwości kwerendy. Aby edytować dane, usuń sumy lub anuluj zaznaczenie właściwości Grupuj Rekordy.


Nie można edytować kwerendy zawierającej wiele tabel

Nie można edytować danych w kwerendzie zawierającej więcej niż jedną tabelę.

  • Aby móc edytować dane w tabeli, dodaj do kwerendy tylko jedną tabelę, a następnie w menu Rekordy kliknij polecenie Zezwalaj na edycję.
  • Aby wyedytować dane w bieżącej kwerendzie, usuń z niej wszelkie tabele inne niż tabela zawierająca dane, które chcesz edytować. Następnie z menu Rekordy wybierz polecenie Zezwalaj na edycję.

Uwaga W przypadku usunięcia tabeli z kwerendy dane w tabeli wyjściowej nie są usuwane. Usunięcie dotyczy tylko tabeli i zawartych w niej danych z bieżącej kwerendy.


Nie można dodać źródła danych.

Program Microsoft Query nie może dodać wybranego źródła danych, ponieważ wystąpił problem z połączeniami z tym źródłem.


Niepoprawne wyrażenie kolumny: <wyrażenie>.

Wyrażenie określone na liście Wybierz jest niepoprawne. Wyrażenie powinno mieć następujący format:

SELECT pracow.PRAC_ID, pracow.DATA_ZATR
FROM C:\QT\pracow pracow


Po 'GROUP BY' oczekiwane jest wyrażenie.

Instrukcja SQL zawiera klauzulę GROUP BY, ale nie następuje po niej wyrażenie.


Po 'ORDER BY' oczekiwane jest wyrażenie.

Instrukcja SQL zawiera klauzulę ORDER BY, ale nie następuje po niej wyrażenie.


Nie można otworzyć kilku kopii pliku.

Nie można jednocześnie otworzyć dwóch kopii tego samego pliku kwerendy.


Nie można dodać tabeli <nazwa>

Nie można było dodać podanej tabeli. Upewnij się, że są spełnione następujące warunki:

  • Podana tabela znajduje się w bazie danych.
  • Prawidłowo podano nazwę tabeli. Sprawdź, czy nie zostały pominięte znaki podkreślenia ( _ ) lub inne znaki przestankowe.
  • Podana tabela zawiera prawidłowe pola (kolumny).


Do utworzenia samosprzężenia potrzebne są dwa wystąpienia tabeli.

W okienku tabel znajdują się dwie różne tabele, a w oknie dialogowym Sprzężenia zdefiniowano samosprzężenie, używając tej samej nazwy tabeli w polach Lewa i Prawa.

  • Do utworzenia samosprzężenie potrzebne są dwa wystąpienia tej samej tabeli w okienku tabel.
  • Aby połączyć dwie różne tabele, trzeba użyć jednej tabeli jako lewej strony, a drugiej jako prawej strony sprzężenia.


Długość <liczba> musi być wyrażona wartością numeryczną.

W polu Długość użyto wartości nienumerycznej. Zmień wartość na liczbę.


W nazwie <nazwa> wystąpił błąd.

Nazwa tabeli i nazwy pól muszą być zgodne z konwencją nazw stosowaną w wymaganym źródle danych. Zapoznaj się z dokumentacją źródła danych.


Liczba miejsc po przecinku musi być mniejsza lub równa całkowitej długości.

W polu Dziesiętne wprowadzono większą liczbę niż w polu Długość. Zmień wartość w polu Dziesiętne na liczbę mniejszą lub równą liczbie w polu Długość.


Maksymalna długość dla typu <nazwa typu danych> wynosi <liczba>

W polu Długość wprowadzono wartość, która jest większa niż maksymalna długość dozwolona dla pola zawierającego ten typ danych.


Nie można odświeżyć.

Program Microsoft Query nie może zaktualizować listy tabel w oknie dialogowym Dodaj tabele, ponieważ źródło danych nie odpowiada. Upewnij się, że nadal istnieje połączenie ze źródłem danych.


Nie można usunąć źródła danych.

Program Microsoft Query nie może usunąć wybranego źródła danych. Aby usunąć źródło danych, należy się z nim rozłączyć.


Ogólny błąd ODBC.

Program Microsoft ODBC lub źródło danych informuje o wystąpieniu błędu, nie przekazując żadnych szczegółowych informacji. Upewnij się, że baza danych jest uruchomiona i dostępna, i spróbuj ponowić operację.


Błąd składni w klauzuli GROUP BY.

Instrukcja SQL zawiera nieprawidłową klauzulę GROUP BY. Przyczyną może być błędnie wpisane lub pominięte słowo kluczowe lub niepoprawna interpunkcja.


Błąd składni w klauzuli HAVING.

Instrukcja SQL zawiera nieprawidłową klauzulę HAVING. Przyczyną może być błędnie wpisane lub pominięte słowo kluczowe lub niepoprawna interpunkcja.


Błąd składni w wyrażeniu JOIN.

W instrukcji SQL po klauzuli ON nie następuje prawidłowe wyrażenie. Wyrażenie powinno mieć następujący format:

{oj C:\QT\zamow zamow LEFT OUTER JOIN C:\QT\ szczeg szczeg ON zamow.ZAM_ID = szczeg.ZAM_ID}


Błąd składni w klauzuli ORDER BY.

Instrukcja SQL zawiera nieprawidłową klauzulę ORDER BY. Przyczyną może być błędnie wpisane lub pominięte słowo kluczowe lub niepoprawna interpunkcja.


Najpierw wybierz źródło danych.

Próbujesz uruchomić instrukcję SQL przed wybraniem źródła danych. Kliknij przycisk ródła danych w oknie dialogowym Wykonanie instrukcji SQL, a następnie wybierz źródło danych.


Oczekiwano operatora sprzężenia po tabeli <nazwa>

W klauzuli LEFT OUTER JOIN lub RIGHT OUTER JOIN pominięto operator = pomiędzy dwoma nazwami tabel w wyrażeniu. Sprzężenia zewnętrzne muszą być sprzężeniami równoważnymi (zawierającymi operator =).


Po tabeli <nazwa> oczekiwano słowa kluczowego LEFT lub RIGHT

Instrukcja SQL zawiera klauzulę OUTER JOIN niepoprzedzoną słowem kluczowym LEFT lub RIGHT. Klauzula sprzężenia zewnętrznego w instrukcji SQL musi mieć postać LEFT OUTER JOIN lub RIGHT OUTER JOIN.


Po klauzuli 'HAVING' oczekiwane jest wyrażenie.

W instrukcji SQL po klauzuli HAVING nie występuje warunek wyszukiwania.


Po klauzuli 'WHERE' oczekiwane jest wyrażenie.

W instrukcji SQL po klauzuli WHERE nie występuje warunek wyszukiwania.


Po klauzuli 'FROM' oczekiwana jest nazwa tabeli.

Instrukcja SQL zawiera klauzulę FROM, po której nie występuje nazwa tabeli.


Tekst jest zbyt długi; anulowano wklejanie.

Tekst znajdujący się w Schowku jest zbyt długi, aby go dopasować do wybranego pola w okienku danych lub okienku kryteriów. Maksymalna liczba znaków, które można umieścić w polu, zależy od określonej podczas tworzenia tabeli długości pola.


Podczas ładowania wystąpił błąd We-Wy.

Program Microsoft Query nie może otworzyć lub odczytać wybranego pliku. Być może wystąpił błąd dysku lub plik jest uszkodzony.


Nie można odczytać pliku.

Program Microsoft Query nie może odczytać pliku. Być może plik jest zapisany w innym formacie niż format programu Microsoft Query lub format Q+E, wystąpił błąd dysku lub plik jest uszkodzony.


Podczas zapisywania wystąpił błąd We-Wy.

Program Microsoft Query nie może zapisać kwerendy na dysku. Być może wystąpił błąd dysku.


Nie można ustawić kryterium przed określeniem pola.

Przed określeniem kryterium dla pola należy dodać to pole do okienka kryteriów.


Sterownik nie obsługuje wszystkich funkcji.

Wprowadzone wyrażenie zawiera jedną lub więcej funkcji, które nie są obsługiwane przez źródło danych. Aby określić, które funkcje są obsługiwane przez źródło danych, zapoznaj się z dokumentacją dostarczoną ze sterownikiem używanym ze źródłem danych lub skontaktuj się z producentem sterownika.


Nie można utworzyć indeksu.

ródło danych dla tej tabeli nie obsługuje indeksów.


Indeks został utworzony pomyślnie.

Program Microsoft Query pomyślnie utworzył indeks w określonym polu lub polach tabeli.


Zamknięto lub zmieniono komunikację DDE.

Inny program nieoczekiwanie zamknął lub zmienił komunikację dynamicznej wymiany danych (DDE, Dynamic Data Exchange), prawdopodobnie za pomocą instrukcji DDETerminate lub DDETerminateAll.

Zamknij bieżącą komunikację, a następnie utwórz nową komunikację z innym programem.


Szerokość musi zawierać się w zakresie od 0 do <liczba>

Podaj szerokość kolumny mieszczącą się w tym zakresie lub w oknie dialogowym Szerokość kolumny zaznacz opcję Szerokość standardowa.


Nieprawidłowa nazwa pliku.

Nazwy plików muszą być zgodne ze standardową konwencją nazw stosowaną w wymaganym źródle danych. Zapoznaj się z dokumentacją źródła danych.


Wysokość musi zawierać się w zakresie od 1 do <liczba>

Podaj wysokość wiersza mieszczącą się w tym zakresie lub w oknie dialogowym Wysokość wiersza zaznacz opcję Wysokość standardowa.


Lewe i prawe sprzężenia zewnętrzne muszą być równoważne.

W klauzuli LEFT OUTER JOIN lub RIGHT OUTER JOIN pominięto operator = pomiędzy dwiema nazwami tabel w wyrażeniu lub użyto innego operatora. Sprzężenia zewnętrzne muszą być równoważne (operator =).


Kolumny <nazwa> i <nazwa>, między którymi ma powstać sprzężenie, są różnych typów. Utworzyć sprzężenie mimo to?

Podjęto próbę utworzenia sprzężenia pól (kolumn) zawierających różnego typy danych. Mogło to na przykład dotyczyć sprzężenia pola zawierającego daty i pola zawierającego tekst.

  • Aby zapobiec utworzeniu sprzężenia, kliknij przycisk Anuluj.
  • Aby utworzyć sprzężenie, kliknij przycisk OK.

Uwaga Sprzężenia tego typu mogą nie dawać właściwych wyników. Upewnij się, że program Microsoft Query wyświetla właściwe dane w zestawie wyników.


Po 'OUTER' oczekiwane jest 'JOIN'.

Instrukcja SQL zawiera klauzulę LEFT OUTER lub RIGHT OUTER zamiast klauzuli LEFT OUTER JOIN lub RIGHT OUTER JOIN. Słowo JOIN zostało błędnie wpisane lub pominięte.


Nieudana transakcja DDE. Sprawdź, czy zainstalowano właściwą wersję DDEML.DLL.

Instalacja programu Microsoft Query jest niepełna lub uszkodzona. Aby zlikwidować problem, zainstaluj ponownie program Microsoft Query i wybierz opcję naprawy.


Nie można otrzymać sprzężeń zewnętrznych, jeśli w kwerendzie jest więcej niż dwie tabele.

Podczas używania sprzężenia zewnętrznego w okienku tabel mogą znajdować się najwyżej dwie tabele. Usuń dodatkowe tabele z okienka tabel, a następnie utwórz sprzężenie zewnętrzne.


Kolejka komunikatów zapełniona — utracono komunikat DDE.

Program Microsoft Query nie może przechowywać jednocześnie zbyt dużej liczby prób operacji dynamicznej wymiany danych (DDE).

Zamknij niektóre komunikacje DDE, a następnie ponów próbę wykonania operacji.


Wartość musi być liczbą.

Dla opcji, która wymaga wartości liczbowych, wprowadzono wartość, która nie jest liczbą,. Wprowadź liczbę.


Dana aplikacja nie wykonuje rozpoczętej operacji DDE.

Dany program nie może wykonać rozpoczętej operacji dynamicznej wymiany danych (DDE).

  • Możliwe, że przesłano dane lub polecenia, których nie może rozpoznać. Zapoznaj się z dokumentacją programu, aby określić rozpoznawane przez niego dane i polecenia.
  • Wywołana aplikacja może nie rozpoznać argumentu Element na podstawie zdefiniowanego tematu komunikacji. Zapoznaj się z dokumentacja programu, aby sprawdzić, które elementy są rozpoznawane.


Nie można otworzyć kanału DDE; program Microsoft Query nie odnalazł podanego programu i tematu

Program Microsoft Query nie może zlokalizować podanego programu i tematu (tematu komunikacji DDE). Upewnij się, że program docelowy jest uruchomiony, temat jest otwarty, a podczas definiowania komunikacji DDE nie popełniono błędów w nazwie programu i tematu.


Nie można zapisać kolumny <nazwa> w tym źródle danych

Podjęto próbę zapisania zestawu wyników jako tabeli, ale źródło danych, w którym próbowano dokonać zapisu, nie obsługuje typu danych tego pola lub nie może dokonać konwersji do porównywalnego typu danych. Należy spróbować zapisać tabelę w innym źródle danych, obsługującym ten typ danych.


Za mało zasobów systemu do aktualizacji ekranu.

Program Microsoft Query ma za mało wolnej pamięci, aby zakończyć operację.

Zamknij okna programu Microsoft Query lub inne programy. Jeżeli błąd się powtarza, uruchom ponownie system Microsoft Windows i ponów próbę przeprowadzenia operacji.


Nie można uzyskać dostępu do tabeli <nazwa>.

Określona tabela nie może być odnaleziona, jest zablokowana przez innego użytkownika lub inną uruchomioną kwerendę lub zawiera nieprawidłowe pola.


Nie można wyświetlić Pomocy.

W bieżącym folderze nie ma pliku Pomocy programu Microsoft Query. Przenieś lub skopiuj plik do bieżącego folderu.


Nie można pobrać procedur.

Program Microsoft Query nie może wyświetlić listy procedur ze źródła danych, ponieważ źródło danych nie odpowiada. Być może źródło danych jest rozłączone.


Nie można odnaleźć procedur.

ródło danych nie zawiera żadnych procedur. Aby utworzyć procedury, zapoznaj się z dokumentacją źródła danych.


Nie można usunąć — inne kwerendy korzystają z tego źródła.

Co najmniej jedna kwerenda używa źródła danych, które chcesz usunąć. Trzeba najpierw zamknąć kwerendy, które używają źródła danych.


Rekord nie istnieje.

Rekord o określonym numerze nie istnieje. Numer rekordu jest zbyt duży lub zbyt mały. Upewnij się, że w okienku danych są rekordy, a następnie sprawdź, czy poprawnie wprowadzono numer rekordu.


W tabeli nie istnieją unikatowe indeksy. Czy chcesz je utworzysz?

Zestaw wyników, który chcesz zapisać jako nową tabelę, pochodzi z tabeli, która nie zawiera unikatowego indeksu.

  • Aby wyświetlić okno dialogowe Tworzenie indeksu umożliwiające utworzenie dla tabeli unikatowego indeksu, kliknij przycisk Tak.
  • Jeżeli nie chcesz utworzyć indeksu, kliknij przycisk Nie.


Nie można pobrać wartości.

Program Microsoft Query nie może wyświetlić wartości wybranych dla kryteriów. Być może jest za mało pamięci lub przerwano połączenie ze źródłem danych.

Jeżeli istnieje połączenie ze źródłem danych, spróbuj zamknąć inne okna w programie Microsoft Query lub inne programy. Jeżeli błąd się powtarza, uruchom ponownie system Microsoft Windows.


Nie można utworzyć nowego okna.

Program Microsoft Query nie może wyświetlić wybranego pliku, ponieważ jest za mało pamięci.

Zamknij inne okna programu Microsoft Query lub inne programy. Jeżeli błąd się powtarza, uruchom ponownie system Microsoft Windows.


Nie można cofnąć operacji. Czy mimo to chcesz kontynuować?

W przypadku tej operacji polecenie Cofnij jest niedostępne, ponieważ jest za mało wolnej pamięci lub zmiany danych są zbyt duże.

  • Aby kontynuować operację bez możliwości cofnięcia, kliknij przycisk OK.
  • Aby przerwać operację, kliknij przycisk Anuluj.


Po prawej tabeli sprzężenia oczekiwane jest 'ON'.

Instrukcja SQL zawiera klauzulę LEFT OUTER JOIN lub RIGHT OUTER JOIN i odpowiednie wyrażenie, ale po wyrażeniu nie występuje klauzula ON i odpowiednie wyrażenia. Słowo ON zostało błędnie wpisane lub pominięte.


Kwerenda może mieć tylko jedno sprzężenie zewnętrzne.

W kwerendzie może występować tylko jedno sprzężenie zewnętrzne.


Należy wybrać jedną wartość dla operatora <operator>

Podczas definiowania kryteriów za pomocą tego operatora należy użyć tylko jednej wartości. Program Microsoft Query wybiera potem tylko te rekordy, które zawierają wartość w polu, dla którego ustalono kryteria. Na przykład, jeżeli w polu Operator wybrano pozycję „zaczyna się od”, program Microsoft Query przeszukuje pole, w przypadku którego ustalono kryteria dla wartości rozpoczynających się od podanej wartości. Tylko takie rekordy są wybrane do zestawu wyników.


Należy wybrać dwie wartości dla operatora <operator>

Podczas definiowania kryteriów za pomocą tego operatora należy użyć dwóch wartości. Na przykład, jeżeli w polu Operator wybrano opcję „jest pomiędzy”, wyszukiwane będą pola zawierające wartości mieszczące się między dwoma określonymi wartościami. Tylko takie rekordy są wybrane do zestawu wyników.


Nie można otworzyć pliku.

Program Microsoft Query nie może otworzyć określonego pliku kwerendy. Być może wystąpił błąd dysku lub plik jest uszkodzony.


Nie można otworzyć pliku.

Program Microsoft Query nie może otworzyć lub odczytać pliku Microsoft Query określonego w oknie dialogowym Wykonanie instrukcji SQL. Plik nie jest zapisany w formacie tekstowym, wystąpił błąd dysku lub plik jest uszkodzony.


Po 'LEFT/RIGHT' oczekiwane jest 'OUTER'.

Instrukcja SQL zawiera klauzulę sprzężenia zewnętrznego LEFT lub RIGHT, ale zostało pominięte słowo kluczowe OUTER. Klauzula sprzężenia zewnętrznego w instrukcji SQL musi mieć postać LEFT OUTER JOIN lub RIGHT OUTER JOIN.


Sprzężenie zewnętrzne jest możliwe tylko dla dwóch tabel. Czy usunąć sprzężenie zewnętrzne, aby dodać tabelę?

W okienku tabel znajdują się już dwie tabele połączone sprzężeniem zewnętrznym. Aby umieścić w okienku tabel trzy tabele lub więcej, należy usunąć sprzężenie zewnętrzne lub zamienić je na sprzężenie wewnętrzne.


Liczba jest zbyt duża.

Wprowadź mniejszą wartość.


Wyrażenie jest za długie.

Wyrażenie jest zbyt długie, aby mogło być oszacowane przez program Microsoft Query. Spróbuj skrócić wyrażenie lub podzielić je na dwa oddzielne wyrażenia.


Nie można uzyskać dostępu do <bazy danych>.

Używane źródło danych ogranicza możliwość dodawania tabel do bieżącej bazy danych (lub jej odpowiednika).


Zmienianie nagłówka kolumny na bardziej opisowy

  1. Kliknij dwukrotnie nagłówek kolumny pola, dla którego chcesz wprowadzić nowy nagłówek.
  2. W polu Nagłówek kolumny wpisz żądany nagłówek.


Zmienianie szerokości kolumny lub wysokości wszystkich wierszy

Zmiana szerokości kolumny Aby zmienić szerokość kolumny, należy wskazać prawe obramowanie nagłówka kolumny i przeciągać je aż do uzyskania odpowiedniej szerokości kolumny.

Porada Aby szybko dostosować szerokość kolumny do szerokości największej wartości w kolumnie, należy kliknąć dwukrotnie prawe obramowanie nagłówka kolumny.

Zmiana wysokości wiersza Aby zmienić wysokość wszystkich wierszy, należy wskazać dolne obramowanie dowolnego nagłówka wiersza i przeciągać je aż do uzyskania odpowiedniej wysokości.

Uwaga Zmiana wysokości wiersza wpływa na wszystkie wiersze w zestawie wyników.


Zmienianie czcionki, stylu lub rozmiaru tekstu w zestawie wyników

  1. W menu Format kliknij polecenie Czcionka.
  2. Wprowadź żądane zmiany.


Zmienianie typu sprzężenia między tabelami w kwerendzie

  1. Kliknij dwukrotnie linię sprzężenia między tabelami.
  2. Aby wybrać operator, którego program Microsoft Query użyje do porównywania danych w sprzężonych polach, kliknij odpowiedni operator w polu Operator. Aby uzyskać więcej informacji, kliknij przycisk Obrazek przycisku .
  3. Aby utworzyć sprzężenie zewnętrzne, które wykorzystuje wszystkie rekordy z tabeli po lewej stronie, kliknij opcję 2 w obszarze Sprzężenie zawiera. Tworząc sprzężenia zewnętrzne, należy wybrać operator =.

    Aby utworzyć sprzężenie zewnętrzne, które wykorzystuje wszystkie rekordy z tabeli po prawej stronie, kliknij opcję 3 w obszarze Sprzężenie zawiera.

    Aby utworzyć sprzężenie wewnętrzne, które wykorzystuje rekordy z obydwu tabel, kliknij opcję 1 w obszarze Sprzężenie zawiera.

  4. Kliknij przycisk Dodaj.
  5. Kliknij przycisk Zamknij.

    Aby uzyskać więcej informacji na temat typów sprzężeń i ich wpływu na wyniki kwerendy, kliknij przycisk Obrazek przycisku


Tworzenie bardziej złożonej kwerendy w programie Microsoft Query

  1. Kliknij przycisk Nowa kwerenda Obrazek przycisku.
  2. Na karcie Bazy danych kliknij bazę danych, z której chcesz pobrać dane lub utwórz nowe źródło danych.

    Jak?

  3. Wyczyść pole wyboru Użyj Kreatora kwerend do tworzenia/edycji kwerend, a następnie kliknij przycisk OK.
  4. Dodaj żądane tabele.

    Jak?

  5. Dodaj pola, które mają być wyświetlane w zestawie wyników.

    Jak?

    Chcąc tak zawęzić zestaw wyników, aby zawierał tylko określone rekordy, wprowadź kryteria filtrujące rekordy.

    Jak?

    Chcąc utworzyć kwerendę parametryczną, która po uruchomieniu wyświetla monit o podanie kryteriów, określ kryteria.

    Jak?

    Aby zmienić zestaw wyników można również utworzyć sprzężenie wewnętrzne lub sprzężenie zewnętrzne pomiędzy tabelami.

    Jak?

Uwagi

  • Po zakończeniu pobierania danych można zwrócić zestaw wyników do programu Microsoft Excel. Aby uzyskać więcej informacji, kliknij przycisk Obrazek przycisku .
  • Aby zatrzymać wykonywanie kwerendy, która jest zbyt czasochłonna, należy nacisnąć klawisz ESC.
  • Chcąc rozpocząć pobieranie danych dopiero po zakończeniu dodawania pól do zestawu wyników, należy się upewnić, że przycisk Autokwerenda Obrazek przycisku nie jest wciśnięty. Po zakończeniu przygotowywania kwerendy należy kliknąć przycisk Wykonaj kwerendę Obrazek przycisku.
  • Chcąc zapobiec uruchamianiu kwerendy przed jej zapisaniem lub zwróceniem danych do programu Excel, należy kliknąć polecenie Opcje w menu Edycja, a następnie wyczyścić pole wyboru Sprawdź kwerendy przed zapisaniem lub zwróceniem danych.


Tworzenie kwerendy za pomocą Kreatora kwerend

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

  1. Kliknij przycisk Nowa kwerenda Obrazek przycisku.
  2. Zaznacz pole wyboru Używaj Kreatora kwerend do tworzenia/edycji kwerend.
  3. Na karcie Bazy danych kliknij dwukrotnie bazę danych, z której chcesz pobrać dane.

    Jeśli trzeba skonfigurować nowe źródło danych, kliknij dwukrotnie przycisk Nowe źródło danych, a następnie określ źródło danych.

  4. Postępuj zgodnie z instrukcjami wyświetlanymi przez Kreatora kwerend.
  5. W oknie dialogowym Kreator kwerend — Zakończenie wykonaj jedną z następujących czynności:

    Aby zwrócić dane bezpośrednio do programu Microsoft Excel, kliknij przycisk Zwróć dane do programu Microsoft Excel, kliknij przycisk Zakończ, a następnie wybierz miejsce, w którym chcesz umieścić zewnętrzne dane.

    Aby zapisać kwerendę w pliku kwerendy dqy, który można otworzyć i edytować w programie Microsoft Query lub otworzyć i uruchomić w programie Excel, kliknij przycisk Zapisz kwerendę. Powyższy opcjonalny krok jest polecany, jeśli w planach jest utworzenie z kwerendy modułu OLAP.

    Aby uruchomić Kreatora modułów OLAP, w którym można utworzyć moduł z danych zawartych w kwerendzie, kliknij przycisk Utwórz moduł OLAP z tej kwerendy, kliknij przycisk Zakończ, a następnie postępuj według zaleceń kreatora. Opcja ta jest polecana tylko doświadczonym użytkownikom. Dowiedz się więcej na temat tworzenia modułów OLAP.

    Aby jeszcze bardziej zawęzić kwerendę, kliknij przycisk Wyświetl dane lub edytuj kwerendę w programie Microsoft Query, a następnie kliknij przycisk Zakończ. Zestaw wyników jest wyświetlany w okienku danych, gdzie można wprowadzić dalsze zmiany, a następnie zwrócić zestaw wyników do programu Microsoft Excel.

Porada Aby zatrzymać wykonywanie kwerendy, która jest zbyt czasochłonna, należy nacisnąć klawisz ESC.


Usuwanie danych z bazy danych, w której wykonano kwerendę

Przestroga W przypadku usunięcia rekordu z bazy danych jest on trwale usuwany zarówno z zestawu wyników, jak i bazy danych.

  1. Upewnij się, że w menu Rekordy jest zaznaczone polecenie Zezwalaj na edycję.

    W niektórych przypadkach program Microsoft Query nie będzie zezwalał na dokonywanie zmian danych. Jeśli polecenie Zezwalaj na edycję jest wygaszone lub po kliknięciu polecenia Zezwalaj na edycję program Microsoft Query wyświetla komunikat, oznacza to, że zmiana danych jest niemożliwa. Aby uzyskać więcej informacji, kliknij przycisk Obrazek przycisku .

  2. Zaznacz cały rekord, który chcesz usunąć, klikając kwadrat znajdujący się po jego lewej stronie.
  3. W menu Edycja kliknij polecenie Usuń.


Zmienianie danych w bazie, w której wykonano kwerendę

  1. Upewnij się, że w programie Microsoft Query polecenie Zezwalaj na edycję w menu Rekordy jest zaznaczone.

    W niektórych przypadkach program Microsoft Query nie będzie zezwalał na dokonywanie zmian danych. Jeśli polecenie Zezwalaj na edycję jest wygaszone lub po kliknięciu polecenia Zezwalaj na edycję program Microsoft Query wyświetla komunikat, oznacza to, że zmiana danych jest niemożliwa. Aby uzyskać więcej informacji, kliknij przycisk Obrazek przycisku .

  2. W zestawie wyników kliknij pole, które chcesz zmienić.
  3. Dokonaj wymaganych zmian w informacjach, a następnie kliknij przycisk ENTER.

Uwaga W przypadku popełnienia błędu można cofnąć ostatnio dokonaną zmianę, wybierając z menu Edycja polecenie Cofnij. Zmianę należy cofnąć przed przełączeniem do innego rekordu lub okna.


Wstawianie pola do zestawu wyników

  1. Kliknij nagłówek kolumny wybranego pola na prawo od miejsca, w którym chcesz wstawić nowe pole.
  2. W menu Rekordy kliknij polecenie Dodaj kolumnę.
  3. W polu Pole wybierz kolumnę, którą chcesz wstawić.

    W polu Nagłówek kolumny można wpisać nowy, bardziej opisowy nagłówek kolumny.

  4. Kliknij przycisk Wstaw.

Uwaga Aby szybko wstawić pole do zestawu wyników, można przeciągnąć do niego pole z okienka tabel.


Zmienianie kolejności pól w zestawie wyników

  1. Kliknij nagłówek kolumny pola, które chcesz przenieść.
  2. Przenieś wskaźnik na nagłówek kolumny, a następnie przeciągnij kolumnę w odpowiednie miejsce.


Ukrywanie i wyświetlanie pola w zestawie wyników

  1. Kliknij nagłówek kolumny pola, które chcesz ukryć.
  2. W menu Format kliknij polecenie Ukryj kolumny.

Aby wyświetlić ukryte kolumny, kliknij polecenie Pokaż kolumny w menu Format, zaznacz żądaną kolumnę, a następnie kliknij przycisk Pokaż.


Cofanie zmian w danych bazy danych, w której wykonano kwerendę

  • W menu Edycja kliknij polecenie Cofnij.

Uwaga Można odwrócić tylko ostatnią zmianę wprowadzoną w danych. Należy ją cofnąć przed przejściem do innego rekordu lub okna.


Wyświetlany jest komunikat informujący o nieprawidłowej ścieżce dostępu do bazy danych

Sprawdź istnienie zamapowanych dysków sieciowych Jeśli baza danych znajduje się w udostępnionym katalogu sieciowym, podczas tworzenia źródła danych i wybierania pliku bazy danych ścieżka do bazy danych mogła zostać zapisana w źródle danych z użyciem literowego oznaczenia dysku używanego przez system w danej chwili. Na przykład, jeżeli baza danych nosi nazwę Magazyn.mdb, a podczas zapisywania bazy udostępniony katalog sieciowy znajdował się na dysku zamapowanym pod literą G, w źródle danych lokalizacja ta mogła zostać zapisana jako G:\Publiczne\Magazyn.mdb. Jeżeli mapowanie dysków sieciowych ulegnie potem zmianie, to w razie próby ponownego wykorzystania tego źródła danych lub po uruchomieniu korzystających z niego kwerend sterownik ODBC wyświetli komunikat mówiący o nieprawidłowej ścieżce dostępu do bazy danych.

Użyj rozwiązań innych niż mapowanie dysków Jeśli korzystasz ze sterowników programów Microsoft Access lub Microsoft Excel, problem ten można rozwiązać przez utworzenie nowego źródła danych. Podczas określania lokalizacji pliku bazy danych nie należy dla lokalizacji udostępnionego katalogu sieciowego wybierać zamapowanego dysku. W zamian należy wpisać adres UNC udostępnionego katalogu sieciowego, a następnie zlokalizować plik bazy danych. Jeśli na przykład baza danych jest zapisana na serwerze o nazwie Udostępniony, można wpisać ścieżkę \\Udostępniony\publiczne i zaznaczyć plik Magazyn.mdb.

Zamapuj dysk sieciowy pod tą samą literą przed użyciem źródła danych W przypadku innych sterowników ODBC przed użyciem źródła danych lub uruchomieniem kwerendy związanej z tym źródłem upewnij się, że dysk, na którym znajduje się udostępniony katalog sieciowy zawierający bazę danych, jest zamapowany pod tą samą literą, co w momencie tworzenia źródła danych.


Używany wcześniej sterownik ODBC nie działa

Użycie innego sterownika z programem Microsoft Query 2000 może być konieczne w następujących przypadkach:

Upewnij się, że korzystasz z 32-bitowego sterownika ODBC Program Microsoft Query wymaga 32-bitowych sterowników ODBC, takich jak te dostarczane wraz z programem Microsoft Query 97 lub nowszym. Jeśli na przykład w języku Visual Basic zostanie utworzony program do pobierania danych zewnętrznych, korzystający z programu Microsoft Excel i program ten zostanie przekazany użytkownikom programu Microsoft Excel w wersji 5.x, może on nie działać z 16-bitowymi sterownikami ODBC programu Microsoft Excel w wersji 5.x.

Upewnij się, że korzystasz ze sterowników firmy Microsoft w wersji 3.0 lub nowszej Jeśli użytkownik instaluje sterowniki ODBC firmy Microsoft inne niż te dołączone do najnowszych wersji programu Microsoft Excel czy pakietu Microsoft Office, należy się upewnić, że są to sterowniki w wersji 3.0 lub nowszej. Wcześniejsze wersje sterowników ODBC firmy Microsoft mogą nie współpracować z programem Microsoft Query 2000 i nowszym. Sterowniki dostarczane razem z programami Microsoft Excel 97 i Microsoft Office 97 są w wersji 3.0 lub nowszej. W trakcie instalacji tych sterowników starsze wersje istniejące w systemie powinny być zastępowane automatycznie.

Upewnij się, że korzystasz z odpowiedniej wersji sterownika dostarczonego przez inną firmę W razie korzystania ze sterownika ODBC dostarczonego przez inną firmę po zaktualizowaniu bazy danych lub zainstalowaniu jej nowej wersji może zaistnieć konieczność zainstalowania nowego sterownika dla programu Microsoft Query. Aby stwierdzić, czy zachodzi taka konieczność, należy sprawdzić informacje w dokumentacji stosowanego systemu obsługi bazy danych.

Upewnij się, że źródło danych dla sterownika zostało skonfigurowane za pomocą programu Microsoft Query Program Microsoft Query nie może uzyskać dostępu do źródeł danych utworzonych za pomocą Kreatora łączenia danych.


Pola daty lub godziny są niepoprawnie dzielone

Sprawdź pole daty lub godziny w źródłowej bazie danych Jeśli w module OLAP nie widać spodziewanych poziomów w wymiarach daty lub godziny, sprawdź pole daty lub godziny w podstawowej relacyjnej bazie danych, która dostarcza rekordy dla kwerendy. Daty i godziny w rekordach mogą być przechowywane jako tekst, a nie w formacie daty lub godziny, który może być rozpoznawany przez Kreatora modułów OLAP. Jeżeli podejrzewasz, że tak jest, skonsultuj się z administratorem relacyjnej bazy danych, aby zweryfikować i poprawić format daty lub godziny dla pola.

Sprawdź najwyższy poziom wymiaru Gdy Kreator modułów OLAP dodaje pola daty lub godziny jako dolne poziomy istniejącego wymiaru, nie dzieli automatycznie danych na poziomy rok/kwartał/miesiąc/tydzień i godzina/minuta/sekunda. Kreator zrobi tak jedynie wówczas, gdy pole daty lub godziny zostanie dodane jako najwyższy poziom nowego wymiaru. Jeśli pole daty lub godziny nie jest najwyższym poziomem, zmodyfikuj moduł.


Zmiany i formatowanie wprowadzone w kwerendzie nie pojawiają się przy następnym uruchomieniu

Program Microsoft Excel nie zapisuje zmian formatowania w kwerendach Kiedy dane są zwracane do programu Microsoft Excel, definicja kwerendy jest zapisywana jako część arkusza roboczego, lecz nie jest automatycznie zapisywany oddzielny plik kwerendy. Przy późniejszej edycji kwerendy dla zakresu danych zewnętrznych zmiany formatowania i nagłówków kolumn wprowadzone w programie Microsoft Query nie są zapisywane.

Zmiany formatowania nie są zapisywane w plikach kwerend dqy Podczas zapisywania pliku w formacie dqy zmiany formatowania i nagłówki kolumn nie są zapisywane.

Zmiany formatowania są zapisywane w plikach kwerend qry Aby zapisać formatowanie w programie Microsoft Query, należy wprowadzić zmiany formatowania, kliknąć polecenie Zapisz jako w menu Plik tego programu, a następnie kliknąć pozycję Pliki kwerend (*.qry) na liście Zapisz jako typ. Przy powtórnym otwarciu pliku kwerendy zostanie odtworzone formatowanie wprowadzone w programie Microsoft Query.


Przy zmianie modułu OLAP pojawia się komunikat o utracie danych

Pole włączone do modułu nie jest już dostępne w źródłowej bazie danych.

Sprawdź zmiany dokonane w pierwotnej bazie danych Można otworzyć kwerendę bazy danych, jeśli została zapisana kwerenda utworzona przy tworzeniu modułu po raz pierwszy, albo utworzyć nową kwerendę. W kwerendzie sprawdź okienko danych, aby upewnić się, czy wszystkie pierwotnie uwzględniane pola są uwzględnione w kwerendzie. W okienku tabel można przewijać pola, aby sprawdzić, czy wszystkie są dostępne.

Jeśli nie można otworzyć istniejącej kwerendy ani utworzyć nowej, skontaktuj się z administratorem bazy danych, aby uzyskać informacje, w jaki sposób baza danych została zmieniona.

Utwórz nowy moduł Jeśli pola zostały usunięte z bazy danych, można utworzyć nowy moduł.


Nie mogę dodać pól do modułu OLAP

Po zdefiniowaniu modułu OLAP za pomocą Kreatora modułów OLAP nie można dodawać pól z pierwotnej relacyjnej bazy danych. Aby dodać więcej pól, należy zmodyfikować plik kwerendy bazy danych (dqy), a następnie odtworzyć moduł.

Otwórz lub utwórz kwerendę Jeśli została zapisana kwerenda utworzona przy tworzeniu modułu, można otworzyć plik dqy. Jeśli kwerenda nie została zapisana, można utworzyć nową kwerendę.

Dodaj pola do kwerendy Dodaj pola, które są potrzebne, do kwerendy. Jeśli uważasz, że będziesz w przyszłości potrzebować modułu o innych polach, zapisz kopię kwerendy, aby nie trzeba było jej za każdym razem odtwarzać.

Utwórz nowy moduł Po utworzeniu kwerendy ze wszystkimi potrzebnymi polami można utworzyć nowy moduł.


Funkcja podsumowania potrzebna dla danych modułu jest niedostępna

Przy korzystaniu z Kreatora modułów OLAP do tworzenia modułu z rekordów relacyjnej bazy danych jedynymi funkcjami podsumowania, dostępnymi do obliczania wartości pól danych, są funkcje Suma, Licznik, Min i Max.

Utwórz raport bezpośrednio z rekordów bazy danych Chcąc uściślić kwerendę, aby ilość zwracanych danych nie przekraczała możliwości systemu i aby nie trzeba było tworzyć modułu OLAP dla danych, spróbuj zwrócić rekordy w kwerendzie do programu Microsoft Excel, zamiast tworzyć moduł.

Kiedy w programie Excel tworzona jest tabela przestawna lub raport wykresu przestawnego, który został oparty bezpośrednio na kwerendzie relacyjnej bazy danych, a nie na module, dostępnych jest więcej funkcji podsumowania: Suma, Licznik, Średnia, Max, Min, Iloczyn, Licznik num., OdchStd, OdchStdc, Wariancja i Warc. Więcej informacji na temat tych funkcji podsumowania i sposobu ich używania można znaleźć w Pomocy programu Excel.

Rozważ zainstalowanie serwera OLAP dla bazy danych Program firmy Microsoft o nazwie Microsoft SQL Server OLAP Services umożliwia skonfigurowanie szerszego zakresu pól podsumowań niż oprogramowanie klienta OLAP włączone do pakietu Microsoft Office.


Gdy próbuję zapisać plik modułu offline, brakuje miejsca na dysku

Relacyjna baza danych, dla której tworzysz moduł, może być bardzo duża. Jeśli dla pliku modułu offline określisz duży podzbiór danych, może się wyczerpać miejsce na lokalnym dysku twardym.

Zwolnij miejsce na dysku lub znajdź inny dysk Przed zapisaniem pliku usuń z dysku wszelkie niepotrzebne pliki albo spróbuj zapisać plik na dysku sieciowym.

Uwzględnij mniej danych w pliku modułu offline Rozważ, jak zminimalizować ilość danych w pliku i nadal mieć dane potrzebne do raportu tabeli przestawnej lub wykresu przestawnego programu Microsoft Excel. Spróbuj wykonać następujące czynności:

  • Uwzględnij jedynie te pola, które są bezwzględnie konieczne W kroku 1 Kreatora modułów OLAP wybierz tylko te pola danych raportu, które mają być wyświetlane.
  • Uwzględnij jedynie te wymiary, które będą używane W kroku 2 Kreatora modułów OLAP wybierz tylko te pola, które w raportach będą wyświetlane jako wymiary i poziomy. Instrukcje dotyczące tworzenia wymiarów można znaleźć w Pomocy Kreatora modułów OLAP.

Użyj modułu tymczasowego zamiast pliku modułu offline Jeśli wszystkie możliwe dane zostały wyeliminowane, lecz nadal nie można zapisać pliku modułu offline, należy spróbować użyć pierwszej opcji w kroku 3 Kreatora modułów OLAP, która zapewnia minimalne użycie miejsca na dysku. Kiedy jest otwierany raport oparty na module, opcja ta odtwarza moduł w pamięci i pobiera tylko dane niezbędne do wyświetlania raportu.


Nie mogę dodać, skopiować lub przenieść rekordu w bazie danych

W programie Microsoft Query 2000 i nowszych można edytować i usuwać rekordy znajdujące się w bazie danych, ale nie można zmienić kolejności rekordów ani użyć programu Query do dodania rekordów do baz danych, do których dostęp zapewnia sterownik programu Microsoft Excel lub Microsoft Text.

Pracuj bezpośrednio w bazie danych Chcąc skopiować rekord, otwórz bazę danych bezpośrednio i użyj poleceń dostępnych w bazie danych. Aby uzyskać potrzebne informacje i instrukcje, skontaktuj się z administratorem bazy danych.

Posortuj rekordy w programie Query Można zmienić kolejność rekordów w zestawie wyników przy użyciu polecenia Sortuj w menu Rekordy. Sortowanie w programie Microsoft Query nie zmienia kolejności rekordów w źródłowej bazie danych, lecz tylko w zestawie wyników. Aby uzyskać więcej informacji, kliknij przycisk Obrazek przycisku .


Nie mogę utworzyć potrzebnych sprzężeń

W wypadku sprzężenia zewnętrznego sprawdź, czy kwerenda ma nie więcej niż dwie tabele Jeśli kwerenda ma więcej niż dwie tabele, nie można w niej utworzyć sprzężenia zewnętrznego. Do tworzenia sprzężeń zewnętrznych służą opcje 2 i 3 w oknie dialogowym Sprzężenia.

Kwerenda może mieć tylko jedno sprzężenie zewnętrzne Można utworzyć dowolną liczbę sprzężeń wewnętrznych (opcja 1 w oknie dialogowym Sprzężenia), lecz w każdej kwerendzie można utworzyć tylko jedno sprzężenie zewnętrzne. Osoby znające język programowania SQL mogą modyfikować bezpośrednio instrukcję SQL w oknie dialogowym SQL (menu Widok, polecenie SQL), aby utworzyć kilka sprzężeń zewnętrznych.

Informacje na temat sprzężeń Aby uzyskać informacje na temat zewnętrznych sprzężeń używanych do łączenia rekordów, kliknij przycisk Obrazek przycisku .


Nie mogę zapisać zestawu wyników jako tabeli w bazie danych

Program Microsoft Query 2000 i jego nowsze wersje nie pozwalają zapisać zestawu wyników jako tabeli bazy danych.

Zaimportuj dane do bazy danych z programu Microsoft Excel Jeśli do bazy danych można importować dane programu Microsoft Excel, zestaw wyników można zwrócić do programu Microsoft Excel, a następnie używać poleceń dostępnych w tej bazie danych, aby importować dane programu Microsoft Excel jako tabelę. Na przykład program Microsoft Access zawiera Kreatora importu arkuszy kalkulacyjnych, który pozwala tworzyć tabele z danych programu Microsoft Excel. Więcej informacji można znaleźć w dokumentacji lub w Pomocy bazy danych.

Zaimportuj plik tekstowy do bazy danych Jeśli do bazy danych można importować pliki tekstowe, zestaw wyników można zwrócić do programu Microsoft Excel, zapisać go jako plik tekstowy, a następnie używać poleceń dostępnych w tej bazie danych, aby importować plik tekstowy jako tabelę. Informacje na temat konwersji plików tekstowych można znaleźć w Pomocy programu Microsoft Excel.


Nie mogę znaleźć albo usunąć źródła danych

Źródła danych, które zostały utworzone za pomocą starszych wersji programu Microsoft Query Źródła danych, które zostały utworzone za pomocą wersji programu Microsoft Query starszych niż Query 97, mają umieszczoną gwiazdkę obok nazwy źródła. Wszystkie źródła danych, w tym nowe utworzone za pomocą programu Query 2000 i nowszych wersji, są przechowywane jako pliki o rozszerzeniu nazwy dsn. Aby wyświetlić listę źródeł danych utworzonych we wcześniejszych wersjach programu Query, kliknij przycisk Opcje w oknie dialogowym Wybierz źródło danych (menu Plik, polecenie Nowy), a następnie zaznacz pole wyboru Uwzględnij pliki DSN Rejestru na liście dostępnych baz danych. Jeśli te źródła danych są przechowywane w lokalizacji domyślnej, można je zaznaczyć w oknie dialogowym Wybieranie źródła danych, a następnie kliknąć przycisk Usuń.

Lokalizacje plików źródeł danych Pliki źródeł danych pochodzące z wcześniejszych wersji programu Microsoft Query są zwykle przechowywane w folderze ODBC Datasources w folderze Common Files. Pliki źródeł danych programu Query 2000 i jego nowszych wersji są przechowywane w folderze profilu użytkownika folderu Application Data\Microsoft\Queries. Aby zobaczyć, które foldery są używane do przechowywania plików źródeł danych, kliknij przycisk Nowa kwerenda Obrazek przycisku, kliknij kartę Bazy danych, a następnie kliknij przycisk Opcje.

Znajdowanie i usuwanie pliku źródła danych Możesz znaleźć i usunąć pliki źródeł danych w następujący sposób:

  • Skorzystaj z Panelu sterowania systemu Windows Jeśli wszystkie pliki źródeł danych znajdują się w folderze Common Files\ODBC Datasources lub w folderze profilu użytkownika, kliknij dwukrotnie ikonę Źródła danych ODBC (32-bitowe) w Panelu sterowania. W systemach Microsoft Windows 2000 kliknij dwukrotnie ikonę Narzędzia administracyjne, a następnie kliknij dwukrotnie ikonę Źródła danych (ODBC). Kliknij kartę Plik DSN, a następnie kliknij przycisk Usuń, aby usunąć wszelkie zbędne pliki dsn.
  • Wyszukaj pliki dsn Jeśli pliki źródeł danych znajdują się w kilku folderach w systemie Windows, do wyszukania wszystkich plików z rozszerzeniem dsn użyj polecenia Znajdź, a następnie usuń wszelkie zbędne pliki.


Nie mogę edytować kwerendy

Sprawdź, czy edycja jest włączona W menu Edycja kliknij polecenie Opcje, a następnie wyczyść pole wyboru Wyłącz możliwość edycji wyników kwerendy.


Nie mogę odnaleźć żądanej tabeli

Jeżeli lista tabel nie zawiera oczekiwanych tabel, sprawdź następujące możliwości (w zależności od opcji dostępnych dla źródła danych):

  • Sprawdź właściciela Tabele mogą należeć do innego właściciela. Wybierz innego właściciela w polu Właściciel w oknie dialogowym Dodaj tabele. Może być konieczne uzyskanie odpowiedniego uprawnienia od właściciela tabel.
  • Sprawdź wyświetlane typy tabel Tabele mogą być typów, które nie zostały wybrane do wyświetlania. W oknie dialogowym Dodaj tabele kliknij przycisk Opcje. Upewnij się, czy w obszarze Pokaż są zaznaczone wszystkie typy tabel.
  • Odśwież listę tabel Tabele mogły być dodane do bazy danych po ostatnim połączeniu programu Microsoft Query z tą bazą. Aby wyświetlić ostatnio dodane tabele, kliknij przycisk Opcje w oknie dialogowym Dodaj tabele, a następnie kliknij przycisk Odśwież.


Nie mogę utworzyć nowego źródła danych

Sprawdź sterownik Po pierwsze należy sprawdzić, czy jest zainstalowany sterownik ODBC lub sterownik źródła danych odpowiedni dla źródła danych. Sterowniki ODBC i sterowniki źródeł danych dają programowi Microsoft Query dużą elastyczność umożliwiając, po zainstalowaniu odpowiednich sterowników, korzystanie z nowych typów baz danych. Jednakże należy upewnić się, czy dla danego typu bazy danych zainstalowano i odpowiednio skonfigurowano właściwy sterownik.

Sprawdź, czy sterownik współpracuje z programem Microsoft Query Oprócz sterowników dostarczanych z programem Microsoft Query można używać sterowników ODBC i sterowników źródeł danych innych producentów. Przed próbą zastosowania sterownika innego producenta dobrze jest sprawdzić, czy sterownik był testowany z używaną wersją programu Microsoft Query. W przypadku niektórych baz danych sterownik dostarczany z programem bazy danych może być najlepszym wyborem. Skontaktuj się z administratorem bazy danych, aby się dowiedzieć, jakie sterowniki są dostępne i które z nich będą najlepiej pracować w konkretnym zastosowaniu. Zobacz listę sterowników dostarczanych wraz z programem Query

Sprawdź adres serwera i dane logowania Przed zainstalowaniem źródła danych sprawdź, czy jest znany adres lokalizacji bazy danych w sieci i czy masz uprawnienia niezbędne do połączenia się z bazą danych i zalogowania się do niej. Skontaktuj się z administratorem bazy danych, aby otrzymać nazwę użytkownika, hasło lub inne niezbędne uprawnienia i sprawdź, czy przyznany dostęp funkcjonuje poprawnie.

Sprawdź, czy sterownik jest poprawnie zainstalowany Aby wyświetlić listę dostępnych sterowników ODBC, kliknij ikonę Nowa kwerenda Obrazek przycisku, kliknij dwukrotnie opcję Nowe źródło danych na karcie Bazy danych lub Moduły OLAP, wpisz nazwę w kroku 1 okna dialogowego Tworzenie nowego źródła danych, a następnie kliknij listę w kroku 2. Jeśli karta Moduły OLAP jest niedostępna, uruchom program Microsoft Query z programu Microsoft Excel, wskazując polecenie Pobierz dane zewnętrzne w menu Dane programu Excel, a następnie klikając polecenie Nowa kwerenda bazy danych. Kliknij dwukrotnie opcję Nowe źródło danych na karcie Moduły OLAP, wpisz nazwę w kroku 1 okna dialogowego Tworzenie nowego źródła danych, a następnie kliknij listę w kroku 2. Jeśli potrzebny sterownik nie zostanie wyświetlony, należy sprawdzić, czy sterownik został poprawnie zainstalowany. Jak instalować sterowniki

Sprawdź, czy zostały podane wszystkie informacje konfiguracyjne Po zainstalowaniu sterownika i wybraniu go w kroku 2 w oknie dialogowym Utwórz nowe źródło danych sprawdź, czy zostały podane wszystkie niezbędne informacje w kroku 3 okna dialogowego. Aby uzyskać informacje na temat sterownika firmy Microsoft, kliknij polecenie Połącz, a następnie kliknij polecenie Pomoc w oknie dialogowym instalacji sterownika. W wypadku sterowników innych producentów należy się zapoznać z systemem Pomocy lub z dokumentacją sterownika.

Jeśli konfiguruje się źródło danych przy użyciu sterownika ODBC lub sterownika źródła danych firmy Microsoft, należy kliknąć nazwę sterownika, aby uzyskać informacje na temat ustawień koniecznych w kroku 3 w oknie dialogowym Utwórz nowe źródło danych.

Uwaga Program Microsoft Query nie może korzystać ze źródeł danych, utworzonych za pomocą Kreatora łączenia danych.

Sterowniki ODBC

Sterownik programu Microsoft Access

Sterownik programu Microsoft dBASE

Sterownik programu Microsoft Visual FoxPro

Sterownik programu Microsoft Excel

Sterownik ODBC firmy Microsoft dla bazy danych Oracle

Sterownik programu Microsoft Paradox

Sterownik tekstowy firmy Microsoft

Sterownik programu Microsoft SQL Server

Sterownik źródła danych

Sterownik programu Microsoft SQL Server OLAP Services


Sprzężenia nie wybierają oczekiwanych rekordów

Program Query używa domyślnie sprzężeń wewnętrznych Domyślnym sprzężeniem, którego używa program Microsoft Query, kiedy automatycznie sprzęga tabele, jest sprzężenie wewnętrzne (opcja 1 w oknie dialogowym Sprzężenia). Jeżeli dwie tabele są połączone sprzężeniem wewnętrznym, to do zestawu wyników nie są włączane rekordy z drugiej tabeli, które nie mają swoich odpowiedników w pierwszej tabeli.

Utwórz sprzężenie zewnętrzne Aby pobrać wszystkie rekordy z obu tabel, kiedy jedna tabela zawiera rekordy nieobecne w drugiej tabeli, można użyć sprzężenia zewnętrznego (opcje 2 i 3 w oknie dialogowym Sprzężenia). Aby uzyskać informacje na temat łączenia rekordów za pomocą sprzężeń zewnętrznych, kliknij przycisk Obrazek przycisku .

Sprawdź sprzężenia wielokrotne między tymi samymi tabelami Niekiedy sprzężenie zewnętrzne między dwiema tabelami nie zwraca żadnych rekordów z drugiej tabeli. Jeżeli wtedy zostanie dodane sprzężenie wewnętrzne między tymi tabelami, to program Microsoft Query nie wybierze żadnych rekordów z żadnej tabeli. Aby wyświetlić rekordy, należy usunąć jedno ze sprzężeń.

Informacje o sprzężeniach Aby uzyskać więcej informacji na temat sprzężeń, kliknij przycisk Obrazek przycisku .


Program Microsoft Query nie zwraca wszystkich dostępnych rekordów

Sprawdź, czy nie została ograniczona liczba zwracanych rekordów Sprawdź, czy liczba rekordów, które mają być zwrócone, nie została ograniczona. Kliknij polecenie Opcje w menu Edycja, a następnie upewnij się, że jest usunięte zaznaczenie z pola wyboru Ogranicz liczbę zwracanych rekordów do w grupie Ustawienia użytkownika.

Sprawdź kryteria Sprawdź, czy wszystkie kryteria zostały poprawnie wprowadzone, tak że wybierają właściwe rekordy. Aby uzyskać więcej informacji na temat określania kryteriów, kliknij przycisk Obrazek przycisku .

Sprawdź sprzężenia Sprawdź, czy wszelkie utworzone sprzężenia przynoszą zamierzony skutek. Aby uzyskać więcej informacji na temat sprzężeń, kliknij przycisk [image] .


Program Microsoft Query wielokrotnie zgłasza błąd przekroczenia czasu, a połączenie z bazą danych nie następuje

Ustaw dłuższy czas połączenia Program Microsoft Query domyślnie próbuje połączyć się z bazą danych w czasie ustalonym przez sterownik ODBC źródła danych. Jeśli połączenie z bazą danych często wymaga więcej czasu, można wydłużyć ten limit. W menu Edycja programu Microsoft Query kliknij polecenie Opcje, upewnij się, że jest zaznaczone pole wyboru Anuluj połączenie, jeśli brak połączenia przez, a następnie wpisz liczbę sekund wystarczającą do nawiązania połączenia.

Ustaw program Query tak, aby łączył się w dowolnie długim czasie Chcąc, aby program Microsoft Query próbował się łączyć przez nieokreśloną ilość czasu, wyczyść pole wyboru Anuluj połączenie, jeśli brak połączenia przez. Jeśli nawiązanie połączenia z bazą danych w programie Microsoft Query okaże się niemożliwe, to możesz anulować próbę, naciskając klawisz ESC.


Nie mogę uzyskać dostępu do danych z listy programu Microsoft Excel

Zamknij skoroszyt Przed próbą dostępu do danych upewnij się, że skoroszyt nie jest otwarty w programie Microsoft Excel.

Sprawdź arkusz roboczy Sprawdź w arkuszu roboczym programu Microsoft Excel następujące możliwości:

  • Sprawdź format listy Sprawdź, czy lista jest zapisana w formacie listy programu Microsoft Excel. (Aby uzyskać informacje o tworzeniu list w arkuszu kalkulacyjnym, zobacz Pomoc programu Microsoft Excel.) Nadaj nazwy zakresom, które są tabelami i upewnij się, że każdemu zakresowi została nadana inna nazwa.
  • Nazwij listę Program Microsoft Query rozpoznaje jako tabele tylko nazwane zakresy. Aby nazwać listę, zaznacz całą listę w programie Microsoft Excel, a następnie wpisz nazwę w polu Nazwa na pasku formuły.
  • Nie używaj listy jako tabeli systemowej Nie próbuj uzyskać dostępu do tabel programu Microsoft Excel, klikając opcję Tabele systemowe w obszarze Pokaż okna dialogowego Opcje tabel. Jeżeli użyjesz tej metody, to program Microsoft Query może rozpoznawać puste komórki arkuszy roboczych jako dane, może w ogóle nie rozpoznawać części danych lub nieprawidłowo je wybierać.
  • Sformatuj listy tak, aby kojarzyły dane w ten sam sposób Na każdej liście, z której chcesz korzystać, zastosuj ten sam format kolumn. Na przykład jeżeli każda lista zawiera kolumnę z datą, to w każdej kolumnie należy użyć tego samego formatu daty. Jeżeli w jednej kolumnie jest wymieszany tekst i liczby, to sterownik Microsoft Excel może nie być w stanie znaleźć i skojarzyć wszystkich danych.
  • Nie używaj etykiet kolumn o nazwach takich jak Table lub Database. Program Microsoft Query używa takich etykiet do własnych celów i nie rozpoznaje ich wśród danych.
  • Przenieś wszystkie skoroszyty do tego samego folderu Źródło danych skonfigurowane dla sterownika Microsoft Excel może zapewnić dostęp do skoroszytów tylko w jednym folderze naraz. Jeżeli listy znajdują się w dwóch różnych skoroszytach, to sprawdź, czy obydwa skoroszyty znajdują się w tym samym folderze, wskazanym podczas konfigurowania źródła danych.
  • Przenieś skoroszyty do folderu oczekiwanego przez źródło danych Przed uruchomieniem programu Microsoft Query sprawdź, czy wszystkie skoroszyty przewidziane do użycia zostały skopiowane do folderu określonego w źródle danych. Program Microsoft Query nie rozpoznaje automatycznie nowych skoroszytów dodanych do tego folderu w czasie tworzenia kwerendy. Aby uzyskać dostęp do nowych skoroszytów, kliknij przycisk Opcje w oknie dialogowym Dodaj tabele, a następnie kliknij przycisk Odśwież.

Użyj programu Excel do łączenia danych Program Microsoft Query jest przydatny do kojarzenia danych z dwóch lub kilku list programu Microsoft Excel. Jeżeli pracujesz z danymi z pojedynczego arkusza lub chcesz użyć prostych kryteriów, aby wybrać wiersze w takim arkuszu, to łatwiejsze może być użycie poleceń Autofiltr oraz Filtr zaawansowany programu Microsoft Excel (menu Dane, podmenu Filtr). Aby uzyskać więcej informacji na temat Autofiltrów i filtrów zaawansowanych, skorzystaj z Pomocy programu Microsoft Excel.


Nie mogę edytować typów parametrów w procedurze języka SQL w programie Microsoft Query

Aby utworzyć parametry w procedurze języka SQL i ustalić typy danych dla parametrów, należy wykonać następujące czynności:

  1. W menu Plik kliknij polecenie Wykonaj instrukcję SQL.
  2. W polu Instrukcja SQL utwórz nową kwerendę, używając w procedurze ustalonych argumentów, a następnie kliknij przycisk Zapisz.
  3. W menu Widok kliknij polecenie SQL.
  4. W polu Instrukcja SQL zastąp każdy z ustalonych argumentów znakiem zapytania (?).
  5. Kliknij przycisk OK, a następnie w menu Widok kliknij polecenie Parametry.
  6. Aby zmienić typ danych parametru, kliknij ten parametr, a następnie kliknij przycisk Edytuj.


Nie mogę utworzyć etykiet adresowych w programie Microsoft Query

Program Query pobiera dane do etykiet Program Microsoft Query jest narzędziem, które pobiera dane z bazy danych. Nie można w nim bezpośrednio tworzyć etykiet adresowych. Jednak danych wybranych przez program Query można użyć do tworzenia etykiet adresowych w programach Microsoft Excel lub Microsoft Word.

Tworzenie etykiet w programie Word Najpierw należy zwrócić dane do programu Excel, klikając polecenie Zwróć dane do programu Microsoft Excel w menu Plik. Po umieszczeniu zestawu wyników w programie Excel można go użyć jako listy adresowej w programie Word. Można także rozpocząć tworzenie etykiet w programie Word, a następnie zwrócić dane z programu Query bezpośrednio do programu Word. Więcej informacji na temat etykiet adresowych można znaleźć w Pomocy programu Excel lub Word.


Nie mogę wydrukować zestawu wyników w programie Microsoft Query

W programie Query nie można drukować Program Microsoft Query jest narzędziem, które pobiera dane z bazy danych. Nie można w nim bezpośrednio tworzyć drukowanych raportów.

Drukowanie rekordów z programu Excel Aby wydrukować zestaw wyników, należy go zwrócić do programu Microsoft Excel, klikając polecenie Zwróć dane do programu Microsoft Excel w menu Plik. Gdy zestaw wyników znajduje się już w programie Microsoft Excel, można używać wszystkich poleceń formatowania i drukowania programu Microsoft Excel do ustawiania i drukowania danych. Więcej informacji o drukowaniu w programie Microsoft Excel można znaleźć w Pomocy programu Microsoft Excel.


Program Microsoft Query nie przerywa połączenia, mimo że baza danych nie jest używana

Połączenia pozostają otwarte w czasie całej sesji programu Query Program Microsoft Query tworzy domyślnie jedno połączenie z bazą danych i utrzymuje je w stanie otwartym aż do zakończenia działania tego programu, bez względu na liczbę okien kwerend otwartych w tym czasie. Jeżeli w czasie sesji z programem Microsoft Query otwieranych jest wiele połączeń z bazami danych, wiąże się to ze zwiększonym zaangażowaniem zasobów i cennego czasu połączeń.

Zamknij połączenia, zamykając okna kwerend Chcąc zminimalizować czas połączenia, można ustawić program Microsoft Query w taki sposób, aby zamykał połączenie z chwilą zamknięcia okna kwerendy bazy danych. Aby połączenie było otwarte tylko wtedy, kiedy otwarte jest okno kwerendy, należy kliknąć polecenie Opcje w menu Edycja, a następnie wyczyścić pole wyboru Zachowuj połączenia otwarte aż do zamknięcia MS Query.


Dlaczego obok nazwy źródła danych jest umieszczona gwiazdka?

Źródło danych pochodzi ze starszej wersji programu Microsoft Query Źródła danych pochodzące z programu Query 97 i jego nowszych wersji mają inny format niż źródła danych utworzone za pomocą starszych wersji programu Query. Źródła danych i kwerendy utworzone za pomocą wersji programu Query wcześniejszych niż Query 97 mogą być nadal używane w nowszych wersjach tego programu, ale kwerendy tworzone z użyciem tych źródeł danych nie mogą być udostępniane innym użytkownikom. Wersje wcześniejsze niż Query 97 przechowują informacje o źródłach danych jako część systemu operacyjnego Microsoft Windows i informacje te są dostępne jedynie w systemie lokalnym.

Zidentyfikuj źródła danych niemożliwe do udostępniania Aby używać źródeł danych utworzonych za pomocą wcześniejszych wersji programu Query, kliknij przycisk Opcje w oknie dialogowym Wybierz źródło danych (menu Plik, polecenie Nowa), a następnie zaznacz pole wyboru Uwzględnij pliki DSN Rejestru na liście dostępnych baz danych. Wszystkie źródła danych utworzone za pomocą wersji programu wcześniejszej niż Query 97 pojawią się w oknie dialogowym Wybierz źródło danych z gwiazdkami umieszczonymi obok nazw.

Utwórz udostępniane źródła danych Chcąc udostępniać kwerendy lub szablony raportów wykorzystujące dane z zewnętrznych baz danych określonych w źródłach danych, których nie można udostępniać, utwórz nowe źródła danych dla tych baz danych i używaj nowych źródeł danych do tworzenia kwerend, plików kwerend i szablonów raportów.

Usuń stare źródła danych Jak usunąć nieudostępniane źródła danych


Nie mogę zmienić modułu OLAP

Sprawdź, czy pierwotna baza danych jest dostępna Aby wprowadzić zmiany w module OLAP, trzeba mieć dostęp do pierwotnej bazy danych na serwerze, która dostarcza danych dla modułu. Sprawdź położenie tej bazy danych, aby upewnić się, że nie zmieniono jej nazwy, ani jej nie przeniesiono. Sprawdź, czy serwer jest dostępny i czy można się z nim połączyć.

Sprawdź, czy w pierwotnej bazie danych nie wprowadzono zmian Tabele w bazie danych mogły ulec zmianie lub usunięciu albo mogły się zmienić ich nazwy, dlatego moduł nie może już odszukać pierwotnych danych. Sprawdź, czy nie nastąpiły zmiany w organizacji lub schemacie bazy danych. W tym celu można otworzyć kwerendę bazy danych, jeśli kwerenda została zapisana przy pierwszym tworzeniu modułu, lub też można utworzyć nową kwerendę. W menu Tabela kliknij polecenie Dodaj tabele, aby zobaczyć dostępne tabele. Jeśli nie można otworzyć istniejącej kwerendy lub utworzyć nowej, skontaktuj się z administratorem bazy danych, aby uzyskać informacje, jakim zmianom uległa baza danych.


Pojawia się komunikat, że Kreator modułów OLAP nie może otworzyć pliku oqy

Sprawdź, czy plik został pierwotnie utworzony za pomocą kreatora Pliki oqy można otwierać i modyfikować tylko pod warunkiem, że zostały utworzone i zapisane za pomocą Kreatora modułów OLAP. Kreatora nie można używać do otwierania i modyfikowania innych plików oqy, które nie zawierają definicji modułu, na przykład takich, które definiują tylko połączenie z bazę danych serwera OLAP lub pliki modułów offline.

Utwórz ponownie plik oqy Jeśli nie można otworzyć pliku oqy, który został utworzony za pomocą Kreatora modułów OLAP, może to oznaczać, że plik został uszkodzony. Spróbuj otworzyć kopię zapasową pliku lub, jeśli jej brak, utwórz moduł ponownie.


Tworzenie lub usuwanie tabel jest niemożliwe, ponieważ baza danych jest tylko do odczytu. Kontynuować?

W bazie danych tylko do odczytu można wyświetlać definicje tabel, ale nie można tworzyć nowych tabel lub usuwać istniejących.


Nie można wyszukać rekordu. Aby go zlokalizować, potrzeba więcej kolumn lub inny użytkownik zmienił ten rekord

Program Microsoft Query nie może znaleźć rekordu w tabeli podstawowej odpowiadającej rekordowi, który został zaktualizowany lub usunięty. Kwerenda może mieć za małą liczbę kolumn do rozróżnienia rekordu, który ma być zaktualizowany, albo inny użytkownik zmienił rekord od czasu ostatniego uruchomienia kwerendy. Przed zaktualizowaniem rekordu należy wykonać jedną z następujących czynności:

  • Dodać do kwerendy więcej kolumn lub dodać kolumnę, która jednoznacznie identyfikuje rekord.
  • Aby w tabeli podstawowej wyszukać aktualne dane, należy uruchomić ponownie kwerendę, klikając polecenie Wykonaj kwerendę w menu Rekordy.


Otwarte są zdalne łącza, zamknąć mimo to?

Dane w kwerendzie są połączone z innym programem, takim jak Microsoft Excel lub Microsoft Word.

  • Aby zamknąć kwerendę i łącze, kliknij przycisk OK. Po zamknięciu kwerendy nie można odtworzyć łącza.
  • Aby pozostawić otwartą kwerendę i łącze, kliknij przycisk Anuluj.


Czy zapisać dużą ilość danych w Schowku z <nazwa>?

W Schowku umieszczono dużą ilość danych.

  • Aby zapisać dane znajdujące się w Schowku, zamknąć kwerendę i zakończyć działanie programu Microsoft Query, kliknij przycisk Tak.
  • Aby usunąć dane ze Schowka, zamknąć kwerendę lub zakończyć działanie programu Microsoft Query, kliknij przycisk Nie.
  • Aby pozostawić dane znajdujące się w Schowku i kontynuować działanie programu Microsoft Query, kliknij przycisk Anuluj.


Dlaczego nie mogę kontynuować pracy w programie Microsoft Query?

Część treści tego tematu może nie mieć zastosowania w przypadku niektórych języków.

Po wyświetleniu niektórych komunikatów (z Asystentem pakietu Office lub bez niego) nie można kontynuować pracy w programie Microsoft Query aż do chwili zamknięcia okna komunikatu. Są to ważne komunikaty wymagające odpowiedzi.

Aby kontynuować pracę w programie Microsoft Query, należy kliknąć wybrany przycisk w oknie komunikatu. Jeżeli program Microsoft Query przestanie wyświetlać komunikat, a zamiast niego wyświetli temat Pomocy, należy kliknąć w dowolnym miejscu okna programu Microsoft Query, aby ponownie wyświetlić komunikat.


Czy zapisać zmiany w kwerendzie <nazwa>?

Od czasu ostatniego zapisu wprowadzono zmiany w projekcie lub w formacie bieżącej kwerendy.

  • Aby zapisać zmiany przed zamknięciem kwerendy, kliknij przycisk Tak.
  • Aby zignorować zmiany i zamknąć kwerendę, kliknij przycisk Nie.
  • Aby pozostawić kwerendę otwartą, nie zapisując zmian, kliknij przycisk Anuluj.


Instrukcja SQL wykonana pomyślnie. Zaktualizowano wierszy: <liczba>.

Program Microsoft Query uruchomił określoną instrukcję SQL, zmieniając pewną liczbę wierszy (rekordów).


Nieudane wykonanie instrukcji SQL

Program Microsoft Query nie może uruchomić instrukcji SQL. Sprawdź, czy instrukcja została prawidłowo wpisana.


Tabela <nazwa> już istnieje; czy ją zastąpić?

Tabela o tej nazwie już istnieje.

  • Aby zastąpić poprzednią tabelę utworzoną tabelą, kliknij przycisk Tak.
  • Aby nie zastępować poprzedniej tabeli, kliknij przycisk Nie, a następnie podaj inną nazwę dla nowej tabeli.


Zapisywanie pliku jako <nazwa>

Podjęto próbę zapisu zestawu wyników jako tabeli z nazwą pliku, której rozszerzenie jest nieprawidłowe lub go brakuje.

  • Aby zapisać zestaw wyników jako plik z prawidłowym rozszerzeniem dla tego źródła danych, kliknij przycisk OK.
  • Aby powrócić do programu Microsoft Query, nie zapisując zestawu wyników, kliknij przycisk Anuluj.


Wywołana aplikacja została zakończona

Drugi program uczestniczący w dynamicznej wymianie danych (DDE) został nieoczekiwanie zakończony i komunikacja została przerwana. Przed ponownym nawiązaniem komunikacji DDE uruchom ten program.


Kwerenda SQL nie może być przedstawiona graficznie. Kontynuować pomimo to?

Program Microsoft Query nie może wyświetlić okienka Tabela dla tej kwerendy. Jeśli kwerenda zwraca rekordy, w oknie programu Query nie można edytować tych rekordów ani projektu kwerendy. Jednak można edytować projekt kwerendy, klikając polecenie SQL w menu Widok, a następnie bezpośrednio edytując instrukcję SQL.


Przekroczenie czasu oczekiwania na odpowiedź DDE

Drugi program uczestniczący w komunikacji dynamicznej wymiany danych (DDE) nie odpowiedział w czasie ustalonym w polu Czas oczekiwania DDE.

  • Możliwe, że aplikacja wywołana oczekuje na odpowiedź użytkownika. Przełącz się do tego programu i zamknij okno dialogowe lub odpowiedz na zapytanie.
  • Aplikacja wywoływana może być zbyt zajęta, aby odpowiadać na komunikaty dynamicznej wymiany danych.

Uwaga Nie można zmienić czasu podanego w polu opcji Czas oczekiwania DDE.


Nieoczekiwane wyrażenie <tekst> po liście kolumn w klauzuli GROUP BY

Nieprawidłowe wyrażenie lub klauzula po liście kolumn w klauzuli GROUP BY.


Nieoczekiwane wyrażenie <tekst> po klauzuli HAVING

Nieprawidłowe wyrażenie lub klauzula po klauzuli HAVING w instrukcji SQL.


Nieoczekiwane wyrażenie <tekst> po liście kolumn w klauzuli ORDER BY

Nieprawidłowe wyrażenie lub klauzula po klauzuli ORDER BY w instrukcji SQL.


Nieoczekiwane wyrażenie <tekst> po liście w instrukcji SELECT

Nieprawidłowe wyrażenie lub klauzula po liście w instrukcji SELECT.


Nieoczekiwane wyrażenie <tekst> po klauzuli WHERE

Nieprawidłowe wyrażenie lub klauzula po klauzuli WHERE w instrukcji SQL.


Wybrano zbyt wiele wartości

Za mało pamięci do przechowywania wszystkich wartości podanych jako kryteria dla tego pola. Podaj mniejszą liczbę wartości.


Nierozpoznana jednostka miary

Program Microsoft Query nie rozpoznaje znaków wpisanych jako ustawienie tej opcji. Należy wprowadzić wartość miary, lecz nie dodawać znaków rodzaju jednostki, takich jak " (podwójny cudzysłów), "cale" lub "cm" (centymetry).


Aktualizacja nie powiodła się. Kontynuować edycję rekordu?

Program Microsoft Query nie może zaktualizować edytowanych danych, ponieważ tabela podstawowa lub źródło danych są tylko do odczytu, tabela jest uszkodzona lub brak wystarczającej ilości miejsca na dysku do przechowywania wprowadzonych zmian.


Wartość <wartość> ma zbyt wiele cyfr po przecinku

W polu wprowadzono zbyt wiele miejsc dziesiętnych. Podaj mniej miejsc dziesiętnych.


Wartość <wartość> nie jest wartością logiczną

W polu, w którym można wprowadzać tylko wartości logiczne, wprowadzono wartość innego typu. Na przykład wprowadzono datę w polu, które przyjmuje tylko wartości 0 i 1.


Wartość <wartość> nie jest prawidłową datą

W polu wprowadzono niewłaściwy typ danych. Na przykład wprowadzono tekst w polu, w którym można wprowadzać wyłącznie daty.


Wartość <wartość> nie jest prawidłową liczbą

W polu wprowadzono niewłaściwy typ danych. Na przykład wprowadzono tekst w polu, w którym można wprowadzać wyłącznie liczby.


Wartość <wartość> przekracza zakres numeryczny dla tej kolumny

Wartość przekracza maksymalną liczbę dopuszczalną w tej kolumnie (polu). Wprowadź mniejszą wartość.


Istniejące tabele nie mogą być zmieniane. Zmiany mogą być użyte do utworzenia nowej pustej tabeli

Aby utworzyć nową tabelę z istniejącej tabeli, należy zmienić nazwę tabeli w oknie dialogowym Wyświetlanie definicji tabeli. Nowa tabela nie zawiera danych, które znajdowały się w istniejącej tabeli. W programie Microsoft Query nie można edytować istniejących definicji tabel.


Niepoprawne rozszerzenie <rozszerzenie>

Podana nazwa tabeli zawiera nieprawidłowe rozszerzenie nazwy pliku. Sprawdź w dokumentacji źródła danych, jakie jest poprawne rozszerzenie.


Wyrażenie jest zbyt złożone

Nie można obliczyć wyrażenia, ponieważ jest zbyt złożone. Spróbuj uprościć wyrażenie.


Błąd składni

W wyrażeniu wystąpił błąd składni. Na przykład pominięto operand lub operator, wprowadzono nieprawidłowy znak lub przecinek lub wprowadzono tekst bez cudzysłowu ( " lub " ). Sprawdź poprawność wpisanego wyrażenia.


Błąd składni w dacie

Wyrażenie zawiera nieprawidłową wartość daty. Sprawdź poprawność wpisanego wyrażenia.


Nieprawidłowe użycie ".", "!" lub "( )"

W wyrażeniu zastosowano nieprawidłowy operator . (kropka) lub ! albo nieprawidłowe nawiasy okrągłe. Na przykład mógł być wpisany nieprawidłowy identyfikator lub nawias po stałej wartości Null. Sprawdź poprawność wpisanego wyrażenia.


Błąd składni w liczbie

Wyrażenie zawiera nieprawidłową wartość liczby. Sprawdź poprawność wpisanego wyrażenia.


Błąd składni w ciągu

Wyrażenie zawiera nieprawidłowy ciąg. Na przykład została przekroczona maksymalna długość ciągu. Sprawdź poprawność wpisanego wyrażenia.


Operator POMIĘDZY bez ORAZ

Operator Pomiędzy...Oraz wymaga słowa kluczowego Oraz. Należy stosować następującą składnię:

wyrażenie Pomiędzy wartość1 Oraz wartość2


Zbędny ")"

Wyrażenie zawiera zbyt wiele okrągłych nawiasów zamykających. Usuń nawiasy zamykające, którym nie odpowiadają żadne nawiasy otwierające.


Brak pamięci w trakcie obliczeń

Brak wystarczającej ilości pamięci do wykonania obliczeń.

Zamknij zbędne okna programu Microsoft Query lub zamknij inne programy. Jeżeli błąd się powtarza, to ponów próbę po ponownym uruchomieniu systemu Microsoft Windows.


Brakujący ")", "]" lub "|"

W wyrażeniu brakuje zamykającego nawiasu okrągłego, nawiasu ostrego lub pionowej kreski. Sprawdź poprawność wpisanego wyrażenia.